/////////////
//	CBDraw.cpp		:	v0032
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.0 & DirectX
//	Library			:	DDraw.Lib
//	Copyright (C)	:	1996 WayAhead Corporation
//	v0010			:	Sep.26.1996
//	v0011			:	Nov.16.1996
//	v0020			:	Dec.12.1996, changed the display method to MMX
//	v0021			:	Jan.22.1997, changed drawing border method
//	v0030			:	Mar.7.1997, Great changes since optimze display core functions
//						Optimize display functions again, this time, compressed the file
//						to one third, and the speed is faster 2-3 frames/second.
//						Optimzed the border drawing functions too.
//	v0031			:	Mar.12.1997, add new MMX features in code
//	v0032			:	Mar.29.1997, change drawing method of special items
/////////////
// implementation file
// display core codes
#include "stdafx.h"	// compatible with MFC
#include "Assert.h"
#include "DDCompo.h"	// Direct Draw objects and components

#include <stdio.h>

#include "CBDraw.h"
#include "CBMap.h"	// game map data
#include "CBGame.h"	// game data
#include "puthz.h"	// draw chinese charactor
#include "CBMouse.h"	// mouse hit test
#include "CBEyes.h"	// EYE_ifOutOfRange()
/////////////////////

/////////////////////
// subs
#include "CBShadow.h"
#include "CBMini.h"
#include "CBBuild.h"
#include "CBOther.h"
/////////////////////

//---------------LHJ
#include "interfac.h"
//---------------


//---------------LWC
#ifdef	_MAP_COMPRESS_
#include "L_image.h"
#include "L_Allbmp.h"
// image compression library
class  CPicture_image	DRAW_ImageLib;
#endif
//---------------LWC

//---------------TY
//AIʼ
//#include "Temperor.h"
//---------------TY


/////////////////////
// assembler
extern "C"{
// for debug only, get cycles of CPU spent
// defined in file cycount.asm
void reset_time_event_info(int);
void start_time_event(int,int);
void end_time_event(int);
int  get_time_event_info(int);
}
/////////////////////

/////////////////////
// globals, defines, macros
/////////////////////
extern char	strCopyright[65];
class	CDDText tCopyright;
class	CDDText	tGold, tFood, tWood, tIron;
void UpdateGFWI();	// ʾǮľ
BOOL GFWI_bUpdate= TRUE;	// ǷʾǮľ;

void	DrawHZ( class CDDSurface * pSurface );
/////////////////////
// user defined surfaces
BOOL	DRAW_bLoadMaps = FALSE;
/////////////////////

/////////////////////
extern CDDCursor MAIN_Cursors[4];	// defined in CBMain.cpp
/////////////////////

/////////////////////
// ground maps
class	CDDSurface	DRAW_sGroundMap[MAP_GROUND_LIB_NUM];
/////////////////////

/////////////////////
// other maps
class	CDDSurface	DRAW_sOtherMap[MAP_OTHER_NUM];
/////////////////////

/////////////////////
// declared in CBMap.cpp
extern int MAP_nLocationNum[5];
extern POINT MAP_ptLocation[2][MAP_LOCATION_MAX];
POINT ptCovering[2][11]={
	{{-2,0},{-1,0},{0,0},{1,0},{2,0},
	{-3,1},{-2,1},{-1,1},{0,1},{1,1},{2,1},},
	{{-2,0},{-1,0},{0,0},{1,0},{2,0},
	{-2,1},{-1,1},{0,1},{1,1},{2,1},{3,1},},
};
/////////////////////

/////////////////////
// to move screen
BOOL DRAW_bMoveScreenEx = FALSE;
// client size in grid
// how much girds the client can fit
//RECT DRAW_rcScreen={0,0,11,50};
// սʾСսλãӣ
RECT DRAW_rcScreen={0,0,14,51};
// սʾϽս꣨㣩
POINT DRAW_ptScreenOffset;

// client size in pixel
RECT DRAW_rcClient={24,48,483,456};
// ˶ķΧУ
RECT DRAW_rcMove={0,0,0,0};

// moving directions
int DD[8][2]={{-1,-2},{0,-2},{1,-2},{1,0},
	{1,2},{0,2},{-1,2},{-1,0}};

// λõĻ»һ
// draw moving screen, it should be much faster than DRAW_UpdateScreen()
// ptOff	:	λλõƫ
void DRAW_DrawMoveScreen( POINT ptOff );
/////////////////////

/////////////////////
// bkground surface 
// ñͼص棬սһ
class CDDSurface DRAW_sBkGround;
// Ϸ浽α
// prcCut	:	õķΧΪNULL򿽱ս
void DRAW_DrawBack2BkGround( CONST RECT *prcCut = NULL );
// α浽Ϸ
// prcCut	:	õķΧΪNULL򿽱ս
void DRAW_DrawBkGround2Back( CONST RECT *prcCut = NULL );
/////////////////////

/////////////////////
// MMX temp surface
// ʱŵԪͼ棬ڵĵԪĴС
#define	DRAW_MMX_WIDTH	144
#define	DRAW_MMX_HEIGHT	120
class CDDSurface DRAW_sMMX;
extern BOOL MAIN_bMMX;	// ʹMMXĿ
/////////////////////

/////////////////////
// cover method
// ļжȡԪڵݴ浽
struct DRAW_COVER_STRUCT DRAW_CoverLib;
/////////////////////
// for hit test only
//7       8 
// 5     6
//  3   4
//   1 2
//    0

// ܹĳе
// һάż
POINT DRAW_ptCovering[2][9]=
{	{{0,2},{-1,1},{0,1},
	{-1,0},{1,0},{-2,-1},
	{1,-1},{-2,-2},{2,-2}},
	{{0,2},{0,1},{1,1},
	{-1,0},{1,0},{-1,-1},
	{2,-1},{-2,-2},{2,-2}}
};	
/////////////////////

/////////////////////
// ѡΪĿĵصĵԪҪ˸ʾı߽
#define	DRAW_BLINK_DELAY1	10
#define	DRAW_BLINK_DELAY2	20
#define	DRAW_BLINK_COUNT	3

int DRAW_BLINK_nCounter = 0;
int DRAW_BLINK_nDelay = 0;
int DRAW_BLINK_bDraw = TRUE;
WORD DRAW_BLINK_nID = MAP_DATA_NONE;
int DRAW_BLINK_nSave = 0;
/////////////////////

/////////////////////
// local functions
// ʾģ
/////////////////////
// draw one ground item
// ʾһͼ
// prcCut	:	ֻ´˾ڵͼ
// k,i,j	:	ͼصĲţкţк
// bFront	:	ǷֱӸµʾĻ
void DRAW_DrawSingleG( CONST RECT *prcCut, int k, int i, int j, BOOL bFront );

// ʾĳԪڵеΣʵ»þڵĵ
// ӱϿһͼ
// darw other things
// prcCut	:	ֻ´˾ڵͼ
// pstctCF	:	Ԫͼʾ֡ṹ
inline void DRAW_DrawUnitCovered( CONST RECT *prcCut, const struct CTRL_FRAME_STRUCT *pstctCF );

// ʾڵĳԪеԪ
// prcCut	:	ֻ´˾ڵͼ
// pstctCF	:	Ԫͼʾ֡ṹ
inline void DRAW_DrawUnitCovering( CONST RECT *prcCut, const struct CTRL_FRAME_STRUCT *pstctCF );

// ʾĳԪ
// prcCut	:	ֻ´˾ڵͼ
// pstctCF	:	Ԫͼʾ֡ṹ
// BOOL		:	TRUE for has drown
BOOL DRAW_DrawUnitSingle( CONST RECT *prcCut, const struct CTRL_FRAME_STRUCT *pstctCF );

// ʾһԪ˸ΧĵԪĲ
// draw one unit item
// prcCut	:	ֻ´˾ڵͼ
// i,j		:	ͼصкţк
// bFront	:	ǷֱӸµʾĻ
void DRAW_DrawSingleU( CONST RECT *prcCut, int i, int j, BOOL bFront );

// ʾһͼأľ
// draw one special item
// prcCut	:	ֻ´˾ڵͼ
// i,j		:	ͼصкţк
// bFront	:	ǷֱӸµʾĻ
// Attr		:	ͼصԣ0ʱЧ
// k		:	ͼصĲţnAttr0ʱЧ
inline void DRAW_DrawSingleS( CONST RECT *prcCut, int i, int j, BOOL bFront, int nAttr, int k );

// ʾսڵеͼ
// draw ground items
// rcCut	:	ֻ´˾ڵͼ
// k		:	ͼصĲ
// bFront	:	ǷֱӸµʾĻ
void DRAW_DrawGround( RECT rcCut, int k, BOOL bFront );

// ʾսڵеԪͼ
// draw unit itmes
// rcCut	:	ֻ´˾ڵͼ
// bFront	:	ǷֱӸµʾĻ
void DRAW_DrawUnit( RECT rcCut, BOOL bFront );
/////////////////////

/////////////////////
// ĳԪѡʱʾһεĿ
// border
int DRAW_nBdrColors[3] = {188,84,59};
// ʾοϰ벿֣ӦñõԪڵ
// pptDest		:	Ŀĵ꣬Ͻ
// dwWidthDest	:	ĿĵػĿ
// pDest		:	Ŀĵָ
// prcCutGOld	:	õԪľδСλ
// nSize		:	õԪռλõĴСӣ
// nColorIndex	:	Ӧʲôɫ
void DRAW_drawBorderTop( CONST POINT *pptDest, DWORD dwWidthDest, BYTE *pDest, 
						CONST RECT *prcCutGOld, int nSize, int nColorIndex );

// ʾο°벿֣ӦڵõԪ
// pptDest		:	Ŀĵ꣬Ͻ
// dwWidthDest	:	ĿĵػĿ
// pDest		:	Ŀĵָ
// prcCutGOld	:	õԪľδСλ
// nSize		:	õԪռλõĴСӣ
// nColorIndex	:	Ӧʲôɫ
void DRAW_drawBorderBottom( CONST POINT *pptDest, DWORD dwWidthDest, BYTE *pDest, 
						CONST RECT *prcCutGOld, int nSize, int nColorIndex );

// ʾ𣬹ľʯͶʯѪը꣬ѩ
// nType	:	before or after the units have been drawn
// defined in CBDrawOt.cpp
int	DRAW_OTHER_nMouseID=-1;	// declared in CBDraw.cpp
void DRAW_DrawOthersCOM( int nType );
void DRAW_DrawOthersBMP( int nType );
void DRAW_DrawOthersMouse();

// ʾıʾͼ꣨Ѫ㣩
// pUnit	:	ʾĵԪ
// pRect	:	õԪľδС
// prcCut	:	еķΧ
void DRAW_Draw8x8( struct UNIT_STRUCT *pUnit, CONST RECT *pRect, CONST RECT *prcCut );
/////////////////////

/////////////////////
// װսҪλͼͻ
// load user defined surfaces
// TRUE if succeeded
// return	:	TRUE if successful
extern CDDPalette palMain;
BOOL DRAW_LoadMaps()
{
	int i;
	// test if created
	if( DRAW_bLoadMaps )
	{
		ErrorMessage( hwndGame, DRAW_ERROR_ID+0, "Maps have been loaded!" );
		return FALSE;
	}

#ifdef	_DEBUG
				DWORD timeBegin, timeEnd;
				timeBegin = timeGetTime();
				OutputDebugString( "LoadMaps:" );
#endif

	// clear screen
//	DD_EraseFrontScreen();

	// change palette
//	palMain.SetPalette();

// initialize displaying and moving range
	DRAW_ptScreenOffset.x = (DRAW_rcScreen.left+2)*MAP_Lib.szItem.cx;
	DRAW_ptScreenOffset.y = DRAW_rcScreen.top*(MAP_Lib.szItem.cy>>1);
	DRAW_rcMove.left = 2;
	DRAW_rcMove.top = 2;
	DRAW_rcMove.right = MAP_Lib.szNum.cx - 2;
	DRAW_rcMove.bottom = MAP_Lib.szNum.cy - 2;

	// load bkground surface
	// same size as client area
	// no color key , in system memory
	OutputDebugString( "BackGround Load:\n" );
	if( !DRAW_sBkGround.Create( DRAW_rcClient.right-DRAW_rcClient.left, 
						DRAW_rcClient.bottom-DRAW_rcClient.top, FALSE, TRUE ) )
	{
		OutputDebugString( "DRAW_LoadMaps: Cannot create back ground surface in video memory!\n" );
		if( !DRAW_sBkGround.Create( DRAW_rcClient.right-DRAW_rcClient.left, 
						DRAW_rcClient.bottom-DRAW_rcClient.top, FALSE, FALSE ) )
		{
			ErrorMessage( hwndGame, DRAW_ERROR_ID+4, "Cannot create bkground surface!" );
			return FALSE;
		}
	}

//	WriteLogFile( "Dead.log","CCC\n" );
#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin, "\n" );
				timeBegin = timeEnd;
#endif

#define	_ALLBMP_
#ifdef	_ALLBMP_
	CPicture_imageall CPImage;
	char fname[_MAX_FNAME];
//	WriteLogFile( "Dead.log", GAME.strPathBMP );
	strcpy( fname, GAME.strPathBMP );
	strcat( fname, "Other" );
	strcat( fname, ".lwc" );
	CPImage.image_open_compress( fname );
	strcpy( fname, GAME.strPathBMP );
	strcat( fname, "Other" );
	strcat( fname, ".idx" );
	CPImage.image_open_index( fname );
	// Load other surfaces, must before read med file, read shadow file, read build file
	// ȡͼļ
	for( i=0; i< MAP_Lib.nOtherNum; i++ )
	{
		// has color key , in system memory
		if( !CPImage.LoadBitmap( &DRAW_sOtherMap[i], i, TRUE ) )
		{
			ErrorMessage( hwndGame, DRAW_ERROR_ID+5, "Cannot open ground map file:", MAP_Lib.Other[i].strFile );
			return FALSE;
		}
	}
	CPImage.image_close_compress();
	CPImage.image_close_index();
#else
	// Load other surfaces, must before read med file, read shadow file, read build file
	// ȡͼļ
	for( i=0; i< MAP_Lib.nOtherNum; i++ )
	{
		// has color key , in system memory
		if( !DRAW_sOtherMap[i].LoadBitmap( MAP_Lib.Other[i].strFile, TRUE, FALSE ) )
		{
			ErrorMessage( hwndGame, DRAW_ERROR_ID+5, "Cannot open ground map file:", MAP_Lib.Other[i].strFile );
			return FALSE;
		}
	}
#endif
//	WriteLogFile( "Dead.log","AAAAA\n" );

#ifdef	_ALLBMP_
	//CPicture_imageall CPImage;
	//char fname[_MAX_FNAME];
	strcpy( fname, GAME.strPathBMP );
	strcat( fname, "Lib" );
	strcat( fname, ".lwc" );
	CPImage.image_open_compress( fname );
	strcpy( fname, GAME.strPathBMP );
	strcat( fname, "Lib" );
	strcat( fname, ".idx" );
	CPImage.image_open_index( fname );
	// Load other surfaces, must before read med file, read shadow file, read build file
	// ȡͼļ
	for( i=0; i< MAP_Lib.nGLibNum; i++ )
	{
		// has color key , in system memory
		if( !CPImage.LoadBitmap( &DRAW_sGroundMap[i], i, TRUE ) )
		{
			ErrorMessage( hwndGame, DRAW_ERROR_ID+5, "Cannot open ground map file:", MAP_Lib.Other[i].strFile );
			return FALSE;
		}
	}
	CPImage.image_close_compress();
	CPImage.image_close_index();
#else
	// load ground bitmaps
	for( i=0; i < MAP_Lib.nGLibNum; i++ )
	{
		// has color key , in system memory
		if( !DRAW_sGroundMap[i].LoadBitmap( MAP_Lib.Ground[i].strFile, TRUE, FALSE ) )
		{
			ErrorMessage( hwndGame, DRAW_ERROR_ID+8, "Cannot open ground map file:", MAP_Lib.Ground[i].strFile );
			return FALSE;
		}
	}
#endif

//	WriteLogFile( "Dead.log","DDD" );
#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin, "\n" );
				timeBegin = timeEnd;
#endif

	// load image compress library
#ifdef	_MAP_COMPRESS_
	char str[_MAX_FNAME];
	strcpy( str, GAME.strPathBMP );
	strcat( str, "Unit" );
	strcat( str, ".LWC" );
	DRAW_ImageLib.image_open_compress( str );
	strcpy( str, GAME.strPathBMP );
	strcat( str, "Unit" );
	strcat( str, ".IDX" );
	DRAW_ImageLib.image_open_index( str );
#endif // _MAP_COMPRESS_

#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin, "\n" );
				timeBegin = timeEnd;
#endif

	// Load Shadow surfaces, must before read med file
	// ΪȡMEDļʱҪӰ
	OutputDebugString( "SHADOW_Load: \n" );
	if( !SHADOW_Load() )
	{
		OutputDebugString( "DRAW_LoadMaps Error(5): Error when loading shadow surfaces!\n" );
		return FALSE;
	}

//	WriteLogFile( "Dead.log","EEE" );
	// load MMX temp surface
	// has color key, in system memory
	if( !DRAW_sMMX.Create( DRAW_MMX_WIDTH, DRAW_MMX_HEIGHT, TRUE, FALSE ) )
	{
		ErrorMessage( hwndGame, DRAW_ERROR_ID+7, "Cannot create MMX temp surface!" );
		return FALSE;
	}
	DRAW_sMMX.Erase();

	// load Build surfaces
	if( !BUILD_Load() )
	{
		OutputDebugString( "DRAW_LoadMaps Error(4): Error when loading build surfaces!\n" );
		return FALSE;
	}

	// load text surfaces
	tCopyright.BeginText( 20, 1, FALSE );
	tWood.BeginText( 8, 1, FALSE );
	tFood.BeginText( 8, 1, FALSE );
	tIron.BeginText( 8, 1, FALSE );
	tGold.BeginText( 8, 1, FALSE );

	// initialize byconts
	MOUSE_InitByConts();

#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin, "\n" );
				timeBegin = timeEnd;
#endif


/*
//Warning : the width of surface must not be larger than 640 piexel!!

	if( !DRAW_sUnitMap[0].Create( 640,10 ) )
	{
		ErrorMessage( hwndGame, DRAW_ERROR_ID+3, "Cannot open unit map" );
		return FALSE;
	}
*/
//	WriteLogFile( "Dead.log","FFF" );

	// set done flag
	DRAW_bLoadMaps=TRUE;
	return TRUE;
//	return GAME_Begin( 0 );

//*****************************Test only, Mar.21.1997
/*	struct OTHER_STRUCT other;
	other.nType = 1;
	other.nCol[0] = 1 + MAP_Lib.AniSeq[22].nOffset;
	other.szItem = MAP_Lib.Unit[22].szItem;
	other.ptBegin.x = 300, other.ptBegin.y = 300;
	OTHER_CreateData( &other );
*/
//*****************************
} // DRAW_LoadMaps()

// ͷսװĻλͼ
// release user defined surfaces
void DRAW_ReleaseMaps()
{
	if( !DRAW_bLoadMaps )
	{
		ErrorMessage( hwndGame, DRAW_ERROR_ID+20, "Try to release maps before load them!" );
		return;
	}

	// ͷĵԪ
//	GAME_ReleaseAllUnits();

	// relese text surfaces
	tCopyright.EndText();
	tWood.EndText();
	tFood.EndText();
	tIron.EndText();
	tGold.EndText();

	// release image compression library
#ifdef	_MAP_COMPRESS_
	DRAW_ImageLib.image_close_compress();	
	DRAW_ImageLib.image_close_index();
#else

	// release unit maps
	for( int j=0; j < MAP_Lib.nULibNum; j++ )
	{
		DRAW_sUnitMap[j].Release();
	}
#endif // _MAP_COMPRESS_

	// release ground maps
	for( int i=0; i < MAP_Lib.nGLibNum; i++ )
	{
		DRAW_sGroundMap[i].Release();
	}

	// release MMX surface
	DRAW_sMMX.Release();

	// Load other surfaces, must before read med file, read shadow file, read build file
	// ȡͼļ
	for( i=0; i< MAP_Lib.nOtherNum; i++ )
	{
		// has color key , in system memory
		DRAW_sOtherMap[i].Release();
	}

	// release shadow surfaces
	SHADOW_Release();

	// release build surfaces
	BUILD_Release();

	// release bkground surface
	DRAW_sBkGround.Release();

	// clear done flag
	DRAW_bLoadMaps = FALSE;

//	GAME_End( 0 );

} // DRAW_ReleaseMaps();
/////////////////////

/////////////////////
// ע⣺ķͳõķһ
// 0 1 2
// 7   3
// 6 5 4
// ΪշҪ󣬶ƶĻĳΧļ
// point	:	Ļϵλ
// return	:	Ӧƶķ-1ʱΪƶ
int  DRAW_MoveScreen2( POINT point );

// ǷƶĻ
// test if should move screen, if so move it
// return value	:	TRUE if moved
int  DRAW_MoveScreen( void )
{

	POINT point;
	GetCursorPos(&point);
	static int nDir=-1;
	static int nDirSave=-1;

	nDirSave = nDir;
	if( DRAW_bMoveScreenEx )
	{
		nDir = DRAW_MoveScreen2( point );
	}
	else
	{
		if( point.x == 0 )
		{
			if( point.y == 0 )						nDir=0;
			else if( point.y == SCREEN_HEIGHT-1 )	nDir=6;
			else									nDir=7;
		}
		else if( point.x == SCREEN_WIDTH-1 )
		{
			if( point.y == 0 )						nDir=2;
			else if( point.y == SCREEN_HEIGHT-1 )	nDir=4;
			else									nDir=3;
		}
		else
		{
			if( point.y == 0 )						nDir=1;
			else if( point.y == SCREEN_HEIGHT-1 )	nDir=5;
			else nDir = -1;
		}
	}

	// if mouse cursor is not in scrolling region, do nothing
	// жǷڹ
	// set cursor part 1, һ
	if( nDir == -1 )
	{	// 겻ڹ
		if( nDirSave != -1 )	// ոƳ
		{
			CURSOR_Set( &MAIN_Cursors[0] );
			MOUSE_EnableTest( TRUE );
		}
		return FALSE;
	}

	// save old top-left point
	POINT ptTopLeft;
	ptTopLeft.x = DRAW_rcScreen.left;
	ptTopLeft.y = DRAW_rcScreen.top;

	// DRAW_rcScreen should always be larger than (0,0,640,480)
	int width = DRAW_rcScreen.right - DRAW_rcScreen.left;
	int height = DRAW_rcScreen.bottom - DRAW_rcScreen.top;
	DRAW_rcScreen.left+=DD[nDir][0] * GAME.nSpeedScroll;
	DRAW_rcScreen.top+=DD[nDir][1] * GAME.nSpeedScroll;
	// adjust
	if( DRAW_rcScreen.left < 0 )
	{
		DRAW_rcScreen.left = 0;
		if( nDir == 0 )	nDir = 1;
		else if( nDir == 6 ) nDir = 5;
	}
	if( DRAW_rcScreen.left >= MAP_Lib.szNum.cx - width )
	{
		DRAW_rcScreen.left = MAP_Lib.szNum.cx - width - 1;
		if( nDir == 2 )	nDir = 1;
		else if( nDir == 4 ) nDir = 5;
	}
	if( DRAW_rcScreen.top < 0 )
	{
		DRAW_rcScreen.top = 0;
		if( nDir == 0 )	nDir = 7;
		else if( nDir == 2 ) nDir = 3;
	}
	if( DRAW_rcScreen.top > MAP_Lib.szNum.cy - height + 9 )
	{
		DRAW_rcScreen.top = MAP_Lib.szNum.cy - height + 9;
		if( nDir == 4 )	nDir = 3;
		else if( nDir == 6 ) nDir = 7;
	}
	DRAW_rcScreen.right=DRAW_rcScreen.left + width;
	DRAW_rcScreen.bottom=DRAW_rcScreen.top+height;

	// if need't move
	if( DRAW_rcScreen.left == ptTopLeft.x && DRAW_rcScreen.top == ptTopLeft.y )
	{	//ͷˣ˳״̬
		CDDCursor *pCursor;
		pCursor = CURSOR_Get();
		Assert( pCursor );
		if( pCursor != &MAIN_Cursors[0] )
		{
			CURSOR_Set( &MAIN_Cursors[0] );
			MOUSE_EnableTest( TRUE );
		}
		nDir = -1;
		return FALSE;
	}
	else
	{	// ڹ
		if( nDirSave == -1 )
		{
			CURSOR_Set( &MAIN_Cursors[1] );
			MOUSE_EnableTest( FALSE );
		}
		if( nDirSave != nDir )
		{
			CDDCursor *pCursor;
			pCursor = CURSOR_Get();
			Assert( pCursor );
			pCursor->SetState( nDir );
		}
	}

	// set screen offset
	POINT ptSave;
	ptSave.x = DRAW_ptScreenOffset.x;
	ptSave.y = DRAW_ptScreenOffset.y;
	DRAW_ptScreenOffset.x = (DRAW_rcScreen.left+DRAW_SCREEN_ADJUST)*MAP_Lib.szItem.cx;
	DRAW_ptScreenOffset.y = DRAW_rcScreen.top*(MAP_Lib.szItem.cy>>1);

	//DRAW_UpdateScreen();
	// offset since move screen
	ptSave.x = DRAW_ptScreenOffset.x - ptSave.x;
	ptSave.y = DRAW_ptScreenOffset.y - ptSave.y;
	DRAW_DrawMoveScreen( ptSave );

	return TRUE;
}	// DRAW_MoveScreen()

// ΪշҪ󣬶ƶĻĳΧļ
// point	:	Ļϵλ
// return	:	Ӧƶķ-1ʱΪƶ
//RECT rcScroll[8]={{15,39,24,48},{24,39,483,48},{483,39,492,48},
//{483,48,492,456},{483,456,492,465},{24,456,492,465},
//{15,456,24,465},{15,48,24,456}};
//RECT rcScroll[8]={{24,48,48,72},{48,48,459,72},{459,48,483,72},
//{459,72,483,432},{459,432,483,456},{48,432,459,456},
//{24,432,48,456},{24,72,48,432}};
RECT rcScroll[8]={{24,48,72,96},{72,48,435,96},{435,48,483,96},
{435,96,483,408},{435,408,483,456},{72,408,435,456},
{24,408,72,456},{24,96,72,408}};
#define	DRAW_MOVE_SCREEN_DELAY	10
BOOL DRAW_bShowScrollBorder = TRUE;
int  DRAW_MoveScreen2( POINT point )
{
	int i, nDir = -1;
	if( DRAW_bShowScrollBorder )
	for ( i=0; i< 8; i++ )
	{
		DDC_FrameRect( &rcScroll[i], RGB(255,0,0), TRUE );
	}

	static int nCounter=0;
	for ( i=0; i< 8; i++ )
	{
		if( PtInRect( &rcScroll[i], point ) )
		{
			nCounter ++;
			nDir = i; break;
		}
	}

	if( nDir == -1 )
	{
		nCounter = 0;
	}
	else if( nCounter < DRAW_MOVE_SCREEN_DELAY )
	{
		nDir = -1;
	}
	return nDir;
}	// DRAW_MoveScreen2()

// λõĻ»һ
// draw moving screen, it should be much faster than DRAW_UpdateScreen()
// ptOff	:	λλõƫ
void DRAW_DrawMoveScreen( POINT ptOff )
{
	if( !DRAW_bLoadMaps )	return;

	POINT ptDest;
	RECT rcRemain;
	RECT rcMore1, rcMore2;
	
	// 㱣ֵľ
	rcRemain.left = rcRemain.top = 0;
	rcRemain.right = DRAW_rcClient.right - DRAW_rcClient.left;
	rcRemain.bottom = DRAW_rcClient.bottom - DRAW_rcClient.top;

	// ӲֵľΣһ
	// if move to left
	if( ptOff.x < 0 )
	{
		ptDest.x = -ptOff.x;
		rcMore1.left = 0; rcMore1.right = -ptOff.x;
		//rcMore2.left = rcRemain.left; rcMore2.right = rcRemain.right;
		rcMore2.left = -ptOff.x; rcMore2.right = rcRemain.right;
		rcRemain.right += ptOff.x;
	}
	else
	{
		ptDest.x = 0;
		rcMore1.left = rcRemain.right-ptOff.x; rcMore1.right = rcRemain.right;
		//rcMore2.left = rcRemain.left; rcMore2.right = rcRemain.right;
		rcMore2.left = 0; rcMore2.right = rcRemain.right-ptOff.x;
		rcRemain.left += ptOff.x;
	}
	// if move to top
	if( ptOff.y < 0 )
	{
		ptDest.y = -ptOff.y;
		rcMore1.top = 0; rcMore1.bottom = rcRemain.bottom;
		rcMore2.top = 0; rcMore2.bottom = -ptOff.y;
		rcRemain.bottom += ptOff.y;
	}
	else
	{
		ptDest.y = 0;
		rcMore1.top = 0; rcMore1.bottom = rcRemain.bottom;
		rcMore2.top = rcRemain.bottom - ptOff.y; rcMore2.bottom = rcRemain.bottom;
		rcRemain.top += ptOff.y;
	}

	// draw the part on screen that remains to the new position
	// αϱµλ
	DRAW_sBkGround.BltSurface(	ptDest.x, ptDest.y, 
								DRAW_sBkGround.GetSurface(), 
								&rcRemain, DDBLTFAST_NOCOLORKEY );

	// Ļϱµλ
	OffsetRect( &rcRemain, DRAW_rcClient.left, DRAW_rcClient.top );
	ptDest.x += DRAW_rcClient.left;
	ptDest.y += DRAW_rcClient.top;
	DD_BltSurface( ptDest, DD_GetBackBuffer(),
		&rcRemain, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );

	// Ӱϱµλ
	SHADOW_MoveBack( ptDest, &rcRemain );

	// ӵľʾµĵԪ͵
	if( !IsRectEmpty( &rcMore1 ) )
	{
		OffsetRect( &rcMore1, DRAW_rcClient.left, DRAW_rcClient.top );
		DRAW_DrawGround( rcMore1, 0, FALSE );
		DRAW_DrawGround( rcMore1, 1, FALSE );
		DRAW_DrawGround( rcMore1, 2, FALSE );
		DRAW_DrawBack2BkGround( &rcMore1 );
		DRAW_DrawUnit( rcMore1, FALSE );
		SHADOW_DrawAll( &rcMore1 );
	}
	if( !IsRectEmpty( &rcMore2 ) )
	{
		OffsetRect( &rcMore2, DRAW_rcClient.left, DRAW_rcClient.top );
		DRAW_DrawGround( rcMore2, 0, FALSE );
		DRAW_DrawGround( rcMore2, 1, FALSE );
		DRAW_DrawGround( rcMore2, 2, FALSE );
		DRAW_DrawBack2BkGround( &rcMore2 );
		DRAW_DrawUnit( rcMore2, FALSE );
		SHADOW_DrawAll( &rcMore2 );
	}

	// ʾӰ
	// draw shadow
	//SHADOW_DrawAll();
	// draw shadow
	SHADOW_Update2Back();

	// debug
//	DDC_FrameRect( &rcMore1, RGB(255,0,0), TRUE );
//	DDC_FrameRect( &rcMore2, RGB(255,0,0), TRUE );

	// ͼ
	// draw minimap, do not erase blink point array
	// draw to back buffer
	// July 23. 1997
	MINI_Update( 0, FALSE );	

	FACE_BlitCurrentMenu();

	// update to front buffer
	// July 23. 1997
	MINI_Update( 2, FALSE );
}	// DRAW_DrawMoveScreen()

// ͼϷһʼʱʹĻӦλ
// if mouse hit minimap, should jump the screen to the point
// ptCenter		:	mouse hit point, in grid
// return value	:	TRUE if jumped
BOOL  DRAW_JumpScreen( POINT ptCenter )
{
	// if not hit minimap, not jump screen
	if( ptCenter.x == -1 )	return FALSE;	

	// save old top-left point
	POINT ptTopLeft;
	ptTopLeft.x = DRAW_rcScreen.left;
	ptTopLeft.y = DRAW_rcScreen.top;

	// DRAW_rcScreen should always be larger than (0,0,640,480)
	// calc new DRAW_rcScreen
	int width = DRAW_rcScreen.right - DRAW_rcScreen.left;
	int height = DRAW_rcScreen.bottom - DRAW_rcScreen.top;

	// adjust
	int nOffX = ptCenter.x - (width>>1);
	int nOffY = ptCenter.y - (height>>2)-12;
	if( nOffX < 0 )	nOffX = 0;
	if( nOffX >= MAP_Lib.szNum.cx-width ) nOffX = MAP_Lib.szNum.cx-width-1;
	if( nOffY < 0 )	nOffY = 0;
	if( nOffY > MAP_Lib.szNum.cy-height+9 ) nOffY = MAP_Lib.szNum.cy-height+9;

	// set
	DRAW_rcScreen.left = nOffX;
	DRAW_rcScreen.right = DRAW_rcScreen.left + width;
	DRAW_rcScreen.top = nOffY;
	DRAW_rcScreen.bottom = DRAW_rcScreen.top + height;

	// if need't move
	if( DRAW_rcScreen.left == ptTopLeft.x && DRAW_rcScreen.top == ptTopLeft.y )
		return FALSE;

	// set screen offset
	DRAW_ptScreenOffset.x = (DRAW_rcScreen.left+DRAW_SCREEN_ADJUST)*MAP_Lib.szItem.cx;
	DRAW_ptScreenOffset.y = DRAW_rcScreen.top*(MAP_Lib.szItem.cy>>1);

	// update screen in new position
	DRAW_UpdateScreen();
	return TRUE;
}	// DRAW_JumpScreen()

// draw all the user defined maps to screen
// Ļ
// bFront		:	TRUEͼĻǰ
void DRAW_UpdateScreen( BOOL bFront/*=TRUE*/ )
{
	if( !DRAW_bLoadMaps )	return;
	DRAW_DrawGround( DRAW_rcClient, 0, FALSE );
	DRAW_DrawGround( DRAW_rcClient, 1, FALSE );
	DRAW_DrawGround( DRAW_rcClient, 2, FALSE );
	DRAW_DrawBack2BkGround();
	DRAW_DrawUnit( DRAW_rcClient, FALSE );

	// draw shadow
	SHADOW_DrawAll();
	// draw shadow
	SHADOW_Update2Back();

	// draw minimap
	MINI_Update( FALSE );	// to front buffer

	GFWI_bUpdate = TRUE;
//	DrawHZ( NULL );

	if( bFront )
		DDC_UpdateScreen( &DRAW_rcClient );
}	// DRAW_UpdateScreen()
/////////////////////

/////////////////////
// draw one ground item
// ʾһͼ
// prcCut	:	ֻ´˾ڵͼ
// k,i,j	:	ͼصĲţкţк
// bFront	:	ǷֱӸµʾĻ
inline void DRAW_DrawSingleG( CONST RECT *prcCut, int k, int i, int j, BOOL bFront )
{
	RECT rect;
	RECT rcCutG;

	// decode
	WORD code = MAP_GetGroundData( k, i, j );
	if( code == MAP_DATA_NONE ) return;
	struct MAP_GROUND_CODE_STRUCT stctG;
	MAP_GroundDeCode( code, &stctG );

	// get update region
	RECT rcCutGOld = ::MAP_GetGroundRect( DRAW_ptScreenOffset, k, i, j, stctG.nFile );
	if( IntersectRect( &rcCutG, &rcCutGOld, prcCut ) )
	{
		POINT ptTLOff, ptRBOff;
		ptTLOff.x = rcCutGOld.left - rcCutG.left;
		ptTLOff.y = rcCutGOld.top - rcCutG.top;
		ptRBOff.x = rcCutGOld.right - rcCutG.right;
		ptRBOff.y = rcCutGOld.bottom - rcCutG.bottom;

		// calc source position and size
		rect.left = stctG.nCol*(rcCutGOld.right - rcCutGOld.left) - ptTLOff.x;
		rect.right = (stctG.nCol+1)*(rcCutGOld.right - rcCutGOld.left) - ptRBOff.x;
		rect.top = stctG.nRow*(rcCutGOld.bottom - rcCutGOld.top) - ptTLOff.y;
		rect.bottom = (stctG.nRow+1)*(rcCutGOld.bottom - rcCutGOld.top) - ptRBOff.y;

		// draw
		POINT ptDest;
		ptDest.x = rcCutG.left, ptDest.y = rcCutG.top;
	//	class CDDSurface *pSurface = &DRAW_sGroundMap[stctG.nFile];
	//	pSurface->BltToBack( ptDest, &rect );
		DRAW_sGroundMap[stctG.nFile].BltToBack( ptDest, &rect );
		}

	// draw special ground item
	if( stctG.nAttr != MAP_SPECIAL_NONE )
	{
		DRAW_DrawSingleS( prcCut, i, j, bFront, stctG.nAttr, k );
	}

	if( bFront )
	{
#ifdef	_CURSOR_OLD_VERSION_
		DDC_UpdateSprite( &rcCutG, &rcCutG );
#endif	// 	_CURSOR_OLD_VERSION_
	}

} // DRAW_DrawSingleG()

// ʾĳԪ
// prcCut	:	ֻ´˾ڵͼ
// pstctCF	:	Ԫͼʾ֡ṹ
inline BOOL DRAW_DrawUnitSingle( CONST RECT *prcCut, const struct CTRL_FRAME_STRUCT *pstctCF )
{
// if hide by shadow do not draw it
	{
	if( SHADOW_IfEnabled() )
	{
		BOOL bOdd = pstctCF->nY&1;
		int nX, nY;
		WORD codeR;
		struct MAP_REGION_CODE_STRUCT stctR;
		int nNotDraw=0;
		for( int x=0; x<MAP_nLocationNum[pstctCF->nLocationSize]; x++ )
		{
			nX = pstctCF->nX + MAP_ptLocation[bOdd][x].x,
			nY = pstctCF->nY + MAP_ptLocation[bOdd][x].y;
			Assert( !EYE_IfOutOfRange( nX, nY ) );
			codeR = MAP_GetRegionData( nX, nY );
			MAP_RegionDeCode( codeR, &stctR );
			if( stctR.nShadow == MAP_SHADOW_NONE 
				// ʿ͸ӰҲҪ
				|| ( stctR.nShadowEx == 1 && pstctCF->nFile >= 27 ) )
				nNotDraw++;
			else break;
		}
		if( nNotDraw == MAP_nLocationNum[pstctCF->nLocationSize] )
			return FALSE;	// ȫӰס
	}
	}
#ifdef	_MAP_COMPRESS_
	// get update region
	RECT rcCutGOld, rcCutG;
	RECT rcOff;
	POINT ptDest;

	rcCutGOld = ::MAP_GetUnitRect( DRAW_ptScreenOffset, pstctCF );

	// test if needn't draw, outside client area
	if( !IntersectRect( &rcCutG, &rcCutGOld, prcCut ) )	
	{
		return FALSE;
	}

	// calc offset
	rcOff.left = rcCutGOld.left - rcCutG.left;
	rcOff.top = rcCutGOld.top - rcCutG.top;
	rcOff.right = rcCutGOld.right - rcCutG.right;
	rcOff.bottom = rcCutGOld.bottom - rcCutG.bottom;

	// calc destination position
	ptDest.x = rcCutG.left, ptDest.y = rcCutG.top;

		//-
//		char * pBuffer = NULL;
		//-

	// test if should cut edge
	if( rcOff.left!=0 || rcOff.top!=0 || rcOff.right !=0 || rcOff.bottom !=0 )
	{	// cut edge
		RECT rcSrcMMX;
		POINT ptDestMMX;
		
		// for blting on MMX surface
		ptDestMMX.x = ptDestMMX.y = 0;
		rcSrcMMX.left = 0 - rcOff.left;
		rcSrcMMX.top = 0 - rcOff.top;
		rcSrcMMX.right = rcCutGOld.right - rcCutGOld.left - rcOff.right;
		rcSrcMMX.bottom = rcCutGOld.bottom - rcCutGOld.top - rcOff.bottom;

		LPDIRECTDRAWSURFACE2 pSurDest = DRAW_sMMX.GetSurface();
		DDSURFACEDESC       ddsdDest;
		ddsdDest.dwSize = sizeof( ddsdDest );

		// for change color
		short colorSub[4] = {0 , -57, 90, 53 };
		short ncolorIdx;

		int widthDest = 0;
		DRAW_sMMX.Erase();
		if( pSurDest->Lock( NULL, &ddsdDest, DDLOCK_WAIT, NULL ) == DD_OK )
		{

			// ˸ʾѡеĵԪA
			if( pstctCF->bUpdate >= 5 )
			{
				if( DRAW_BLINK_bDraw == TRUE )
				{
					DRAW_drawBorderTop( &ptDestMMX, ddsdDest.dwWidth, (BYTE*)ddsdDest.lpSurface, 
						&rcCutGOld, pstctCF->nLocationSize, pstctCF->bUpdate-1-5 );
				}
			}
			else if( pstctCF->bUpdate>0 )
			{
				DRAW_drawBorderTop( &ptDestMMX, ddsdDest.dwWidth, (BYTE*)ddsdDest.lpSurface, 
					&rcCutGOld, pstctCF->nLocationSize, pstctCF->bUpdate-1 );
			}
	//-
//				pBuffer = (char *)malloc( ddsdDest.dwWidth*ddsdDest.dwHeight );
//				if( pBuffer != NULL )
//					memcpy( pBuffer, ddsdDest.lpSurface, ddsdDest.dwWidth*ddsdDest.dwHeight );
	//-
			ncolorIdx = pstctCF->nPlayer-1;
			if( ncolorIdx <0 ) ncolorIdx = 0;
			Assert( ncolorIdx < 4 );
			if( MAIN_bMMX )
			{	//-- MMX extension
				DRAW_ImageLib.P_imageMMX(ptDestMMX.x, ptDestMMX.y, ddsdDest.dwWidth, 
						(char*)ddsdDest.lpSurface,
						ncolorIdx, pstctCF->nCol );
				//-- MMX extension
			}
			else
			{
				ncolorIdx = colorSub[ncolorIdx];	// ɫűΪɫ
				if( ncolorIdx == 0 )
				{	// ɫ
					DRAW_ImageLib.P_imageDirect(ptDestMMX.x, ptDestMMX.y, ddsdDest.dwWidth, 
							(char*)ddsdDest.lpSurface,
							ncolorIdx, pstctCF->nCol );
				}
				else
				{
					DRAW_ImageLib.P_image(ptDestMMX.x, ptDestMMX.y, ddsdDest.dwWidth, 
							(char*)ddsdDest.lpSurface,
							ncolorIdx, pstctCF->nCol );
				}
			}

			// ˸ʾѡеĵԪB
			if( pstctCF->bUpdate >= 5 )
			{
				if( DRAW_BLINK_bDraw == TRUE )
				{
					DRAW_drawBorderBottom( &ptDestMMX, ddsdDest.dwWidth, (BYTE*)ddsdDest.lpSurface, 
						&rcCutGOld, pstctCF->nLocationSize, pstctCF->bUpdate-1-5 );
				}
			}
			else if( pstctCF->bUpdate>0 )
			{
				DRAW_drawBorderBottom( &ptDestMMX, ddsdDest.dwWidth, (BYTE*)ddsdDest.lpSurface, 
					&rcCutGOld, pstctCF->nLocationSize, pstctCF->bUpdate-1 );
			}
			pSurDest->Unlock( NULL );
		}
		DRAW_sMMX.BltToBack( ptDest, &rcSrcMMX );
	}
	else
	{
		LPDIRECTDRAWSURFACE2 pSurDest = DD_GetBackBuffer();
		DDSURFACEDESC       ddsdDest;
		ddsdDest.dwSize = sizeof( ddsdDest );

		// for change color
		int colorSub[4] = {0 , -57, 90, 53 };
		int ncolorIdx;

		int widthDest = 0;
		if( pSurDest->Lock( NULL, &ddsdDest, DDLOCK_WAIT, NULL ) == DD_OK )
		{
			// ˸ʾѡеĵԪA
			if( pstctCF->bUpdate >= 5 )
			{
				if( DRAW_BLINK_bDraw == TRUE )
				{
					DRAW_drawBorderTop( &ptDest, ddsdDest.dwWidth, (BYTE*)ddsdDest.lpSurface, 
						&rcCutGOld, pstctCF->nLocationSize, pstctCF->bUpdate-1-5 );
				}
			}
			else if( pstctCF->bUpdate>0 )
				DRAW_drawBorderTop( &ptDest, ddsdDest.dwWidth, (BYTE*)ddsdDest.lpSurface, 
					&rcCutGOld, pstctCF->nLocationSize, pstctCF->bUpdate-1 );

	//-
//				pBuffer = (char *)malloc( ddsdDest.dwWidth*ddsdDest.dwHeight );
//				if( pBuffer != NULL )
//					memcpy( pBuffer, ddsdDest.lpSurface, ddsdDest.dwWidth*ddsdDest.dwHeight );
	//-

			ncolorIdx = pstctCF->nPlayer-1;
			if( ncolorIdx <0 ) ncolorIdx = 0;
			Assert( ncolorIdx < 4 );
			if( MAIN_bMMX )
			{	//-- MMX extension
				DRAW_ImageLib.P_imageMMX(ptDest.x, ptDest.y, ddsdDest.dwWidth, 
						(char*)ddsdDest.lpSurface,
						ncolorIdx, pstctCF->nCol );
				//-- MMX extension
			}
			else
			{
				ncolorIdx = colorSub[ncolorIdx];	// ɫűΪɫ
				if( ncolorIdx == 0 )
				{	// ɫ
					DRAW_ImageLib.P_imageDirect(ptDest.x, ptDest.y, ddsdDest.dwWidth, 
							(char*)ddsdDest.lpSurface,
							ncolorIdx, pstctCF->nCol );
				}
				else
				{
					DRAW_ImageLib.P_image(ptDest.x, ptDest.y, ddsdDest.dwWidth, 
							(char*)ddsdDest.lpSurface,
							ncolorIdx, pstctCF->nCol );
				}
			}

			// ˸ʾѡеĵԪB
			if( pstctCF->bUpdate >= 5 )
			{
				if( DRAW_BLINK_bDraw == TRUE )
				{
					DRAW_drawBorderBottom( &ptDest, ddsdDest.dwWidth, (BYTE*)ddsdDest.lpSurface, 
						&rcCutGOld, pstctCF->nLocationSize, pstctCF->bUpdate-1-5 );
				}
			}
			else if( pstctCF->bUpdate>0 )
				DRAW_drawBorderBottom( &ptDest, ddsdDest.dwWidth, (BYTE*)ddsdDest.lpSurface, 
					&rcCutGOld, pstctCF->nLocationSize, pstctCF->bUpdate-1 );

			pSurDest->Unlock( NULL );
		}
	//-
/*
		if( pBuffer )
		{
			DRAW_ImageLib.P_image(100, 100, ddsdDest.dwWidth, 
				pBuffer, 0, 0 );

			free( pBuffer );
		}
		else
		{
			OutputDebugString( "Not enough memory!\n" );
		}
*/
	//-
	}
	return TRUE;
#endif //_MAP_COMPRESS_
}

// ʾοϰ벿֣ӦñõԪڵ
// pptDest		:	Ŀĵ꣬Ͻ
// dwWidthDest	:	ĿĵػĿ
// pDest		:	Ŀĵָ
// prcCutGOld	:	õԪľδСλ
// nSize		:	õԪռλõĴСӣ
// nColorIndex	:	Ӧʲôɫ
void DRAW_drawBorderTop( CONST POINT *pptDest, DWORD dwWidthDest, BYTE *pDest, 
						CONST RECT *prcCutGOld, int nSize, int nColorIndex )
{
	int i;
	if( nSize == 3 ) nSize = 2;
	
	// colors
	int nColor = DRAW_nBdrColors[nColorIndex];

	// loop number
	int nLoopNum = (MAP_Lib.szItem.cy>>1)*(nSize+1);
	// source rectangle size
	int nSrcWidth = prcCutGOld->right - prcCutGOld->left;
	int nSrcHeight = prcCutGOld->bottom - prcCutGOld->top;
	// border size
	int nBdrWidth = (nSize+1)*MAP_Lib.szItem.cx;
	int nBdrHeight = (nSize+1)*MAP_Lib.szItem.cy;
	// Top-left point of border
	int nBdrLeft = pptDest->x + ((nSrcWidth - nBdrWidth)>>1);
	int nBdrTop = pptDest->y + nSrcHeight - nBdrHeight;

	// destination buffer pointer
	BYTE * pBytesDest;	
	// left part, calculate begin and end value for loop
	// draw left part, from bottom to top, left to right
	pBytesDest = pDest + dwWidthDest*(nBdrTop+(nBdrHeight>>1)) + nBdrLeft;
	for (i=0; i<nLoopNum; i++ )
	{
		memset( pBytesDest, nColor, 2 );
		pBytesDest -= dwWidthDest-2;
	}

	// right part, calculate begin and end value for loop
	// draw right part
	pBytesDest = pDest + dwWidthDest*(nBdrTop+2) + nBdrLeft + (nBdrWidth>>1);
	for (i=0; i<nLoopNum-1; i++ )
	{
		memset( pBytesDest, nColor, 2 );
		pBytesDest += dwWidthDest+2;
	}
}

// ʾο°벿֣ӦڵõԪ
// pptDest		:	Ŀĵ꣬Ͻ
// dwWidthDest	:	ĿĵػĿ
// pDest		:	Ŀĵָ
// prcCutGOld	:	õԪľδСλ
// nSize		:	õԪռλõĴСӣ
// nColorIndex	:	Ӧʲôɫ
void DRAW_drawBorderBottom( CONST POINT *pptDest, DWORD dwWidthDest, BYTE *pDest, 
						CONST RECT *prcCutGOld, int nSize, int nColorIndex )
{
	int i;
	if( nSize == 3 ) nSize = 2;

	// colors
	int nColor = DRAW_nBdrColors[nColorIndex];

	// loop number
	int nLoopNum = (MAP_Lib.szItem.cy>>1)*(nSize+1);
	// source rectangle size
	int nSrcWidth = prcCutGOld->right - prcCutGOld->left;
	int nSrcHeight = prcCutGOld->bottom - prcCutGOld->top;
	// border size
	int nBdrWidth = (nSize+1)*MAP_Lib.szItem.cx;
	int nBdrHeight = (nSize+1)*MAP_Lib.szItem.cy;
	// Top-left point of border
	int nBdrLeft = pptDest->x + ((nSrcWidth - nBdrWidth)>>1);
	int nBdrTop = pptDest->y + nSrcHeight - nBdrHeight;

	// destination buffer pointer
	BYTE * pBytesDest;
	// left part, calculate begin and end value for loop
	// draw left part
	pBytesDest = pDest + dwWidthDest*(nBdrTop+(nBdrHeight>>1)) + nBdrLeft;
	for (i=0; i<nLoopNum; i++ )
	{
		memset( pBytesDest, nColor, 2 );
		pBytesDest += dwWidthDest+2;
	}

	// right part, calculate begin and end value for loop
	// draw right part
	pBytesDest = pDest + dwWidthDest*(nBdrTop+nBdrHeight-2) + nBdrLeft + (nBdrWidth>>1);
	for (i=0; i<nLoopNum-1; i++ )
	{
		memset( pBytesDest, nColor, 2 );
		pBytesDest -= dwWidthDest-2;
	}
}

// ʾĳԪڵеΣʵ»þڵĵ
// ӱϿһͼ
// darw other things
// prcCut	:	ֻ´˾ڵͼ
// pstctCF	:	Ԫͼʾ֡ṹ
inline void DRAW_DrawUnitCovered( CONST RECT *prcCut, const struct CTRL_FRAME_STRUCT *pstctCF )
{
	POINT ptDest;
	RECT rcSrc;
	ptDest.x = prcCut->left, ptDest.y = prcCut->top;
	rcSrc.left = prcCut->left - DRAW_rcClient.left;
	rcSrc.top = prcCut->top - DRAW_rcClient.top;
	rcSrc.right = prcCut->right - DRAW_rcClient.left;
	rcSrc.bottom = prcCut->bottom - DRAW_rcClient.top;
	DD_BltSurface( ptDest, DD_GetBackBuffer(), &rcSrc, DRAW_sBkGround.GetSurface(), DDBLTFAST_NOCOLORKEY );
}

// ʾڵĳԪеԪ
// prcCut	:	ֻ´˾ڵͼ
// pstctCF	:	Ԫͼʾ֡ṹ
inline void DRAW_DrawUnitCovering( CONST RECT *prcCut, const struct CTRL_FRAME_STRUCT *pstctCF )
{
	int i, j, k;
	POINT pt;

	int nX = pstctCF->nX;
	int nY = pstctCF->nY;

	// draw the first level
	i = nY&1;
	int nLayer = pstctCF->nLayer;
//	for( k=0; k<6; k+=2 )
//	for( j=0; j<9; j++ )
	for( k=0; k<8; k+=2 )
	for( j=0; j<11; j++ )
	{
		if( pstctCF->nLocationSize == 0 && j < 5 && k== 0 )	continue;
		pt.x = nX+ptCovering[i][j].x;
		pt.y = nY+ptCovering[i][j].y+k;
		if( EYE_IfOutOfRange( pt.x, pt.y ) )
			continue;

		// draw special grounds around the unit
		struct MAP_GROUND_CODE_STRUCT stctG;
		WORD codeG = MAP_GetGroundData( nLayer, pt.x, pt.y );
		MAP_GroundDeCode( codeG, &stctG );
		if( stctG.nAttr == MAP_SPECIAL_NONE )	continue;

		int nA = stctG.nAttr%4;
		int nB = stctG.nAttr/4;
		int nC = 0;
		if( nB == 2 )	continue;	// ѾԴ򲻻
		DRAW_OTHER_Draw( prcCut, 7, (nA<<1)+nC, nLayer, pt.x, pt.y );

/*		// get special code
		struct CTRL_FRAME_STRUCT stctCF;
		Assert( stctG.nAttr != MAP_SPECIAL_NONE );
		if( !MAP_GetSpecFrameData( nLayer, pt.x, pt.y, stctG.nAttr, &stctCF ) )
			continue;

		// draw special unit in current position
		DRAW_DrawUnitSingle( prcCut, &stctCF );
*/
	}		

	// draw the second level
	nLayer ++;
	for( k=0; k<12; k+=2 )
	for( j=0; j<11; j++ )
	{
		if( pstctCF->nLocationSize == 0 && j < 5 && k== 0 )	continue;
		pt.x = nX+ptCovering[i][j].x;
		pt.y = nY+ptCovering[i][j].y+k;
		if( pt.x < 0 ||	pt.y < 0 || pt.x >= MAP_Lib.szNum.cx || pt.y >= MAP_Lib.szNum.cy )
			continue;

		// draw grounds around the unit
		DRAW_DrawSingleG( prcCut, nLayer, pt.x, pt.y, FALSE );
	}

	if( nLayer == 2	)	return;

	// draw the third level right above the unit
	for( j=MAP_nLocationNum[pstctCF->nLocationSize]-1; j>=0; j-- )
	{
		pt.x = nX+MAP_ptLocation[i][j].x;
		pt.y = nY+MAP_ptLocation[i][j].y;

		// draw grounds above the unit
		DRAW_DrawSingleG( prcCut, 2, pt.x, pt.y, FALSE );
	}

	// draw the third level
	for( k=0; k<12; k+=2 )
	for( j=0; j<11; j++ )
	{
		if( pstctCF->nLocationSize == 0 && j < 5 && k== 0 )	continue;
		pt.x = nX+ptCovering[i][j].x;
		pt.y = nY+ptCovering[i][j].y+k;
		if( pt.x < 0 ||	pt.y < 0 || pt.x >= MAP_Lib.szNum.cx || pt.y >= MAP_Lib.szNum.cy )
			continue;

		// draw grounds around the unit
		DRAW_DrawSingleG( prcCut, 2, pt.x, pt.y, FALSE );
	}
}

// ʾһԪ˸ΧĵԪĲ
// draw one unit item
// prcCut	:	ֻ´˾ڵͼ
// i,j		:	ͼصкţк
// bFront	:	ǷֱӸµʾĻ
RECT DRAW_rcUpdate={0,0,0,0};
inline void DRAW_DrawSingleU( CONST RECT *prcCut, int i, int j, BOOL bFront )
{
	//RECT rect;		// source rectangle
	RECT rcCutG, rcCutGSave;	// update region for current position

// get code
	struct CTRL_FRAME_STRUCT stctCF;
	if( !MAP_GetUnitFrameData( i, j, &stctCF, FALSE ) )
		return;

	// ʾ
	struct UNIT_STRUCT *pUnit = MAP_GetUnit( i,j );
	Assert( pUnit );
	if( pUnit->Status.nTaskID == MFU && pUnit->Draw.nPlayer != GAME.nMe )
		return;
	// debug
//	if( pUnit->Status.nTaskID == MFU )
//		return;

	// test if should draw
//	if( !stctCF.bUpdate )	return;

	// below: same as DRAW_DrawSingleS()
// draw this unit in current position
	BOOL bDraw = DRAW_DrawUnitSingle( prcCut, &stctCF );
	
// draw covering items, items which covering this unit
	// get update region
	rcCutGSave = ::MAP_GetUnitRect( DRAW_ptScreenOffset, &stctCF );

	// ʾıʾͼ꣨Ѫ㣩
	if( bDraw && pUnit->Draw.nFile > 28 )	// ûмı
		DRAW_Draw8x8( pUnit, &rcCutGSave, prcCut );
	
	// draw covering
	if( bDraw && stctCF.nLayer != 2 
		&& IntersectRect( &rcCutG, &rcCutGSave, prcCut ) )
		DRAW_DrawUnitCovering( &rcCutG, &stctCF );

	// calculate update region
	// The mouse cursor is blinking, so do not use it
/*	RECT rcCutGL, rcCutGLSave;	// update region for previous position
	rcCutGLSave = ::MAP_GetUnitRectLast( DRAW_ptScreenOffset, &stctCF );
	IntersectRect( &rcCutGL, &rcCutGLSave, prcCut );
	UnionRect( &DRAW_rcUpdate, &rcCutGL, &DRAW_rcUpdate );
	UnionRect( &DRAW_rcUpdate, &rcCutG, &DRAW_rcUpdate );
*/
} // DRAW_DrawSingleU()

// ʾһͼأľ
// draw one special item
// prcCut	:	ֻ´˾ڵͼ
// i,j		:	ͼصкţк
// bFront	:	ǷֱӸµʾĻ
// Attr		:	ͼصԣ0ʱЧ
// k		:	ͼصĲţnAttr0ʱЧ
inline void DRAW_DrawSingleS( CONST RECT *prcCut, int i, int j, BOOL bFront, int nAttr, int k )
{
	//RECT rect;		// source rectangle
// get code
//	struct CTRL_FRAME_STRUCT stctCF;
	Assert( nAttr != MAP_SPECIAL_NONE );
//	if( !MAP_GetSpecFrameData( k, i, j , nAttr, &stctCF ) )
//		return;

	// below: same as DRAW_DrawSingleU()
// draw this unit in current position
	//DRAW_DrawUnitSingle( prcCut, &stctCF );
	int nA = nAttr%4;
	int nB = nAttr/4;
	int nC = 0;
	if( nB == 2 )	nC = 1;
	DRAW_OTHER_Draw( prcCut, 7, (nA<<1)+nC, k, i, j );
} // DRAW_DrawSingleS()
/////////////////////

/////////////////////
// ʾսڵеͼ
// draw ground items
// rcCut	:	ֻ´˾ڵͼ
// k		:	ͼصĲ
// bFront	:	ǷֱӸµʾĻ
inline void DRAW_DrawGround( RECT rcCut, int k, BOOL bFront )
{
	for( int j=DRAW_rcScreen.top; j<DRAW_rcScreen.bottom; j++ )
	for( int i=DRAW_rcScreen.left; i<DRAW_rcScreen.right; i++ )
	{
		DRAW_DrawSingleG( &rcCut, k, i, j, bFront );
	}
}

// ʾսڵеԪͼ
// draw unit itmes
// rcCut	:	ֻ´˾ڵͼ
// bFront	:	ǷֱӸµʾĻ
inline void DRAW_DrawUnit( RECT rcCut, BOOL bFront )
{
	int i, j;

	// ˸Ч
	if( DRAW_BLINK_nID != MAP_DATA_NONE )
	{
		if( DRAW_BLINK_bDraw == TRUE )
		{	// ʾʱ
			if( DRAW_BLINK_nDelay < DRAW_BLINK_DELAY1 )
			{
				DRAW_BLINK_nDelay++;
			}
			else
			{	// ʱ䵽
				DRAW_BLINK_nDelay = 0;
				DRAW_BLINK_bDraw = FALSE;
			}
		}
		else
		{	// ʱ
			if( DRAW_BLINK_nDelay < DRAW_BLINK_DELAY2 )
			{
				DRAW_BLINK_nDelay++;
			}
			else
			{	// ʱ䵽
				DRAW_BLINK_nDelay = 0;
				DRAW_BLINK_bDraw = TRUE;
				DRAW_BLINK_nCounter++;

				if( DRAW_BLINK_nCounter >= DRAW_BLINK_COUNT )
				{	// ˸
					struct UNIT_STRUCT *pU = MAP_GetUnit( DRAW_BLINK_nID );
					Assert( pU );
					DRAW_BLINK_nID = MAP_DATA_NONE;
					pU->Draw.bUpdate = DRAW_BLINK_nSave;
				}
			}
		}
	}// End of if( DRAW_BLINK_nID != MAP_DATA_NONE )

	// ʾսڵеԪ
	// ~40ms
	for( j=DRAW_rcScreen.top; j<DRAW_rcScreen.bottom; j++ )
	for( i=DRAW_rcScreen.left; i<DRAW_rcScreen.right; i++ )
	{
		DRAW_DrawSingleU( &rcCut, i, j, bFront );
	}   
}

// Ƿʽ
extern MAIN_bRelease; // defined in CBMain.cpp
void DrawHZ( class CDDSurface * pSurface )
{
	HDC hdc=0;
	BOOL bUpdate =FALSE;
	static char strSave[20]="";

	UpdateGFWI();

	if( MAIN_bRelease == TRUE )
		return;	

	if( strcmp( strSave, strCopyright )!= 0 )
	{
		tCopyright.GetDDSurface()->Erase();
		bUpdate = TRUE;
		OutputDebugString( strSave );
		OutputDebugString( "," );
		OutputDebugString( strCopyright );
		OutputDebugString( "\n" );

		tCopyright.MyTextOut( DD_GetBackBuffer(), 24, 460, strCopyright );

		strcpy( strSave, strCopyright );
		RECT rect;
		rect.left = 24;
		rect.top = 460;
		rect.right = rect.left + tCopyright.GetDDSurface()->GetSize().cx;
		rect.bottom = rect.top + tCopyright.GetDDSurface()->GetSize().cy;
		if( bUpdate )	DDC_UpdateScreen( &rect );
	}

}
/////////////////////

/////////////////////
// Ϸ浽α
// prcCut	:	õķΧΪNULL򿽱ս
void DRAW_DrawBack2BkGround( CONST RECT *prcCut /*=NULL */)
{
	POINT ptDest;
	RECT rcSrc;
	if( prcCut == NULL )
	{
		ptDest.x = ptDest.y = 0;
		SetRect( &rcSrc, DRAW_rcClient.left, 
				DRAW_rcClient.top, 
				DRAW_rcClient.right, 
				DRAW_rcClient.bottom ); 
	}
	else
	{
		ptDest.x = prcCut->left - DRAW_rcClient.left,
		ptDest.y = prcCut->top - DRAW_rcClient.top;
		SetRect( &rcSrc, prcCut->left, 
				prcCut->top, 
				prcCut->right, 
				prcCut->bottom ); 
	}
	// draw from backbuffer to bkGround surface
	DD_BltSurface( ptDest, DRAW_sBkGround.GetSurface(), &rcSrc, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );
}

// α浽Ϸ
// prcCut	:	õķΧΪNULL򿽱ս
void DRAW_DrawBkGround2Back( CONST RECT *prcCut/*= NULL*/ )
{
	// draw background
	// ~2.8ms
	POINT ptDest;
	RECT rcSrc;
	if( prcCut == NULL )
	{
		ptDest.x = DRAW_rcClient.left, ptDest.y = DRAW_rcClient.top;
		rcSrc.left = rcSrc.top =0, 
		rcSrc.right = DRAW_rcClient.right - DRAW_rcClient.left,
		rcSrc.bottom = DRAW_rcClient.bottom - DRAW_rcClient.top;
	}
	else
	{
		ptDest.x = prcCut->left, ptDest.y = prcCut->top;
		SetRect( &rcSrc, prcCut->left, 
				prcCut->top, 
				prcCut->right, 
				prcCut->bottom ); 
		OffsetRect( &rcSrc, -DRAW_rcClient.left, -DRAW_rcClient.top );
	}
	DD_BltSurface( ptDest, DD_GetBackBuffer(), &rcSrc, DRAW_sBkGround.GetSurface(), DDBLTFAST_NOCOLORKEY );
}
/////////////////////

/////////////////////
// ʾԪӰˮƵЧ֡ͼ
// ÿҪмʮ
// draw maps in every program cycle
#define	DRAW_CLOCK_CIRCLE	5
void DRAW_DrawMaps( void )
{
	if( !DRAW_bLoadMaps )	return;

	// draw background
	// S->S, no colorkey, 5.13ms, 195 frames/sec
	// ԭĵαʾϷı
	DRAW_DrawBkGround2Back( &DRAW_rcClient );

	// draw others lower than units
	DRAW_DrawOthersCOM( OTHER_TYPE_BLOOD );

	// draw units
	// 27 frames/sec, 37 ms
	DRAW_DrawUnit( DRAW_rcClient, TRUE );

	// draw others upper than units
	DRAW_DrawOthersBMP( OTHER_TYPE_FIRE );

//---	
	// draw blinking water
	// 2500 frames/sec, 0.4 ms
#ifndef	_DEBUG
	DRAW_FlipWater();
#endif

	// draw mouse dragging rectangle to back buffer
	// 1550 frames/sec, 0.645ms
	MOUSE_DrawDragRect();

	//	ÿֵѭ,Ϸػκ͵Ԫ,ػӰ,ӰϷ 
	// .
	// draw shadow, 
	// V->S, colorkey, 8.33ms, 120 frames/sec
	SHADOW_Update2Back();

	// ʾۼ˵֮󣬳һָʾ
	// 
	DRAW_DrawOthersMouse();

	// draw build surface
	BUILD_Draw( &DRAW_rcClient );

	// draw characters, should be at last
	// English:	5080 frames/sec, nearly 0ms consumed
	// Chinese:	4700 frames/sec, 0.213ms
	DrawHZ( NULL );

//---- begin clock session
// ڴֻʱnClkAttrĺű
	// ͼ
	// July 23, 1997
	static int nClock=0;
	int nClkAttr = nClock%DRAW_CLOCK_CIRCLE;
	if( nClkAttr == 1 )
	{
		// draw minimap only in back buffer
		MINI_Update( 0 );
	}
	nClock++;
//---- end clock session


//---- network only
	// July 23, 1997
//	GAME.bNetwork = TRUE;
	FACE_BlitCurrentMenu();

	// ͼµǰĻ
	// July 23, 1997
	if( nClkAttr == 1 )
	{
		// draw minimap only in back buffer
		MINI_Update( 2 );
	}

	// update to front buffer, S->S, no colorkey, 5.56ms, 180 frames/sec
	DDC_UpdateScreen( &DRAW_rcClient );

// DDBLTFAST_NOCOLORKEY
} // DRAW_DrawMaps()
/////////////////////

void UpdateGFWI()
{
	if( GFWI_bUpdate == TRUE )
	{
		char str[20];
		int nColor=97;
		itoa( GAME.Players[GAME.nMe].nGold, str, 10 );
		tGold.GetDDSurface()->Erase( nColor );
		tGold.MyTextOut( DD_GetBackBuffer(), 52, 21, str );
		itoa( GAME.Players[GAME.nMe].nFood, str, 10 );
		tFood.GetDDSurface()->Erase( nColor );
		tFood.MyTextOut( DD_GetBackBuffer(), 155, 21, str );
		itoa( GAME.Players[GAME.nMe].nWood, str, 10 );
		tWood.GetDDSurface()->Erase( nColor );
		tWood.MyTextOut( DD_GetBackBuffer(), 445, 21, str );
		itoa( GAME.Players[GAME.nMe].nIron, str, 10 );
		tIron.GetDDSurface()->Erase( nColor );
		tIron.MyTextOut( DD_GetBackBuffer(), 548, 21, str );

		RECT rect;
		rect.left = 52;
		rect.top = 21;
		rect.right = rect.left + tGold.GetDDSurface()->GetSize().cx+16;
		rect.bottom = rect.top + tGold.GetDDSurface()->GetSize().cy;
		DDC_UpdateScreen( &rect );
		rect.left = 155;
		rect.top = 21;
		rect.right = rect.left + tFood.GetDDSurface()->GetSize().cx+16;
		rect.bottom = rect.top + tFood.GetDDSurface()->GetSize().cy;
		DDC_UpdateScreen( &rect );
		rect.left = 445;
		rect.top = 21;
		rect.right = rect.left + tWood.GetDDSurface()->GetSize().cx+16;
		rect.bottom = rect.top + tWood.GetDDSurface()->GetSize().cy;
		DDC_UpdateScreen( &rect );
		rect.left = 548;
		rect.top = 21;
		rect.right = rect.left + tIron.GetDDSurface()->GetSize().cx+16;
		rect.bottom = rect.top + tIron.GetDDSurface()->GetSize().cy;
		DDC_UpdateScreen( &rect );

		GFWI_bUpdate = FALSE;
	}
}
