/////////////
//	CBEyes.cpp		:	v0020
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.2
//	Copyright (C)	:	1996 WayAhead Corporation 
//	v0010			:	Feb.26.1997
//	v0020			:	Apr.29.1997, add so many functions
/////////////
// implementation file
// This file is to give thinking methods information they need.
// so call them Eyes.
#include "stdafx.h"
#include "Assert.h"

#include "CBGame.h"
#include "CBMAP.h"
#include "CBCTrl.h"
#include "CBEyes.h"
#include "CBData.h"
#include "CBRDelay.h"

//added by tian yue
#include <math.h>

/////////////
// externals
// declared in CBMap.cpp
extern POINT MAP_ptSenser[2][MAP_SENSER_MAX][8*MAP_SENSER_MAX];
extern POINT MAP_ptLocation[2][MAP_LOCATION_MAX];
extern int MAP_nLocationNum[4];
/////////////

// ܲ
/////////////
// ȡñԪģҰڣԪID
// bFriend	:	룬0ȡеԪ1ȡҷԪ2ȡõзԪ
// wThis	:	룬ԪID
// pwArray	:	ԪID
// nNum		:	룬ҪԪʵʷصĵԪ
void EYE_GetUnitInSight( int bFriend, WORD wThis, WORD *pwArray, int *pnNum )
{
	struct UNIT_STRUCT *pUnit;
	int nSight;
	BOOL bOdd;
	int nX, nY, nNewX, nNewY;
	int nCounter=0;
	WORD codeUEx;
	WORD *pwCurrent;

	pUnit = MAP_GetUnit( wThis );
	Assert( pUnit );
	nSight = EYE_GetViewRange( &pUnit->Draw );
	bOdd = pUnit->Draw.nY%2;
	nX = pUnit->Draw.nX, nY = pUnit->Draw.nY;
	pwCurrent = pwArray;
	for( int i=0; i<nSight; i++ )
	for( int j=0; j<((i+1)<<3); j++ )
	{
		if( nCounter >= *pnNum )	break;
		nNewX = nX + MAP_ptSenser[bOdd][i][j].x;
		nNewY = nY + MAP_ptSenser[bOdd][i][j].y;
		if( EYE_IfOutOfRange( nNewX, nNewY ) )
			continue;
		codeUEx = MAP_GetUnitDataEx( nNewX, nNewY );
		if( codeUEx != MAP_DATA_NONE )
		{
			if( bFriend == 1 )
			{	// ֻѡҷ
				struct UNIT_STRUCT *p = MAP_GetUnit( codeUEx );
				Assert( p );
				if( pUnit->Draw.nPlayer != p->Draw.nPlayer )
				{	// ǵзԹ
					continue;
				}
				if( EYE_IfUnitIsDead( p ) )	continue;
			}
			else if( bFriend == 2 )
			{	// ֻѡ
				struct UNIT_STRUCT *p = MAP_GetUnit( codeUEx );
				Assert( p );
				if( EYE_PlayerIsAllied( pUnit->Draw.nPlayer, p->Draw.nPlayer )	)
				{// ͬߣԹ
					continue;
				}
				if( pUnit->Status.nTaskID == MFU )
				{// ò
					continue;
				}

				//add by tian yue

				if( EYE_IfUnitIsDead( p ) )	continue;
			}
			*pwCurrent = codeUEx;
			nCounter++;
			pwCurrent++;
		}
	}
	*pnNum = nCounter;
}

// ȡñӵԪID
// bFriend	:	룬0ȡеԪ1ȡҷԪ2ȡõзԪ
// wThis	:	룬ԪID
// pwArray	:	ԪID
// nNum		:	룬ҪԪʵʷصĵԪ
void EYE_GetUnitInGroup( int bFriend, WORD wThis, WORD *pwArray, int *pnNum )
{
	struct UNIT_STRUCT *pUnit;
	int nPlayer;
	BOOL bOdd;
	int nX, nY;
	int nCounter=0;
	WORD codeUEx;
	WORD *pwCurrent;

	pUnit = MAP_GetUnit( wThis );
	Assert( pUnit );
	nPlayer = pUnit->Draw.nPlayer;
	if( EYE_IfUnitIsSoldier( pUnit ) )
	{
		if( pUnit->Soldier.nGenID == MAP_DATA_NONE )
		{
			*pnNum = 0;
			return;
		}
		wThis = pUnit->Soldier.nGenID;	// Լɽ
		pUnit = MAP_GetUnit( wThis );
		Assert( pUnit );
		Assert( pUnit->nType == MAP_UNIT_TYPE_GEN
			|| pUnit->nType == MAP_UNIT_TYPE_WGEN
			|| pUnit->nType == MAP_UNIT_TYPE_SGEN );
	}

	bOdd = pUnit->Draw.nY%2;
	nX = pUnit->Draw.nX, nY = pUnit->Draw.nY;
	pwCurrent = pwArray;
	for( int i=0; i<GENERAL_TROOP_MAX; i++ )
	{
		if( nCounter >= *pnNum )	break;
		codeUEx = pUnit->Gen.wTroop[i];
		if( codeUEx != MAP_DATA_NONE )
		{
			if( bFriend == 1 )
			{	// ֻѡҷ
				struct UNIT_STRUCT *p = MAP_GetUnit( codeUEx );
				Assert( p );
				if( pUnit->Draw.nPlayer != p->Draw.nPlayer )
				{	// ǵзԹ
					continue;
				}
				if( EYE_IfUnitIsDead( p ) )	continue;
			}
			else if( bFriend == 2 )
			{	// ֻѡ
				struct UNIT_STRUCT *p = MAP_GetUnit( codeUEx );
				Assert( p );
				if( EYE_PlayerIsAllied( pUnit->Draw.nPlayer, p->Draw.nPlayer )	)
				{// ͬߣԹ
					continue;
				}
				if( EYE_IfUnitIsDead( p ) )	continue;
			}
			*pwCurrent = codeUEx;
			nCounter++;
			pwCurrent++;
		}
	}
	*pnNum = nCounter;
}

// ĿĵԪǷҰ
// wThis	:	ԪID
// wThat	:	ĿĵԪID
// nRange	:	ҰΧȱʡ-1ʱΪһԪҰ
// return	:	-1,Ұ,0-7Ƿ
int EYE_IfUnitIsInSight( WORD wThis, WORD wThat, int nRange/*= -1*/ )
{
	struct UNIT_STRUCT *pUnit, *pUnit2;
	int nSight;
	int nX, nY, bOdd, nXNext, nYNext;
	
	pUnit = MAP_GetUnit( wThis );
	Assert( pUnit );
	pUnit2 = MAP_GetUnit( wThat );
	Assert( pUnit2 );

	if( pUnit2->Status.bIRQ == TRUE 
		&& !EYE_IfUnitIsBuild( pUnit2 ) )	// ʿڽ֮У
		return -1;

	if( nRange > 10 )
	{
		if( pUnit->Draw.nX > pUnit2->Draw.nX-nRange 
			&& pUnit->Draw.nY > pUnit2->Draw.nY-nRange 
			&& pUnit->Draw.nX < pUnit2->Draw.nX+nRange 
			&& pUnit->Draw.nY < pUnit2->Draw.nY+nRange )
		{
			return 1;
		}
		else
			return -1;
	}
	else if( nRange == - 1 )
		nSight = EYE_GetViewRange( &pUnit->Draw );
	else
		nSight = nRange;

	bOdd = pUnit->Draw.nY%2;
	nX = pUnit->Draw.nX, nY = pUnit->Draw.nY;
	
	for( int i=0; i<nSight; i++ )
	for( int j=0; j<((i+1)<<3); j++ )
	{
		nXNext = nX + MAP_ptSenser[bOdd][i][j].x,
		nYNext = nY + MAP_ptSenser[bOdd][i][j].y;
		if( EYE_IfOutOfRange( nXNext, nYNext ) )
			continue;
		WORD codeUEx = MAP_GetUnitDataEx( nXNext, nYNext );
		if( codeUEx == wThat )
			return (j>>i);
	}	
	return -1;
}

// ĿĵԪǷڹΧ
// wThis	:	ԪID
// wThat	:	ĿĵԪID
// nRange	:	ӲԹ涨жΧȱʡʱΪӵĹΧ
// return	:	-1,,0-7Ƿ
int EYE_IfUnitIsInRange( WORD wThis, WORD wThat, int nRange/* = -1*/ )
{
	struct UNIT_STRUCT *pUnit, *pUnit2;
	int nX, nY, bOdd, nXNext, nYNext, bOdd2;
	
	pUnit = MAP_GetUnit( wThis );
	Assert( pUnit );
	pUnit2 = MAP_GetUnit( wThat );
	Assert( pUnit2 );
	
	if( pUnit2->nHasShadow == FALSE 
		&& !EYE_IfUnitIsBuild( pUnit2 ) )	// ʿڽ֮У
		return -2;

	// жΧΪʱΪӵĹΧ
	if( nRange == -1 )
	{
		nRange = DATA_Lib.Unit[pUnit->Draw.nFile].nFightRange;
		if( CTRL_GetSTG( &pUnit->Draw, GUNMU ) == TRUE 
			&& (pUnit->Draw.nFile == 32 || pUnit->Draw.nFile == 45) )
		{	// ʹùľıΧҰ
			nRange = DATA_Lib.Unit[pUnit->Draw.nFile].nViewRange;
		}
	}

	bOdd = pUnit->Draw.nY&1;
	nX = pUnit->Draw.nX, nY = pUnit->Draw.nY;

	// Զ̹ӣֻжʵڵλãԼӿжٶ
	if( nRange > 1 )
	{
		for( int i=0; i<nRange; i++ )
		for( int j=0; j<((i+1)<<3); j++ )
		{
			nXNext = nX + MAP_ptSenser[bOdd][i][j].x,
			nYNext = nY + MAP_ptSenser[bOdd][i][j].y;
			if( EYE_IfOutOfRange( nXNext, nYNext ) )
				continue;
			WORD codeUEx = MAP_GetUnitDataEx( nXNext, nYNext );
			if( codeUEx == wThat )
			{	// õ
				j = j/(i+1);
				return j;
			}
		}
	}
	else
	{	// ڽ̹ӣҪжϸòռݵе
		for( int x=0; x< MAP_nLocationNum[pUnit->Draw.nLocationSize]; x++ )
		{
			nX = pUnit->Draw.nX+MAP_ptLocation[bOdd][x].x, 
			nY = pUnit->Draw.nY+MAP_ptLocation[bOdd][x].y;
			if( EYE_IfOutOfRange( nX, nY ) )
				continue;
			bOdd2 = nY&1;
			for( int j=0; j<8; j++ )
			{
				nXNext = nX + MAP_ptSenser[bOdd2][0][j].x,
				nYNext = nY + MAP_ptSenser[bOdd2][0][j].y;
				if( EYE_IfOutOfRange( nXNext, nYNext ) )
					continue;
				WORD codeUEx = MAP_GetUnitDataEx( nXNext, nYNext );
				if( codeUEx == wThat )
					return j;
			}
		}
	}
	return -1;
}

// ĿλǷĳԪλһΧ
// pUnit		:	ĵԪ
// nEndX, nEndY	:	Ŀĵλ
// return		:	-1,,0-7Ƿ
int EYE_IfShipYardIsInRange( struct UNIT_STRUCT *pUnit, int nEndX, int nEndY )
{
	BOOL bOdd = pUnit->Draw.nY&1;
	BOOL bOdd2 = nEndY&1;
	WORD codeG;
	struct MAP_GROUND_CODE_STRUCT stctG;
	int nX, nY, nX2, nY2;
	for( int i=0; i<8; i++ )
	{
		nX = pUnit->Draw.nX+MAP_ptSenser[bOdd][0][i].x, 
		nY = pUnit->Draw.nY+MAP_ptSenser[bOdd][0][i].y;
		for( int j=0; j<9; j++ )
		{
			nX2 = nEndX + MAP_ptLocation[bOdd2][j].x,
			nY2 = nEndY + MAP_ptLocation[bOdd2][j].y;
			if( nX == nX2 && nY == nY2 )
				return i;
		}

		codeG = MAP_GetGroundData( 0, nX, nY );
		Assert( codeG!= MAP_DATA_NONE );
		MAP_GroundDeCode( codeG, &stctG );
		if( stctG.nFile == 3 )// 
			return i;
	}
	return -1;
}
/////////////


/////////////
// õԪǷЧ
inline BOOL EYE_IfUnitIsUnit( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType != MAP_UNIT_TYPE_NONE )		// 
	{
		return TRUE;
	}
	return FALSE;
}

// õԪǷǽ
inline BOOL EYE_IfUnitIsBuild( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_BUILDING		// 
		|| pUnit->nType == MAP_UNIT_TYPE_RESOURCE	// Դ
		|| pUnit->nType == MAP_UNIT_TYPE_FLAG 		// 
		|| pUnit->nType == MAP_UNIT_TYPE_SHIPYARD	// 
		)
	{
		return TRUE;
	}
	return FALSE;
}

// õԪǷǽ
inline BOOL EYE_IfUnitIsGen( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_GEN 
		|| pUnit->nType == MAP_UNIT_TYPE_WGEN 
		|| pUnit->nType == MAP_UNIT_TYPE_SGEN )		// 
	{
		return TRUE;
	}
	return FALSE;
}

// õԪǷĽ
inline BOOL EYE_IfUnitIsWorkerGen( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	//if( pUnit->Draw.nFile == 29 )		// Ľ
	if( pUnit->nType == MAP_UNIT_TYPE_WGEN )		// 
	{
		return TRUE;
	}
	return FALSE;
}

// õԪǷǹ
inline BOOL EYE_IfUnitIsWorker( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_WORKER )	// 
	{
		return TRUE;
	}
	return FALSE;
}

// õԪǷƽ
inline BOOL EYE_IfUnitIsMan( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_MAN )		// ƽ
	{
		return TRUE;
	}
	return FALSE;
}

// õԪǷԴ
inline BOOL EYE_IfUnitIsRes( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_RESOURCE )// Դ
	{
		return TRUE;
	}
	return FALSE;
}

// õԪǷͼ
inline BOOL EYE_IfUnitIsSpec( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_SPECIAL )	// ͼ
	{
		return TRUE;
	}
	return FALSE;
}

// õԪǷSoldier򣬿齨ɲ
inline BOOL EYE_IfUnitIsSoldier( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_SOLDIER		// ʿ
		|| pUnit->nType == MAP_UNIT_TYPE_SHIP 		// ս
		|| pUnit->nType == MAP_UNIT_TYPE_LADDER 	// 
		|| pUnit->nType == MAP_UNIT_TYPE_WORKER		// 
		|| pUnit->nType == MAP_UNIT_TYPE_MAN		// ƽ
		)
	{
		return TRUE;
	}
	return FALSE;
}

// õԪǷƶ
inline BOOL EYE_IfUnitIsMovable( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_SOLDIER		// ʿ
		|| pUnit->nType == MAP_UNIT_TYPE_SHIP 		// ս
		|| pUnit->nType == MAP_UNIT_TYPE_LADDER 	// 
		|| pUnit->nType == MAP_UNIT_TYPE_GEN 		// 
		|| pUnit->nType == MAP_UNIT_TYPE_SGEN 		// ˮ
		|| pUnit->nType == MAP_UNIT_TYPE_WGEN 		// Ľ
		|| pUnit->nType == MAP_UNIT_TYPE_MAN 		// ƽ
		|| pUnit->nType == MAP_UNIT_TYPE_WORKER		// 
		)
	{
		return TRUE;
	}
	return FALSE;
}

// 鿴õԪǷǹ
inline BOOL EYE_IfUnitIsArcher( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->Draw.nFile == 33
		|| pUnit->Draw.nFile == 45
		|| pUnit->Draw.nFile == 39
		|| pUnit->Draw.nFile == 42
		|| pUnit->Draw.nFile == 44 )
	{
		return TRUE;
	}
	return FALSE;
}

// 鿴õԪǷǼ¥
inline BOOL EYE_IfUnitIsTower( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->Draw.nFile == 18
		|| pUnit->Draw.nFile == 19 )
	{
		return TRUE;
	}
	return FALSE;
}

// 鿴õԪǷǴ
inline BOOL EYE_IfUnitIsShip( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_SHIP 
		|| pUnit->nType == MAP_UNIT_TYPE_SGEN )
		return TRUE;
	return FALSE;
}

// 鿴õԪǷս
inline BOOL EYE_IfUnitIsBattleShip( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( (pUnit->nType == MAP_UNIT_TYPE_SHIP
		|| pUnit->nType == MAP_UNIT_TYPE_SGEN )
		&& pUnit->Draw.nFile != 47 )	// 䴬
		return TRUE;
	return FALSE;
}

// 鿴õԪǷ䴬
inline BOOL EYE_IfUnitIsTransport( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->Draw.nFile == 47 )	// 䴬
		return TRUE;
	else
		return FALSE;
}

// 鿴õԪǷͶʯ
inline BOOL EYE_IfUnitIsCatapult( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->Draw.nFile == 34 )	// 
		return TRUE;
	return FALSE;
}

// 鿴õԪǷ
inline BOOL EYE_IfUnitIsCavalry( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->Draw.nFile == 36		// 100
		|| pUnit->Draw.nFile == 37	// 200
		|| pUnit->Draw.nFile == 40	// 500
		|| pUnit->Draw.nFile == 35 )// ｫ
		return TRUE;
	return FALSE;
}

// 鿴õԪǷǳ
inline BOOL EYE_IfUnitIsDoor( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->Draw.nFile == 16 
		|| pUnit->Draw.nFile == 17 )
		return TRUE;
	return FALSE;
}
/////////////

/////////////
// 鿴Ƿͬ
// Ҫ޸ģAug 20, 1997
// nPlayer1, nPlayer2	:	Ϸ
// return	:	TRUE if is
inline BOOL EYE_PlayerIsAllied( int nPlayer1, int nPlayer2 )
{
	if( nPlayer1 == nPlayer2 )	return TRUE;
	if( GAME.Players[nPlayer1].nAllies[nPlayer2] == TRUE )
	{
		Assert( GAME.Players[nPlayer2].nAllies[nPlayer1] == TRUE );
		return TRUE;
	}
/*
	for( int i=0; i< GAME_PLAYER_MAX; i++ )
	{
		if( GAME.Players[nPlayer1].nAllies[i] == nPlayer2 )
		{
			return TRUE;
		}
	}
*/
	return FALSE;
}

// 鿴Ƿ񳬹ĵͼĽ
inline BOOL EYE_IfOutOfRange( int nX, int nY )
{
	// 0Ϊ3July 18, 1997
	if( nX <= 1 || nX >= MAP_Lib.szNum.cx-1 || nY <= 3 || nY >= MAP_Lib.szNum.cy-3 )
		return TRUE;
	return FALSE;
}

// 鿴õԪǷѾ
inline BOOL EYE_IfUnitIsDead( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->nType == MAP_UNIT_TYPE_NONE
		|| pUnit->Status.nTaskID == SHANCHU )
		return TRUE;
	return FALSE;
}

// 鿴õԪǷԼ
inline BOOL EYE_IfSheIsMine( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( pUnit->Draw.nPlayer == GAME.nMe )
		return TRUE;
	return FALSE;
}

// 鿴ǷõԪڽ״̬
extern int DRAW_BLINK_nSave;	// defined in CBDraw.cpp
inline BOOL EYE_IfFocusOnUnit( struct UNIT_STRUCT *pUnit )
{
	if( pUnit->Draw.bUpdate >= 5 
		&& DRAW_BLINK_nSave == 0 )
	{
		return FALSE;
	}
	return pUnit->Draw.bUpdate;
}

// 鿴õԪǷ񵽴Ŀĵ
inline int	EYE_IfArrived( struct UNIT_STRUCT *pUnit )
{
	struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;
	int bOdd = pDraw->nY&1;
	int nNum = MAP_nLocationNum[pDraw->nLocationSize];
	int nNewX, nNewY;
	WORD codeUEx;

	for( int i=0; i< nNum; i++ )
	{
		nNewX = pDraw->nX+MAP_ptLocation[bOdd][i].x;
		nNewY = pDraw->nY+MAP_ptLocation[bOdd][i].y;
		codeUEx = MAP_GetUnitDataEx( nNewX, nNewY ) ;
		// test if there is some one (not me) in front of me
		if( codeUEx != MAP_DATA_NONE && 
			codeUEx != pUnit->nID )
		{
			if( pUnit->Status.nTaskIDEx == 2	// ĿĵǵԪ
				&& pUnit->Status.nParam1 == codeUEx )	
			{
				return TRUE;
			}
		}
	}
	return FALSE;	// someone blocked him
}

// 鿴õεǷеԴ
// 
// nZ, nX, nY	:	position on ground map
// return		:	resource type
inline int EYE_GetGResType( int nZ, int nX, int nY )
{
	WORD codeG = MAP_GetGroundData( nZ, nX, nY );
	struct MAP_GROUND_CODE_STRUCT stctG;
	MAP_GroundDeCode( codeG, &stctG );
	if( stctG.nAttr == 0 ) return SHULIN;	// 
	if( stctG.nAttr == 1 ) return MAITIAN;	// 
	return QXZIYUAN;	// Ч
}

// õԪǷԴ
// ڽ֡ҲΪԴ
// return	:	ظԴͣһǽͣΪQXZIYUANʱЧ
inline int EYE_GetUResType( struct UNIT_STRUCT *pUnit, int nPlayer )
{
	if( pUnit->Draw.nFile == 22 )	return TIEKUANG;	// 
	if( pUnit->Draw.nFile == 24
		|| pUnit->Draw.nFile == 25 )	return MINJU;	// 
	// ˵
	if( nPlayer ==-1 )	return QXZIYUAN;	// debug only
	if( (pUnit->Draw.nFile == 10
		|| pUnit->Draw.nFile == 11)
		&& pUnit->Draw.nPlayer != nPlayer )	return LIANGCANG;	
	return QXZIYUAN;
}

// 鿴һΧǷԴֻѰҵԴ
// nFind	:	ҪҵԴ
// return	:	ҵԴķ0-7Ϊ-1ʱЧ
inline int EYE_IfResIsInRange( struct UNIT_STRUCT *pUnit, int nFind )
{
	// ڽ̹ӣҪжϸòռݵе
	int bOdd;
	int nXNext, nYNext;
	int nGet;

	Assert( pUnit->Draw.nLocationSize == 0 );

	bOdd = pUnit->Draw.nY&1;
	for( int i=0 ;i<8; i++ )
	{
		nXNext = pUnit->Draw.nX + MAP_ptSenser[bOdd][0][i].x,
		nYNext = pUnit->Draw.nY + MAP_ptSenser[bOdd][0][i].y;
		if( EYE_IfOutOfRange( nXNext, nYNext ) )
			continue;
		nGet = EYE_GetGResType( pUnit->Draw.nLayer, nXNext, nYNext );
		if( nGet == nFind )
		{	// ҪԴ
			return i;
		}
	}
	return -1;
}

// 鿴ҰΧǷԴֻѰҵԴ
// nZ,nX, nY	:	ʼλ
// nSight		:	Ұ
// nFind		:	ҪҵԴ
// return		:	ҵԴλãnXnYʱΪδҵ
inline POINT EYE_IfResIsInSight( int nZ, int nX, int nY, int nSight, int nFind )
{
	// ڽ̹ӣҪжϸòռݵе
	POINT pt;
	int bOdd;
	int nXNext, nYNext;
//	int nSight;
	int nGet;

//	nSight = DATA_Lib.Unit[pUnit->Draw.nFile].nViewRange;
	pt.x = nX, pt.y = nY;
	bOdd = nY&1;

	for( int i=0; i<nSight; i++ )
	for( int j=0; j<((i+1)<<3); j++ )
	{
		nXNext = nX + MAP_ptSenser[bOdd][i][j].x,
		nYNext = nY + MAP_ptSenser[bOdd][i][j].y;
		if( EYE_IfOutOfRange( nXNext, nYNext ) )
			continue;
		nGet = EYE_GetGResType( nZ, nXNext, nYNext );
		if( nGet == nFind )
		{
			pt.x = nXNext,pt.y = nYNext;
			return pt;
		}
	}
	return pt;
}

// Ѱļ
// nPlayer	:	
// nType	:	0, ڴʳĹˣ˧ʣ
//				1, ڴľĵĹˣ˧ʣľ
// return	:	building ID, MAP_DATA_NONEΪû
inline WORD EYE_FindNearestHome( int nPlayer, int nType )
{
	int n2, n3;
	if( nType == 0 )
	{
		n2 = 10, n3 = 11;
	}
	else
	{
		n2 = 4, n3 = 5;
	}

	struct UNIT_STRUCT *pUnit;
	for( int i=0; i< GAME.Players[nPlayer].wUnitCounter; i++ )
	{
		pUnit = &GAME.Players[nPlayer].Unit[i];
		if( !EYE_IfUnitIsDead( pUnit ) 
			&& (pUnit->Draw.nFile == 0 
				|| pUnit->Draw.nFile == 1
				|| pUnit->Draw.nFile == n2
				|| pUnit->Draw.nFile == n3) )
		{
			return pUnit->nID;
		}
	}
	return MAP_DATA_NONE;
}

// õýǷԽԴ
// pU		:	Ľ
// return	:	ԽܵԴͣQXZIYUANΪЧ
inline int EYE_GetUResHome( struct UNIT_STRUCT *pU )
{
	if( pU->Draw.nFile == 0 || pU->Draw.nFile == 1 )
		return SUOYOUZY;
	if( pU->Draw.nFile == 2	|| pU->Draw.nFile == 3 )
		return TIEKUANG;
	if( pU->Draw.nFile == 4 || pU->Draw.nFile == 5 )
		return SHULIN;
	if( pU->Draw.nFile == 10 || pU->Draw.nFile == 11 )
		return MAITIAN;
	return QXZIYUAN;
}

// õԪʿ𣬹١У
// return	:	-1 ñûʿ
inline int EYE_GetUnitPerson( struct UNIT_STRUCT *pU )
{
	int nPerson = -1;
	switch( pU->Draw.nFile )
	{
	case	32:	// 100
	case	36:	// 100
	case	45:	// 100
	case	46:	// Сս
		nPerson = 0;
		break;
	case	37:	// 200
	case	38:	// 200
	case	39:	// 200
	case	48:	// ս
		nPerson = 1;
		break;
	case	40:	// 500
	case	41:	// 500
	case	42:	// 500
		nPerson = 2;
		break;
	case	43:	// 1000
	case	44:	// 1000
		nPerson = 3;
		break;
	}
	return nPerson;
}
/////////////

/////////////
// õĳԪȫֵ
// nPlayer	:	ϷΪ-1ʱӸֵ
// nFile	:	ļ
inline int EYE_GetFullLife( int nPlayer, int nFile )
{
	int nLife;
	nLife = (int)DATA_Lib.Unit[nFile].dwLife;
	if( nPlayer < 0 )	return nLife;					// õԭʼѪ
	if( nFile == 18 || nFile == 19 )	return nLife;	// ¥ԶѪ
	if( nFile < 27 )
		nLife += GAME.Players[nPlayer].dwLifeUp;		// Ѫ
	if( nFile == 52 )	return nLife>>1;				// 콢Ѫ
	return nLife;
}

// 鿴õεǷˮ
inline int EYE_GetWater(int nZ, int nX,int nY)
{
	WORD codeG = MAP_GetGroundData( nZ, nX, nY );
	struct MAP_GROUND_CODE_STRUCT stctG;
	MAP_GroundDeCode( codeG, &stctG );

	if( stctG.nFile == 3 )
	{
		if (stctG.nCol != 12)
		{
			return TRUE;
		}
	}
	return FALSE;
}

// õĳԪĽ죬޻ǷʱΪ
inline struct UNIT_STRUCT *EYE_GetGeneral( struct UNIT_STRUCT * pUnit )
{
	struct UNIT_STRUCT *pU = NULL;
	// ʿҪĽ
	if( EYE_IfUnitIsSoldier( pUnit ) 
		&& pUnit->Soldier.nGenID != MAP_DATA_NONE )
	{
		pU = MAP_GetUnit( pUnit->Soldier.nGenID );
	}
	else if( EYE_IfUnitIsGen( pUnit ) )
		pU = pUnit;
	return pU;
}

// õ̹
inline int EYE_GetNearAttack( struct UNIT_STRUCT *pUnit )
{
	int nAttack;
	if( EYE_IfUnitIsGen( pUnit ) )
	{
		nAttack = EYE_GetWuLi( pUnit->Gen.nID )*DATA_Lib.Unit[pUnit->Draw.nFile].nNearAttack/100;
	}
	else
	{
		int nPerson = EYE_GetUnitPerson( pUnit );
		nAttack = DATA_Lib.Unit[pUnit->Draw.nFile].nNearAttack
			+GAME.Players[pUnit->Draw.nPlayer].nAddNearAttack[nPerson];// ʿĸӹ
	}

	// 
	struct UNIT_STRUCT *pUG = EYE_GetGeneral( pUnit );
	if( pUG && pUG != pUnit )
	{
//		nAttack = int(nAttack*(
//			1+(DATA_Lib.Gen[pUG->Gen.nID].nWuLi*
//			DATA_Lib.Unit[pUG->Draw.nFile].nNearAttack/100.0
//			-70)/70.0+(EYE_GetMorale(pUG)-70)/300.0
//			));
		nAttack = int(nAttack*(
			1+(DATA_Lib.Gen[pUG->Gen.nID].nWuLi
			-70)/70.0+(EYE_GetMorale(pUG)-70)/200.0
			));
	}
	return nAttack;
}

// õԶ̹
inline int EYE_GetFarAttack( struct UNIT_STRUCT *pUnit )
{
	int nAttack;
	if( EYE_IfUnitIsGen( pUnit ) )
	{
		nAttack = EYE_GetWuLi( pUnit->Gen.nID )*DATA_Lib.Unit[pUnit->Draw.nFile].nFarAttack/100;
	}
	else if( EYE_IfUnitIsCatapult( pUnit ) )
	{
		nAttack = DATA_Lib.Unit[pUnit->Draw.nFile].nFarAttack
			+GAME.Players[pUnit->Draw.nPlayer].nAddSFarAttack;	// Ͷʯĸӹ
	}
	else if( EYE_IfUnitIsBattleShip( pUnit ) )
	{
		int nPerson = EYE_GetUnitPerson( pUnit );
		Assert( nPerson < 2 );
		nAttack = DATA_Lib.Unit[pUnit->Draw.nFile].nFarAttack
			+GAME.Players[pUnit->Draw.nPlayer].nAddWaterAttack[nPerson];	// սĸӹ
	}
	else
	{
		int nPerson = EYE_GetUnitPerson( pUnit );
		nAttack = DATA_Lib.Unit[pUnit->Draw.nFile].nFarAttack
			+GAME.Players[pUnit->Draw.nPlayer].nAddFarAttack[nPerson];// ʿĸӹ
	}
	// 
	struct UNIT_STRUCT *pUG = EYE_GetGeneral( pUnit );
	if( pUG && pUG != pUnit )
	{
//		nAttack = int(nAttack*(
//			1+(DATA_Lib.Gen[pUG->Gen.nID].nWuLi*
//			DATA_Lib.Unit[pUG->Draw.nFile].nNearAttack/100.0
//			-70)/70.0+(EYE_GetMorale(pUG)-70)/300.0
//			));
		nAttack = int(nAttack*(
			1+(DATA_Lib.Gen[pUG->Gen.nID].nWuLi
			-70)/70.0+(EYE_GetMorale(pUG)-70)/200.0
			));
	}
	return nAttack;
}

// õ̷
inline int EYE_GetNearDefend( struct UNIT_STRUCT *pU )
{
	int nDefend;
	if( EYE_IfUnitIsGen( pU ) )
	{
		nDefend = DATA_Lib.Gen[pU->Gen.nID].nWuLi*DATA_Lib.Unit[pU->Draw.nFile].nNearDefend/100;
	}
	else if( EYE_IfUnitIsBattleShip( pU ) )
	{
		int nPerson = EYE_GetUnitPerson( pU );
		Assert( nPerson < 2 );
		nDefend = DATA_Lib.Unit[pU->Draw.nFile].nNearDefend
			+GAME.Players[pU->Draw.nPlayer].nAddWaterDefend[nPerson];	// սĸӷ
	}
	else
	{
		int nPerson = EYE_GetUnitPerson( pU );
		nDefend = DATA_Lib.Unit[pU->Draw.nFile].nNearDefend;
		if( nDefend != -1 )
		{
			nDefend += GAME.Players[pU->Draw.nPlayer].nAddNearDefend[nPerson];// Զʿĸӷ
		}
	}

	// 
	struct UNIT_STRUCT *pUG = EYE_GetGeneral( pU );
	if( pUG && pUG != pU )
	{
//		nDefend = int(nDefend*(
//			1+(DATA_Lib.Gen[pUG->Gen.nID].nWuLi*
//			DATA_Lib.Unit[pUG->Draw.nFile].nNearDefend/100.0
//			-70)/70.0+(EYE_GetMorale(pUG)-70)/300.0
//			));
		nDefend = int(nDefend*(
			1+(DATA_Lib.Gen[pUG->Gen.nID].nWuLi
			-70)/70.0+(EYE_GetMorale(pUG)-70)/200.0
			));
		if( nDefend == 0 ) nDefend = 1;
	}
	return nDefend;
}

// õԶ̷
inline int EYE_GetFarDefend( struct UNIT_STRUCT *pUnit )
{
	int nDefend;
	if( EYE_IfUnitIsGen( pUnit ) )
	{
		nDefend = DATA_Lib.Gen[pUnit->Gen.nID].nWuLi*DATA_Lib.Unit[pUnit->Draw.nFile].nFarDefend/100;
	}
	else if( EYE_IfUnitIsBattleShip( pUnit ) )
	{
		int nPerson = EYE_GetUnitPerson( pUnit );
		Assert( nPerson < 2 );
		nDefend = DATA_Lib.Unit[pUnit->Draw.nFile].nFarDefend
			+GAME.Players[pUnit->Draw.nPlayer].nAddWaterDefend[nPerson];	// սĸӷ
	}
	else
	{
		int nPerson = EYE_GetUnitPerson( pUnit );
		nDefend = DATA_Lib.Unit[pUnit->Draw.nFile].nFarDefend;
		if( nDefend != -1 )
		{
			nDefend += GAME.Players[pUnit->Draw.nPlayer].nAddFarDefend[nPerson];// Զʿĸӷ
		}
	}
	// 
	struct UNIT_STRUCT *pUG = EYE_GetGeneral( pUnit );
	if( pUG && pUG != pUnit )
	{
//		nDefend = int(nDefend*(
//			1+(DATA_Lib.Gen[pUG->Gen.nID].nWuLi*
//			DATA_Lib.Unit[pUG->Draw.nFile].nFarDefend/100.0
//			-70)/70.0+(EYE_GetMorale(pUG)-70)/300.0
//			));
		nDefend = int(nDefend*(
			1+(DATA_Lib.Gen[pUG->Gen.nID].nWuLi
			-70)/70.0+(EYE_GetMorale(pUG)-70)/200.0
			));
		if( nDefend == 0 ) nDefend = 1;
	}
	return nDefend;
}

// test if there is the bank of the water around the unit
// nLayer	:	layer of the unit
// nStartX, nStartY	:	position of the unit
// nLocationSize	:	location size of the unit
// return			:	TRUE if there is bank
BOOL EYE_IfNearBank( int nLayer, int nStartX, int nStartY, int nLocationSize )
{
	WORD codeG;
	struct MAP_GROUND_CODE_STRUCT stctG;
	BOOL bOdd = nStartY&1;
	BOOL bOdd2;
	int nX, nY, nX2, nY2;
	BOOL bBank = FALSE;
	for( int j=0; j<MAP_nLocationNum[nLocationSize]; j++ )
	{
		nX = nStartX+MAP_ptLocation[bOdd][j].x,
		nY = nStartY+MAP_ptLocation[bOdd][j].y;
		if( EYE_IfOutOfRange( nX, nY ) )
			continue;
		bOdd2 = nY&1;
		for( int i=0; i< 8; i++ )
		{	
			nX2 = nX + MAP_ptSenser[bOdd2][0][i].x;
			nY2 = nY + MAP_ptSenser[bOdd2][0][i].y;
			if( EYE_IfOutOfRange( nX2, nY2 ) )
				continue;
			codeG = MAP_GetGroundData( nLayer, nX2, nY2 );
			Assert( codeG != MAP_DATA_NONE );
			MAP_GroundDeCode( codeG, &stctG );
			// ڰ
			if( stctG.nFile == 3 && stctG.nCol != 12 )
			{	
				bBank = TRUE;
				break;
			}
		}
		if( bBank == TRUE ) break;
	}
	return bBank;
}

// òǷм
// pU		:	ĵԪ
// nJiMou	:	ļı
inline BOOL EYE_IfInSTG( struct UNIT_STRUCT *pU, CTRL_JIMOU nJiMou )
{
	if( pU->Draw.nSTG[nJiMou] == 1 )
		return TRUE;
	return FALSE;
}

// õʿ
#define	EYE_MORALE_ADD	50
inline BYTE EYE_GetMorale( struct UNIT_STRUCT *pU )
{
	Assert( EYE_IfUnitIsGen( pU ) );
	Assert( pU->Gen.nMorale>= 0 && pU->Gen.nMorale< 300 );
	if( pU != NULL && EYE_IfInSTG( pU, JILI ) )
		return pU->Gen.nMorale+EYE_MORALE_ADD;
	return pU->Gen.nMorale;
}

// õҰ
inline int  EYE_GetViewRange( struct CTRL_FRAME_STRUCT *pDraw )
{
	int nRange;
	if( pDraw->nSTG[YUANSHI] == 1 )
		nRange = 10;
	else 
		nRange = DATA_Lib.Unit[pDraw->nFile].nViewRange;
	return nRange;
}

// жϴ˵Ƿ񱻻
// nX, nY	:	
inline BOOL EYE_IfBurned( int nX, int nY )
{
	WORD codeR = MAP_GetRegionData( nX, nY );
	struct MAP_REGION_CODE_STRUCT stctR;
	MAP_RegionDeCode( codeR, &stctR );
	if( stctR.nPlayer == 1 )
		return TRUE;
	return FALSE;
}

// жʳǷܴ洢ˡֲ
// ϷID
inline BOOL EYE_IfFoodExceeded( int nPlayer )
{
	if( GAME.Players[nPlayer].nFood >=
		GAME.Players[nPlayer].nFoodStore*RUN_FOODSTORE_MAX )
	{	// ʳԴ˳
		return TRUE;
	}
	return FALSE;
}


inline int EYE_GetNewLevel( int nGenID )
{
	int nLevel = DATA_Lib.Gen[nGenID].nLevel;
	int nType = DATA_Lib.Gen[nGenID].nType-1;
	// ͵ƫ
	int nGenOff[4]={1,0,2,3};// 
	// ÿһ켶ƵĿʼλ
	int nStart[10] = {0, 4, 8, 10, 12, 14, 16, 20, 24, 28};
	// ÿһ켶Ƶĸ
	int nRange[10] = {4,4,2,2,2,2,4,4,4,1};
	int nNewLevel;

	if( nRange[nLevel] == 4 )
	{
		nNewLevel = nStart[nLevel]+nGenOff[nType];
	}
	else
	{
		nNewLevel = nStart[nLevel]+nType%nRange[nLevel];
	}
	return nNewLevel;
}
// õļ
// nGenID		:	ȷĽ쵥ԪĽID
// strLvlName	:	
// return		:	ƵID
inline int EYE_GetLevelName( int nGenID, LPSTR strLvlName )
{
	int nNewLevel = EYE_GetNewLevel( nGenID );
	strcpy( strLvlName, DATA_Lib.Grade[nNewLevel].strName );
	return nNewLevel;
}

// õ
// nGenID	:	ID
// return	:	ֵ
inline int EYE_GetWuLi( int nGenID )
{
	int nNewLevel = EYE_GetNewLevel( nGenID );
	return DATA_Lib.Gen[nGenID].nWuLi+DATA_Lib.Grade[nNewLevel].nAddWuLi;
}

// õ
// nGenID	:	ID
// return	:	ֵ
inline int EYE_GetZhiLi( int nGenID )
{
	int nNewLevel = EYE_GetNewLevel( nGenID );
	return DATA_Lib.Gen[nGenID].nZhiLi+DATA_Lib.Grade[nNewLevel].nAddZhiLi;
}

// жϸýǷʹĳı
inline BOOL EYE_IfJiMou( int nGenID, CTRL_JIMOU JiMou )
{
	int nStrategy[10] = {0x00, 0x01, 0x0181, 0x01C1, 0x01C9, 0x01CF, 0x01EF, 0x01FF, 0x01FF, 0x01FF};
	int comp = 1<<DATA_Lib.Gen[nGenID].nLevel;
	if( (comp & nStrategy[DATA_Lib.Gen[nGenID].nLevel]) == comp )
		return TRUE;
	return FALSE;
}

// жϸýǷԵ
inline BOOL EYE_IfFight( int nBlood1, int nPower1, int nBlood2, int nPower2 )
{
	int nHit1 = (int)(nBlood1*nPower1*(1+(nPower1-nPower2)*4/60.0)*6/1000.0);
	if( nHit1 >= nBlood2 )
	{	// з佫Ҫ
		int  i = getrandom(1,5);
		// Ȼ֮һĿͬⵥ
		if( i == 3 )
			return TRUE;
		return FALSE;
	}
	return TRUE;
}

// жĳϷǷѾ군
// nPlayer	:	жϷ
// nRun		:	ƶ
// return	:	ΪʱʾѾ군
inline BOOL EYE_IfPlayerIsOver( int nPlayer, int nRun )
{
	if( (GAME.Players[nPlayer].nGold==0 || nRun==0 )
		&& GAME.Players[nPlayer].wGroupCounter == 0 )
		return TRUE;
	return FALSE;
}
/////////////

/////////////
//add by tian yue

//Ѱض
//:
//nPlayer :ϷߵID
//nFile   :ҪѰļ
//X       :X
//Y       :Y
//:
//ʧܣMAP_DATA_NONE
//ɹҪѰID
WORD TY_FindNearObject(WORD nPlayer,WORD nFile,WORD X,WORD Y)
{
   WORD i;
   WORD j=0;
   WORD Pau0=0,Pau1=0;
   WORD IDarrays[15][2];
   WORD num=0;
   WORD nID=MAP_DATA_NONE;

   for (i=0;i<15;i++)
   {
	   IDarrays[i][0]=MAP_DATA_NONE;
	   IDarrays[i][1]=MAP_DATA_NONE;
   }
   for (i=0;i<PLAYER_UNIT_MAX;i++)
   {  if ((GAME.Players[nPlayer].Unit[i].Draw.nFile == nFile)
         &&(GAME.Players[nPlayer].Unit[i].Task.nTaskID != SHANCHU)
		 &&(GAME.Players[nPlayer].Unit[i].nType != MAP_UNIT_TYPE_NONE))
	  {  
	     IDarrays[num][0]=i;
		 IDarrays[num][1]=(WORD)sqrtl((((X-GAME.Players[nPlayer].Unit[i].Draw.nX)*
						    			  (X-GAME.Players[nPlayer].Unit[i].Draw.nX))+
                                          ((Y-GAME.Players[nPlayer].Unit[i].Draw.nY)*
										  (Y-GAME.Players[nPlayer].Unit[i].Draw.nY))));
		 num++;
		 if (num >= 15)
			 break;
	  }
      
   }
   if (num == 0)
	  return (MAP_DATA_NONE);
   else
   { 
	   for (i=1;i<num;i++)
		{
			if (IDarrays[0][1] > IDarrays[i][1])
			{
				Pau0=IDarrays[i][0];
				Pau1=IDarrays[i][1];
				IDarrays[i][1]=IDarrays[0][1];
				IDarrays[i][0]=IDarrays[0][0];
				IDarrays[0][1]=Pau1;
				IDarrays[0][0]=Pau0;
			}

		}
		
		return (GAME.Players[nPlayer].Unit[IDarrays[0][0]].nID);
   }

}

WORD TY_FindNearHome(WORD player,WORD X,WORD Y,WORD TYPE)
{
	WORD Num=0,i;
	WORD Arrays[15][2];
	WORD Pau0=0,Pau1=0;

	for (i=0;i<5;i++)
	{
		Arrays[i][0]=MAP_DATA_NONE;
		Arrays[i][1]=MAP_DATA_NONE;
	}

	switch(TYPE)
	{
		//ľ
	case 0:
		for (i=0;i<PLAYER_UNIT_MAX;i++)
		{
			if (GAME.Players[player].Unit[i].Draw.nFile == 0
			  ||GAME.Players[player].Unit[i].Draw.nFile == 1
			  ||GAME.Players[player].Unit[i].Draw.nFile == 4
			  ||GAME.Players[player].Unit[i].Draw.nFile == 5)
			{
				if (GAME.Players[player].Unit[i].nType != MAP_UNIT_TYPE_BUILDING 
				||GAME.Players[player].Unit[i].nLife <= 0
				||GAME.Players[player].Unit[i].Task.nTaskID == JIANZAOZHONG
				||GAME.Players[player].Unit[i].Task.nTaskID == SHANCHU)
				   continue;

				Arrays[Num][0]=i;
				Arrays[Num][1]=(WORD)sqrtl((((X-GAME.Players[player].Unit[i].Draw.nX)*
						    			  (X-GAME.Players[player].Unit[i].Draw.nX))+
                                          ((Y-GAME.Players[player].Unit[i].Draw.nY)*
										  (Y-GAME.Players[player].Unit[i].Draw.nY))));
				Num++;
				//if (Num >= 4 )
				 if (Num >= 15 )
					break;
			}

		}
		break;

		//
	case 1:
		//˵
	case 4:
		for (i=0;i<PLAYER_UNIT_MAX;i++)
		{
			if (GAME.Players[player].Unit[i].nType != MAP_UNIT_TYPE_BUILDING 
			  ||GAME.Players[player].Unit[i].nLife <= 0
			  ||GAME.Players[player].Unit[i].Task.nTaskID == JIANZAOZHONG
			  ||GAME.Players[player].Unit[i].Task.nTaskID == SHANCHU)
				continue;

			if (GAME.Players[player].Unit[i].Draw.nFile == 0
			  ||GAME.Players[player].Unit[i].Draw.nFile == 1
			  ||GAME.Players[player].Unit[i].Draw.nFile == 10
			  ||GAME.Players[player].Unit[i].Draw.nFile == 11)
			{
				Arrays[Num][0]=i;
				Arrays[Num][1]=(WORD)sqrtl((((X-GAME.Players[player].Unit[i].Draw.nX)*
						    			  (X-GAME.Players[player].Unit[i].Draw.nX))+
                                          ((Y-GAME.Players[player].Unit[i].Draw.nY)*
										  (Y-GAME.Players[player].Unit[i].Draw.nY))));
				Num++;
				//if (Num >= 4 )
				if (Num >= 15 )
					break;
			}

		}
		break;

		//
	case 2:
		for (i=0;i<PLAYER_UNIT_MAX;i++)
		{
			if (GAME.Players[player].Unit[i].nType != MAP_UNIT_TYPE_BUILDING 
			  ||GAME.Players[player].Unit[i].nLife <= 0
			  ||GAME.Players[player].Unit[i].Task.nTaskID == JIANZAOZHONG
			  ||GAME.Players[player].Unit[i].Task.nTaskID == SHANCHU)
				continue;

			if (GAME.Players[player].Unit[i].Draw.nFile == 0
			  ||GAME.Players[player].Unit[i].Draw.nFile == 1
			  ||GAME.Players[player].Unit[i].Draw.nFile == 2
			  ||GAME.Players[player].Unit[i].Draw.nFile == 3)
			{
				Arrays[Num][0]=i;
				Arrays[Num][1]=(WORD)sqrtl((((X-GAME.Players[player].Unit[i].Draw.nX)*
						    			  (X-GAME.Players[player].Unit[i].Draw.nX))+
                                          ((Y-GAME.Players[player].Unit[i].Draw.nY)*
										  (Y-GAME.Players[player].Unit[i].Draw.nY))));
				Num++;
				//if (Num >= 4 )
				if (Num >= 15 )
					break;
			}

		}
		break;

		//
	case 3:
		for (i=0;i<PLAYER_UNIT_MAX;i++)
		{
			if (GAME.Players[player].Unit[i].nType != MAP_UNIT_TYPE_BUILDING 
			  ||GAME.Players[player].Unit[i].nLife <= 0
			  ||GAME.Players[player].Unit[i].Task.nTaskID == JIANZAOZHONG
			  ||GAME.Players[player].Unit[i].Task.nTaskID == SHANCHU)
				continue;

			if (GAME.Players[player].Unit[i].Draw.nFile == 0
			  ||GAME.Players[player].Unit[i].Draw.nFile == 1
			  ||GAME.Players[player].Unit[i].Draw.nFile == 23)
			{
				Arrays[Num][0]=i;
				Arrays[Num][1]=(WORD)sqrtl((((X-GAME.Players[player].Unit[i].Draw.nX)*
						    			  (X-GAME.Players[player].Unit[i].Draw.nX))+
                                          ((Y-GAME.Players[player].Unit[i].Draw.nY)*
										  (Y-GAME.Players[player].Unit[i].Draw.nY))));
				Num++;
				//if (Num >= 4 )
				if (Num >= 15 )
					break;
			}
		}
		break;

	}

	if (Num == 0)
		return (MAP_DATA_NONE);
	else
	{
		for (i=1;i<Num;i++)
		{
			if (Arrays[0][1] > Arrays[i][1])
			{
				Pau0=Arrays[i][0];
				Pau1=Arrays[i][1];
				Arrays[i][1]=Arrays[0][1];
				Arrays[i][0]=Arrays[0][0];
				Arrays[0][1]=Pau1;
				Arrays[0][0]=Pau0;
			}

		}
		
		return (GAME.Players[player].Unit[Arrays[0][0]].nID);
	}
}
/////////////


// defined in CBRun.cpp
extern int RUN_nCounter;

// Ĳ
// min	:	Сֵ
// max	:	ֵ
inline int getrandom( int min, int max )
{
	if( GAME_bNetwork == FALSE )
	{
		return rand() % (max + 1 - min) + min;
	}
	else
	{
		return RUN_nCounter % (max + 1 - min) + min;
	}
}