/////////////////
// CBMap.cpp	:	ڡͼͼȫݽṹ
// CBMap.cpp	:	<< chibi >> global map data structure
//
// v0010		:	Sep.18.1996
// v0011		:	Oct.16.1996
// v0012		:	Nov.7.1996
// v0013		:	Nov.22.1996
// v0014		:	Feb.5.1997
// v0020		:	Feb.28.1997
// v0030		:	May.14.1997, changed so many things, especialy for testregion
//
// д			:	
// written by	:	Liu Gang
//
// 		:	Visual C++ 4.2
// Compiler		:	Visual C++ 4.2
//
// Ȩ			:	ǰ޹˾		1996-1997
// Copyright	:	WayAhead Software Co.Ltd.	1996-1997
/////////////////
// ļжԵκ͵ԪͼصĲ

#include "stdafx.h"
#include "Assert.h"	// Error message

#include "CBMap.h"
#include "CBEyes.h"	// EYE_IfOutOfRange()
#include "CBGame.h"

///////////
// ȫmostly used in this file
///////////
// ͼ
WORD MAP_wGroundData[MAP_DATA_THICK][MAP_DATA_WIDTH][MAP_DATA_HEIGHT];
// Ԫͼ
WORD MAP_wUnitData[MAP_DATA_WIDTH][MAP_DATA_HEIGHT];
// 飬ڲʹ
// ǲҪֱӷʣʹMAP_GetRegionData()رҪٶȵĵطƵõĵط
WORD MAP_wRegionData[MAP_DATA_WIDTH][MAP_DATA_HEIGHT];
// ͼܿ
struct MAP_LIB_STRUCT	MAP_Lib;
///////////

///////////
//    0
//  7   1
//6       2
//  5   3
//    4
// ĳΪģΧMAP_SENSER_MAXԶе
// First Dimension:		Even or Odd
// Second Dimension:	Distance from center
// Third Dimension:		max senser items
POINT MAP_ptSenser[2][MAP_SENSER_MAX][8*MAP_SENSER_MAX];
int MAP_nLocationNum[4] = { 1, 4, 9, 16 };
int MAP_nDrawNum[4] = { 0, 1, 3, 5 };
///////////

///////////
//      F
//    B   E
//  A   8   D
//9   5   7   C
//  4   3   6
//    1   2
//      0
//
// Ԫռλõ
// first dimension:		Even or Odd
POINT MAP_ptLocation[2][MAP_LOCATION_MAX]=
{	{{0,0},{-1,-1},{0,-1},
	{0,-2},{-1,-2},{-1,-3},
	{1,-2},{0,-3},{0,-4},
	{-2,-3},{-1,-4},{-1,-5},
	{1,-3},{1,-4},{0,-5},{0,-6}},
	{{0,0},{0,-1},{1,-1},
	{0,-2},{-1,-2},{0,-3},
	{1,-2},{1,-3},{0,-4},
	{-1,-3},{-1,-4},{0,-5},
	{2,-3},{1,-4},{1,-5},{0,-6}}
};	// Ԫռͼλ飨ż
///////////

// Local functions
///////////
// only called by MAP_TestRegion()
// Ƿڵ޽return 10 if successful
// nLayer		:	
// pt			:	Ե㣬Ϊλ
// codeU		:	루ѹ
// codeUEx		:	ĵԪʱȡô˵㣬MAP_DATA_NONEʱЧ
// return value	:	룬
int MAP_testPointRegion( int nLayer, POINT pt, DWORD codeU, WORD codeUEx = MAP_DATA_NONE );

// ƶʾͼ
// nColFrom	:	
// nRowFrom	:	
// nColTo	:	Ŀĵ
// nRowTo	:	Ŀĵ
void MAP_MoveUnitData( int nColFrom, int nRowFrom, int nColTo, int nRowTo );
///////////

// ʼ
///////////
// ʼͼݣUnit, Ground, Region
// initialize ground, unit, region data and map library
void MAP_InitMap()
{
	MAP_ResetGround();
	MAP_ResetUnit();
	MAP_ResetRegion();
	MAP_InitMapLib();
}

// initialize ground, unit, region data
void MAP_InitGUR()
{
	MAP_ResetGround();
	MAP_ResetUnit();
	MAP_ResetRegion();
}

// initialize map library
void MAP_InitMapLib()
{
	memset( &MAP_Lib, 0, sizeof(struct MAP_LIB_STRUCT ) );
}

// ʼͼ
void MAP_ResetGround()
{
	memset( MAP_wGroundData, MAP_DATA_NONE, sizeof(WORD)*MAP_DATA_THICK*MAP_DATA_WIDTH*MAP_DATA_HEIGHT );
}

// ʼԪͼ
void MAP_ResetUnit()
{
	memset( MAP_wUnitData, MAP_DATA_NONE, sizeof(WORD)*MAP_DATA_WIDTH*MAP_DATA_HEIGHT );
}

// ʼͼ
void MAP_ResetRegion()
{
	memset( MAP_wRegionData, 0xFF, sizeof(WORD)*MAP_DATA_WIDTH*MAP_DATA_HEIGHT );
}
///////////

// ͼ
///////////
// Եͼؽ
// ڵô˺֮ǰӦжcodeֵǷΪMAP_DATA_NONE
// codeG	:	ͼش루ѹڣ
// pstctG	:	ͼش루չڣ
inline void MAP_GroundDeCode(WORD codeG, struct MAP_GROUND_CODE_STRUCT * pstctG)
{
	memset( pstctG, 0, sizeof( MAP_GROUND_CODE_STRUCT ) );

	pstctG->nRow=codeG&0x0F;
	codeG=codeG>>4;
	pstctG->nCol=codeG&0x0F;
	codeG=codeG>>4;
	pstctG->nFile=codeG&0x0F;
	codeG=codeG>>4;
	pstctG->nAttr=codeG&0x0F;
}

// Եͼؼ
// stctG		:	ͼش루չڣ
// return value	:	ͼش루ѹڣ
inline WORD MAP_GroundEnCode(struct MAP_GROUND_CODE_STRUCT stctG)
{
	WORD codeG=0;
	codeG=stctG.nAttr&0x0F;
	codeG=codeG<<4;
	codeG|=stctG.nFile&0x0F;
	codeG=codeG<<4;
	codeG|=stctG.nCol&0x0F;
	codeG=codeG<<4;
	codeG|=stctG.nRow&0x0F;
	return codeG;
}

// ȡõͼ
// nLayer		:	
// nCol			:	к
// nRow			:	к
// return value	:	ͼش루ѹ
inline WORD MAP_GetGroundData( int nLayer, int nCol, int nRow )
{
	return MAP_wGroundData[nLayer][nCol][nRow];
}

// õͼ
// nLayer	:	
// nCol		:	к
// nRow		:	к
// codeG	:	ͼش루ѹ
inline void MAP_SetGroundData( int nLayer, int nCol, int nRow, WORD codeG )
{
	MAP_wGroundData[nLayer][nCol][nRow] = codeG;
}

// õͼĻλúʹС㣩
// lprcS		:	Ļڸӵָ루ڣ
// nLayer		:	
// nCol			:	к
// nRow			:	к
// nFile		:	ļ
// return value	:	ͼĻλúʹС㣩
RECT MAP_GetGroundRect( CONST POINT ptOff, int nLayer, int nCol, int nRow, int nFile )
{
	int left, top;
	int width = MAP_Lib.Ground[nFile].szItem.cx;
	int height = MAP_Lib.Ground[nFile].szItem.cy;
	RECT rect;

	// calc top-left position on screen
	top = nRow*MAP_Lib.szItem.cy>>1;
	top -= MAP_Lib.nHeight[nLayer];
	top -= MAP_Lib.Ground[nFile].nHeight;
	if( (nRow&1) == 0 )
	{
		left = nCol*MAP_Lib.szItem.cx;
	}
	else
	{
		left = nCol*MAP_Lib.szItem.cx+(MAP_Lib.szItem.cx>>1);
	}

	// re-adjust coords
	left -= ptOff.x;
	top -= ptOff.y;
	
	rect.left = left, rect.top = top, 
	rect.right = left+width, rect.bottom = top + height;
	return rect;
}
///////////

// Ԫͼ
///////////
// ԵԪͼؽ
// ڵô˺֮ǰӦжcodeֵǷΪMAP_DATA_NONE
// codeU	:	Ԫͼش루ѹڣ
// pstctU	:	Ԫͼش루չڣ
inline void MAP_UnitDeCode(DWORD codeU, struct MAP_UNIT_CODE_STRUCT * pstctU)
{
	memset( pstctU, 0, sizeof( MAP_UNIT_CODE_STRUCT ) );

	pstctU->nRow=codeU&0x0F;
	codeU=codeU>>4;
	pstctU->nCol=codeU&0x3F;
	codeU=codeU>>6;
	pstctU->nFile=codeU&0x3F;
	codeU=codeU>>6;
	pstctU->nPlayer=codeU&0x0F;
	codeU=codeU>>4;
	pstctU->nLayer=codeU&0x03;

	Assert( pstctU->nLayer < 3 );
}

// ԵԪͼؼ
// stctU		:	Ԫͼش루չڣ
// return value	:	Ԫͼش루ѹڣ
inline DWORD MAP_UnitEnCode(struct MAP_UNIT_CODE_STRUCT stctU)
{
	DWORD codeU=0;
	codeU|=stctU.nLayer&0x03;
	codeU=codeU<<4;
	codeU|=stctU.nPlayer&0x0F;
	codeU=codeU<<6;
	codeU|=stctU.nFile&0x3F;
	codeU=codeU<<6;
	codeU|=stctU.nCol&0x3F;
	codeU=codeU<<4;
	codeU|=stctU.nRow&0x0F;
	return codeU;
}

// ԵԪͼݽв
// õԪݣѹ
// nCol			:	к
// nRow			:	к
// return value	:	Ԫݣѹ
DWORD MAP_GetUnitData( int nCol, int nRow )
{
	// get data
	WORD code = MAP_wUnitData[nCol][nRow];
	if( code == MAP_DATA_NONE ) return MAP_DATA_NONE;

	WORD counter = code&0x0FFF;
	code = code>>12;
	struct UNIT_STRUCT *pUnit = &GAME.Players[code].Unit[counter];
	
	// set data 
	struct MAP_UNIT_CODE_STRUCT stct;
	stct.nPlayer = code;
	stct.nFile = pUnit->Draw.nFile;
	stct.nCol = pUnit->Draw.nCol;
	stct.nRow = pUnit->Draw.nRow;
	stct.nLayer = pUnit->Draw.nLayer;

	Assert( stct.nLayer < 3 );
	// encode to lib data
	return MAP_UnitEnCode( stct );
}

// õʾ/ݣѹ
// ԪݺɾԪݣһ
// ֻCTRL_UNIT_Create()CTRL_UNIT_Destroy()
// ⲿڲɾԪʱֱʹ
// nCol			:	кţĿλ
// nRow			:	кţĿλ
// codeU		:	Ԫݣѹ
// return value	:	ĵԪѹExcodeUEx
WORD MAP_SetUnitData( int nLayer, int nX, int nY, DWORD dcodeU )
{
	// if should erase
	if( dcodeU == MAP_DATA_NONE )
	{
		WORD code = MAP_wUnitData[nX][nY];
		Assert( code != MAP_DATA_NONE );
		if( code != MAP_DATA_NONE )
		{
			WORD counter = code&0x0FFF;
			code = code>>12;
			struct UNIT_STRUCT *pUnit = &GAME.Players[code].Unit[counter];
			POINT pt;
			int bOdd = pUnit->Draw.nY&1;	// TRUE if Odd
			for( int i=0; i<MAP_nLocationNum[pUnit->Draw.nLocationSize]; i++ )
			{
				pt.x = pUnit->Draw.nX + MAP_ptLocation[bOdd][i].x;
				pt.y = pUnit->Draw.nY + MAP_ptLocation[bOdd][i].y;
				MAP_wUnitData[pt.x][pt.y] = MAP_DATA_NONE;
			}
			if( pUnit->nType == MAP_UNIT_TYPE_NONE )
				OutputDebugString( " CBMap Warning(0): the unit has been deleted! " );
			else
				GAME.Players[code].wUnitCounter--;
			pUnit->nType = MAP_UNIT_TYPE_NONE;
		}
		return MAP_DATA_NONE;
	}

	// decode from lib data
	struct MAP_UNIT_CODE_STRUCT stct;
	MAP_UnitDeCode( dcodeU, &stct );
#ifdef	_DEBUG
	if( stct.nPlayer >= GAME_PLAYER_MAX )
	{
		OutputDebugString( "MAP_SetUnitData Error(0): Error in Decode! Player ID is too large!\n" );
		return MAP_DATA_NONE;
	}
#endif // _DEBUG
	// try to find next room to fit the unit
	WORD	wUnitID = GAME.Players[stct.nPlayer].wLastUnit;
	WORD	wCount = 0;

	// Dec.1.1997
	do
	{
		wCount++;
		wUnitID++;
		if( wUnitID >= PLAYER_UNIT_MAX )	
		{
			wUnitID = 0;
			OutputDebugString( "MAP_SetUnitData Message(0): back to the head\n" );
			//return MAP_DATA_NONE;	// no room to store the unit
		}
		if( wCount >= PLAYER_UNIT_MAX-1 )
		{	// 
			return MAP_DATA_NONE;
		}
	}
	while( GAME.Players[stct.nPlayer].Unit[wUnitID].nType != MAP_UNIT_TYPE_NONE );

	GAME.Players[stct.nPlayer].wLastUnit = wUnitID;
	GAME.Players[stct.nPlayer].wUnitCounter++;

	// get data
	WORD code=0;
	code = stct.nPlayer<<12;
	code |= wUnitID;
	struct UNIT_STRUCT *pUnit = &GAME.Players[stct.nPlayer].Unit[wUnitID];

	// initialize
	memset( pUnit, 0, sizeof( struct UNIT_STRUCT ) );

	// ݵṹ
	pUnit->nID = code;	// ѹõṹ
	pUnit->nType = MAP_Lib.Unit[stct.nFile].nType;

#ifdef	_DEBUG
	if( pUnit->nType == MAP_UNIT_TYPE_NONE )
	{
		OutputDebugString( "MAP_SetUnitData Error(2): Error in decode! The type of new unit is NONE!\n" );
		return MAP_DATA_NONE;
	}
#endif // _DEBUG

	// ʾ
	pUnit->Draw.bUpdate = FALSE;
	pUnit->Draw.nPlayer = stct.nPlayer;
	pUnit->Draw.nFile = stct.nFile;
	pUnit->Draw.nLayer = nLayer;
	Assert( nLayer < 3 );
	//pUnit->Draw.nFrame = 0;

	int nLocationSize = MAP_Lib.Unit[stct.nFile].nLocationSize;
	pUnit->Draw.nX = nX;
	pUnit->Draw.nY = nY;
	{
		// set display position
		int bOdd = nY&1;
		pUnit->Draw.nDrawX = nX + (WORD)MAP_ptLocation[bOdd][MAP_nDrawNum[nLocationSize]].x;
		pUnit->Draw.nDrawY = nY + (WORD)MAP_ptLocation[bOdd][MAP_nDrawNum[nLocationSize]].y;
	}
	pUnit->Draw.nLocationSize = nLocationSize;
#ifdef	_MAP_COMPRESS_
	pUnit->Draw.nCol = MAP_Lib.AniSeq[pUnit->Draw.nFile].nAniSeq[pUnit->Draw.nState][pUnit->Draw.nFrame]+MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
	pUnit->Draw.nRow = 0;
#else
	pUnit->Draw.nRow = stct.nRow;
	pUnit->Draw.nCol = stct.nCol;
#endif

	//pUnit->Draw.ptOff.x = 0;
	//pUnit->Draw.ptOff.y = 0;

	pUnit->Draw.nXLast = nX;
	pUnit->Draw.nYLast = nY;
	//pUnit->Draw.ptOffLast.x = 0;
	//pUnit->Draw.ptOffLast.y = 0;

	POINT pt;
	int bOdd = nY&1;	// TRUE if Odd
	for( int i=0; i<MAP_nLocationNum[pUnit->Draw.nLocationSize]; i++ )
	{
		pt.x = nX + MAP_ptLocation[bOdd][i].x;
		pt.y = nY + MAP_ptLocation[bOdd][i].y;
		WORD codeUEx = MAP_wUnitData[pt.x][pt.y];
		Assert( codeUEx == MAP_DATA_NONE );
#ifdef	_DEBUG
		if( codeUEx != MAP_DATA_NONE )
			OutputDebugString( ";" );
#endif
		MAP_wUnitData[pt.x][pt.y] = code;
	}
	return code;
}

// ֱӵõ
// nCol			:	к
// nRow			:	к
// return value	:	Ԫݣѹ룩
inline WORD MAP_GetUnitDataEx( int nCol, int nRow )
{
	return MAP_wUnitData[nCol][nRow];
}

// ֱ
// nCol			:	к
// nRow			:	к
// wCode		:	Ԫݣѹ룩
inline void MAP_SetUnitDataEx( int nCol, int nRow, WORD wCode )
{
	MAP_wUnitData[nCol][nRow] = wCode;
}

// õʾͼݣ˺רʾ
// кŲڸõԪʾλʱ򷵻ʧ
// nCol			:	к
// nRow			:	к
// pstctCF		:	֡ݽṹڣ
// reutrn value	:	TRUE if succeeded
BOOL MAP_GetUnitFrameData( int nCol, int nRow, struct CTRL_FRAME_STRUCT *pstctCF, BOOL bDone/*=TRUE*/ )
{	
	// get data
	WORD code = MAP_wUnitData[nCol][nRow];
	if( code == MAP_DATA_NONE ) return FALSE;

	WORD counter = code&0x0FFF;
	code = code>>12;
	struct UNIT_STRUCT *pUnit = &GAME.Players[code].Unit[counter];
	struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;

	Assert( pDraw->nLayer < 3 );
	
	// if should display in the right position
	if( pDraw->nDrawX != nCol || pDraw->nDrawY != nRow )
		return FALSE;

	// set data
	memcpy( pstctCF, pDraw, sizeof(struct CTRL_FRAME_STRUCT) );
/*
	pstctCF->bUpdate = pDraw->bUpdate;

	pstctCF->nPlayer = pDraw->nPlayer;
	pstctCF->nFile = pDraw->nFile;
	pstctCF->nLayer = pDraw->nLayer;
	pstctCF->nFrame = pDraw->nFrame;
	pstctCF->nX = pDraw->nX;
	pstctCF->nY = pDraw->nY;
	pstctCF->nDrawX = pDraw->nDrawX;
	pstctCF->nDrawY = pDraw->nDrawY;

	pstctCF->nCol = pDraw->nCol;
	pstctCF->nRow = pDraw->nRow;
	pstctCF->nState = pDraw->nState;
	pstctCF->nDir = pDraw->nDir;

	pstctCF->nLocationSize = pDraw->nLocationSize;
	pstctCF->ptOff.x = pDraw->ptOff.x,
	pstctCF->ptOff.y = pDraw->ptOff.y;

	pstctCF->nXLast = pDraw->nXLast;
	pstctCF->nYLast = pDraw->nYLast;
	pstctCF->ptOffLast.x = pDraw->ptOffLast.x;
	pstctCF->ptOffLast.y = pDraw->ptOffLast.y;
*/
	// set update to FALSE
//	if( bDone )
//		pDraw->bUpdate = FALSE;

	return TRUE;
}

// ƶʾͼ
// nColFrom	:	
// nRowFrom	:	
// nColTo	:	Ŀĵ
// nRowTo	:	Ŀĵ
void MAP_MoveUnitData( int nColFrom, int nRowFrom, int nColTo, int nRowTo )
{
	WORD code = MAP_wUnitData[nColFrom][nRowFrom];
	MAP_wUnitData[nColTo][nRowTo] = code;
	MAP_wUnitData[nColFrom][nRowFrom] = MAP_DATA_NONE;
}

// ƶԪ
// ĿλñԪռʱʧ
// ֻCTRL_UNIT_Move()ã˲ֱӵô˺
// only used by CTRL_UNIT_Move()
// pDraw		:	unit control frame struct Ԫ֡ƽṹ
// nType		:	type of unit
// return value	:	TRUE if succeeded
BOOL MAP_MoveUnit( struct CTRL_FRAME_STRUCT *pDraw, int nType )
{
	int i;
	WORD codeUEx, codeUExLast;
	int nX[16], nY[16], nXLast[16], nYLast[16];
	int nNum = MAP_nLocationNum[pDraw->nLocationSize];
	codeUExLast = MAP_wUnitData[pDraw->nXLast][pDraw->nYLast];

	int bOdd = pDraw->nY&1;
	int bOddLast = pDraw->nYLast&1;
	for( i=0; i<nNum; i++ )
	{
		nXLast[i] = pDraw->nXLast+MAP_ptLocation[bOddLast][i].x;
		nYLast[i] = pDraw->nYLast+MAP_ptLocation[bOddLast][i].y;
		nX[i] = pDraw->nX+MAP_ptLocation[bOdd][i].x;
		nY[i] = pDraw->nY+MAP_ptLocation[bOdd][i].y;

		if( nX[i] < 2 )	return FALSE;
		if( nY[i] < 5 )	return FALSE;
		if( nX[i] > MAP_Lib.szNum.cx-3 )	return FALSE;
		if( nY[i] > MAP_Lib.szNum.cy-2 )	return FALSE;

#ifdef	_DEBUG
		// check footprint
		codeUEx = MAP_wUnitData[nXLast[i]][nYLast[i]];
		if( codeUEx != codeUExLast )
			OutputDebugString( "MAP_MoveUnit Warning(0): :\n" );
#endif
		codeUEx = MAP_wUnitData[nX[i]][nY[i]];
		// test if there is some one (not me) in front of me
		if( codeUEx != MAP_DATA_NONE && 
			codeUEx != codeUExLast )
			return FALSE;	// someone blocked him

		// test if there is a hill here
		if( pDraw->nLayer < 2 )
		if( MAP_GetGroundData( pDraw->nLayer+1, nX[i], nY[i] ) != MAP_DATA_NONE )
			return FALSE;

		// test if cannot move there
		WORD codeG = MAP_GetGroundData( pDraw->nLayer, nX[i], nY[i] );
		if( codeG == MAP_DATA_NONE ) return FALSE;
		struct MAP_GROUND_CODE_STRUCT stctG;
		MAP_GroundDeCode( codeG, &stctG );
		if( stctG.nAttr != MAP_SPECIAL_NONE 
			&& stctG.nAttr != MAP_SPECIAL_CUT_WOOD 
			&& stctG.nAttr != MAP_SPECIAL_CUT_WHEAT )	// cannot move in Forest and Field
//				&& GroundDeCode.nAttr != MAP_SPECIAL_CUT_WOOD 
//				&& GroundDeCode.nAttr != MAP_SPECIAL_CUT_WHEAT )	// cannot move in Forest and Field
		{
			return FALSE;
		}
		if( nType == MAP_UNIT_TYPE_SHIP 
			|| nType == MAP_UNIT_TYPE_SGEN )
		{	// ship cannot move out of water
			if( stctG.nFile != 3 || stctG.nCol != 12 )	// ˮ
			{
				return FALSE;
			}
		}
		else if( nType == MAP_UNIT_TYPE_SOLDIER 
			|| nType == MAP_UNIT_TYPE_LADDER 
			|| nType == MAP_UNIT_TYPE_WORKER 
			|| nType == MAP_UNIT_TYPE_MAN
			|| nType == MAP_UNIT_TYPE_WGEN
			|| nType == MAP_UNIT_TYPE_GEN )
		{	// others cannot move in water
			if( stctG.nFile == 3 && stctG.nCol == 12 )	// ˮ
			{
				return FALSE;
			}
		}

	}

	// set display position
	pDraw->nDrawX = pDraw->nX + (WORD)MAP_ptLocation[bOdd][MAP_nDrawNum[pDraw->nLocationSize]].x;
	pDraw->nDrawY = pDraw->nY + (WORD)MAP_ptLocation[bOdd][MAP_nDrawNum[pDraw->nLocationSize]].y;

	// Erase old footprint
	for( i=0; i<nNum; i++ )
	{
#ifdef	_DEBUG
		// check footprint
		codeUEx = MAP_wUnitData[nXLast[i]][nYLast[i]];
		if( codeUEx != codeUExLast )
			OutputDebugString( "MAP_MoveUnit Warning(1): ,\n" );
#endif	// _DEBUG
		MAP_wUnitData[nXLast[i]][nYLast[i]] = MAP_DATA_NONE;
	}

	// draw new footprint
	for( i=0; i<nNum; i++ )
	{
#ifdef	_DEBUG
		// check footprint
		codeUEx = MAP_wUnitData[nX[i]][nY[i]];
		if( codeUEx != MAP_DATA_NONE )
			OutputDebugString( "MAP_MoveUnit Warning(2): .\n" );
#endif	// _DEBUG
		MAP_wUnitData[nX[i]][nY[i]] = codeUExLast;
	}
	return TRUE;
}

// õԪṹ
// nCol			:	к
// nRow			:	к
// return value	:	Ԫṹָ
inline struct UNIT_STRUCT *MAP_GetUnit( int nCol, int nRow )
{
	// get data
	WORD code = MAP_wUnitData[nCol][nRow];
	if( code == MAP_DATA_NONE )
	{
//		WriteLogFile( "Test.log","MAP_GetUnit()\n" );
//		OutputDebugString( "MAP_GetUnit0 Warning: unit is NULL!\n" );
		return NULL;
	}

	WORD counter = code&0x0FFF;
	code = code>>12;
	struct UNIT_STRUCT *pUnit = &GAME.Players[code].Unit[counter];
	return pUnit;
}

// õԪṹ
// dwCode		:	Ԫѹ
// return value	:	Ԫṹָ
inline struct UNIT_STRUCT *MAP_GetUnit( WORD wCode )
{
	struct UNIT_STRUCT *pUnit=NULL;
	WORD counter;
	if( wCode == MAP_DATA_NONE ) 
	{
//		WriteLogFile( "Test.log","MAP_GetUnit()AAA\n" );
		OutputDebugString( "MAP_GetUnit Warning: unit is NULL!\n" );
		return NULL;
	}

	counter = wCode&0x0FFF;
	wCode = wCode>>12;
	pUnit = &GAME.Players[wCode].Unit[counter];
	return pUnit;
}

// õԪͼĻλúʹС㣩
// lprcS		:	Ļڸӵָ루ڣ
// pstctCF		:	֡ṹָ루ڣ
// return value	:	ԪͼĻλúʹС㣩
RECT MAP_GetUnitRect( CONST POINT ptOff, CONST struct CTRL_FRAME_STRUCT *lpstctCF )
{
	int top, left;
	int width = MAP_Lib.Unit[lpstctCF->nFile].szItem.cx;
	int height = MAP_Lib.Unit[lpstctCF->nFile].szItem.cy;
	RECT rect;

	// calc top-left position on screen
	top = (lpstctCF->nY*MAP_Lib.szItem.cy>>1)+MAP_Lib.szItem.cy;
	top -= MAP_Lib.nHeight[lpstctCF->nLayer+1];
	top -= lpstctCF->nOff_Z;
	top -= height;
	if( (lpstctCF->nY&1) == 0 )
	{
		left = lpstctCF->nX*MAP_Lib.szItem.cx;
	}
	else
	{
		left = lpstctCF->nX*MAP_Lib.szItem.cx+(MAP_Lib.szItem.cx>>1);
	}
//	if( lpstctCF->nLocationSize == 2 )
//		left = left - MAP_Lib.szItem.cx;
//	else
		left = left + (MAP_Lib.szItem.cx>>1) - (width>>1);

	// re-adjust coords to relative
	left = left - ptOff.x + lpstctCF->ptOff.x;
	top = top - ptOff.y + lpstctCF->ptOff.y;

	rect.left = left, rect.top = top, 
	rect.right = left + width, rect.bottom = top + height;
	return rect;
}

// õԪľλúʹСھλϲõԪ
// lprcS		:	Ļڸӵָ
// pstctCF		:	֡ṹָ루ڣ
// return value	:	ԪͼĻһλõλúʹС㣩
RECT MAP_GetUnitRectLast( CONST POINT ptOff, CONST struct CTRL_FRAME_STRUCT *lpstctCF )
{
	int top, left;
	int width = MAP_Lib.Unit[lpstctCF->nFile].szItem.cx;
	int height = MAP_Lib.Unit[lpstctCF->nFile].szItem.cy;
	RECT rect;

	// calc top-left position on screen
	top = (lpstctCF->nYLast*MAP_Lib.szItem.cy>>1)+MAP_Lib.szItem.cy;
	top -= MAP_Lib.nHeight[lpstctCF->nLayer+1];
	top -= height;
	if( (lpstctCF->nYLast&1) == 0 )
	{
		left = lpstctCF->nXLast*MAP_Lib.szItem.cx;
	}
	else
	{
		left = lpstctCF->nXLast*MAP_Lib.szItem.cx+(MAP_Lib.szItem.cx>>1);
	}
//	if( lpstctCF->nLocationSize == 2 )
//		left = left - MAP_Lib.szItem.cx;
//	else
		left = left + (MAP_Lib.szItem.cx>>1) - (width>>1);
	// re-adjust coords to relative
	left = left - ptOff.x + lpstctCF->ptOffLast.x;
	top = top - ptOff.y + lpstctCF->ptOffLast.y;

	rect.left = left, rect.top = top, 
	rect.right = left+width, rect.bottom = top + height;
	return rect;
}
///////////


// ͼ
///////////
// õʾͼݣreturn not null for pstct is valid
// nLayer		:	
// nCol			:	к
// nRow			:	к
// nAttr		:	
// pstctCF		:	֡ṹָ루ڣ
// reutrn value	:	TRUE if succeeded
BOOL MAP_GetSpecFrameData( int nLayer, int nCol, int nRow, int nAttr, struct CTRL_FRAME_STRUCT *pstctCF )
{	
	// decode
	int nA = nAttr%4;
	int nB = nAttr/4;

	DWORD codeU = MAP_Lib.Special[nA];
	if( codeU == MAP_DATA_NONE )	return FALSE;
	struct MAP_UNIT_CODE_STRUCT stctU;
	MAP_UnitDeCode( codeU, &stctU );

	// set data
	pstctCF->bUpdate = FALSE;

	pstctCF->nPlayer = stctU.nPlayer;
	pstctCF->nFile = stctU.nFile;
	pstctCF->nLayer = nLayer;
	Assert( nLayer < 3 );
	pstctCF->nFrame = 0;
	pstctCF->nX = nCol;
	pstctCF->nY = nRow;
	pstctCF->nDrawX = nCol;
	pstctCF->nDrawY = nRow;
#ifdef	_MAP_COMPRESS_
	pstctCF->nCol = stctU.nRow*2 + stctU.nCol+MAP_Lib.AniSeq[stctU.nFile].nOffset;
	if( nB == 2 )	pstctCF->nCol += 1;	// 
	pstctCF->nRow = 0; //stctU.nRow;
#else
	pstctCF->nCol = stctU.nCol;
	pstctCF->nRow = stctU.nRow;
#endif
	pstctCF->nState = 0;
	pstctCF->nDir = 0;
//	pstctCF->nMaxFrame = 1;
	pstctCF->nLocationSize = 0;
	pstctCF->ptOff.x = 0;
	pstctCF->ptOff.y = 0;

	pstctCF->nXLast = pstctCF->nX;
	pstctCF->nYLast = pstctCF->nY;
	pstctCF->ptOffLast.x = 0;
	pstctCF->ptOffLast.y = 0;

	return TRUE;
}
///////////

// ͼ
///////////
// ͼؽ
// ڵô˺֮ǰӦжcodeֵǷΪMAP_DATA_NONE
// codeR	:	ͼأѹڣ
// pstctR	:	ͼأչڣ
inline void MAP_RegionDeCode(WORD codeR, struct MAP_REGION_CODE_STRUCT * pstctR)
{
	memset( pstctR, 0, sizeof( MAP_REGION_CODE_STRUCT ) );

	pstctR->nPlayer=codeR&0x0F;
	codeR=codeR>>4;
	pstctR->nShadow=codeR&0x0F;
	codeR=codeR>>4;
	pstctR->nShadowEx=codeR&0x0F;
}

// ͼؼ
// stctR		:	ͼأչڣ
// return value	:	ͼأѹڣ
inline WORD MAP_RegionEnCode(struct MAP_REGION_CODE_STRUCT stctR)
{
	WORD codeR=0;
	codeR|=0x0F;
	codeR=codeR<<4;
	codeR|=stctR.nShadowEx&0x0F;
	codeR=codeR<<4;
	codeR|=stctR.nShadow&0x0F;
	codeR=codeR<<4;
	codeR|=stctR.nPlayer&0x0F;
	return codeR;
}

// ݽв
// ݵĲ
// , ݹ麯
// pt		:	ӣΪλ
// nPlayer	:	ݣϷ߱
int MAP_nRegionStack=0;
#define	MAP_REGION_STACK_MAX 1024
void MAP_FillRegion( POINT pt, int nPlayer )
{
	// set current point
	struct MAP_REGION_CODE_STRUCT stctR;
	WORD code;
	stctR.nPlayer = nPlayer;
	stctR.nShadow = MAP_SHADOW_NONE;
	stctR.nShadowEx = MAP_SHADOW_NONE;
	code = MAP_RegionEnCode( stctR );

	MAP_SetRegionData( pt.x, pt.y, code );
	MAP_nRegionStack++;	// stack counter

	POINT ptNext;
	for( int i=0; i<4; i++ )
	{
		// get next point
		int bOdd = pt.y&1;	// TRUE if Odd
		ptNext.x = pt.x + MAP_ptSenser[bOdd][0][i*2+1].x;
		ptNext.y = pt.y + MAP_ptSenser[bOdd][0][i*2+1].y;
		if( EYE_IfOutOfRange( ptNext.x, ptNext.y ) )
			continue;
		code = MAP_GetGroundData( 0, ptNext.x, ptNext.y );
		if( code == MAP_DATA_NONE )	continue;
		struct MAP_GROUND_CODE_STRUCT stctG;
		MAP_GroundDeCode( code, &stctG );

		// if it is on the correct ground type
		if( stctG.nFile == 2 && stctG.nCol == 12 && MAP_nRegionStack<MAP_REGION_STACK_MAX )
		{	
			code = MAP_GetRegionData( ptNext.x, ptNext.y );
			MAP_RegionDeCode( code, &stctR );
			// if has filled
			if(  stctR.nPlayer != nPlayer )
				MAP_FillRegion( ptNext, nPlayer );
		}
	}
	MAP_nRegionStack--;
}

// 
// ֻеͼ༭ʹ
// pt	:	ӣΪλ
void MAP_ClearRegion( POINT pt )
{
	// set current point
	struct MAP_UNIT_CODE_STRUCT stctU;
	DWORD codeU;
	codeU = MAP_GetUnitData( pt.x, pt.y );
	if( codeU != MAP_DATA_NONE )
	{
		::MAP_UnitDeCode( codeU, &stctU );
		// if it is flag
		//if( stctU.nFile == 3 && stctU.nCol == 0 )
		// ֻеͼ༭ʹ
		int nType = MAP_Lib.Unit[stctU.nFile].nType;
		if( nType == MAP_UNIT_TYPE_FLAG )
		{
			// reset to zero
			MAP_SetUnitData( 0, pt.x, pt.y, MAP_DATA_NONE );
		}
	}

	// set region to none
	WORD code;
	code = MAP_GetRegionData( pt.x, pt.y );
	struct MAP_REGION_CODE_STRUCT stctR;
	MAP_RegionDeCode( code, &stctR );
	stctR.nPlayer = MAP_PLAYER_NONE;	// custom value 
	code = MAP_RegionEnCode( stctR );
	MAP_SetRegionData( pt.x, pt.y, code );
	MAP_nRegionStack++;	// stack counter

	POINT ptNext;
	for( int i=0; i<4; i++ )
	{
		// find next point
		int bOdd = pt.y&1;	// TRUE if Odd
		ptNext.x = pt.x + MAP_ptSenser[bOdd][0][i*2+1].x;
		ptNext.y = pt.y + MAP_ptSenser[bOdd][0][i*2+1].y;

		code = MAP_GetGroundData( 0, ptNext.x, ptNext.y );
		if( code == MAP_DATA_NONE )	continue;
		struct MAP_GROUND_CODE_STRUCT stctG;
		MAP_GroundDeCode( code, &stctG );
		// if it is the correct ground type
		if( stctG.nFile == 2 && stctG.nCol == 12 && MAP_nRegionStack<MAP_REGION_STACK_MAX )
		{
			code = MAP_GetRegionData( ptNext.x, ptNext.y );
			MAP_RegionDeCode( code, &stctR );
			// if has been cleared
			if(  stctR.nPlayer != MAP_PLAYER_NONE )
				MAP_ClearRegion( ptNext );
		}
	}
	MAP_nRegionStack--;
}

// ֱӽѹĴõ
// nCol		:	к
// nRow		:	к
// codeR	:	ݴ루ѹ
inline void MAP_SetRegionData( int nCol, int nRow, int codeR )
{
	MAP_wRegionData[nCol][nRow] = codeR;
}

// ֱӴȡ
// nCol			:	к
// nRow			:	к
// return value	:	ݴ루ѹ
inline WORD MAP_GetRegionData( int nCol, int nRow )
{
	return MAP_wRegionData[nCol][nRow];
}

// ǷڴƬ޽return 10 if successful
// nLayer		:	
// pt			:	Ե㣬Ϊλ
// codeU		:	루ѹ
// codeUEx		:	ĵԪʱȡô˵㣬MAP_DATA_NONEʱЧ
// return value	:	룬
int MAP_TestRegion( int nLayer, POINT pt, DWORD codeU, WORD codeUEx/*=MAP_DATA_NONE*/ )
{
	if( codeU == MAP_DATA_NONE )	return 10;

	// should be built on one special ground type
	struct MAP_UNIT_CODE_STRUCT stctU;
	::MAP_UnitDeCode( codeU, &stctU );
	//int nType = MAP_Lib.Unit[stctU.nFile].nType;

	// set locations
	int nLocationSize = MAP_Lib.Unit[stctU.nFile].nLocationSize;
	POINT ptNext;
	int retrns[16];
	int i;

	int bOdd = pt.y&1;	// TRUE if Odd
	for( i=0; i<MAP_nLocationNum[nLocationSize]; i++ )
	{
		ptNext.x = pt.x + MAP_ptLocation[bOdd][i].x;
		ptNext.y = pt.y + MAP_ptLocation[bOdd][i].y;
		if( EYE_IfOutOfRange( ptNext.x, ptNext.y ) )
		{
			retrns[i] = MAP_REGION_ERROR_OUT;
		}
		else
			retrns[i] = MAP_testPointRegion( nLayer, ptNext, codeU, codeUEx );
		if( retrns[i] != MAP_REGION_SUCCESS )
			return retrns[i];
	}

	return MAP_REGION_SUCCESS;
}

// only called by MAP_TestRegion()
// Ƿڵ޽return 10 if successful
// nLayer		:	
// pt			:	Ե㣬Ϊλ
// codeU		:	루ѹ
// codeUEx		:	ĵԪʱȡô˵㣬MAP_DATA_NONEʱЧ
// return value	:	룬
int MAP_testPointRegion( int nLayer, POINT pt, DWORD codeU, WORD codeUEx/*=MAP_DATA_NONE*/ )
{
	WORD codeG1;
	for(;;)
	{
		// ûеͼضײ㣬󷵻
		// cannot build below ground
		codeG1 = MAP_GetGroundData( nLayer, pt.x, pt.y );
		if( codeG1 != MAP_DATA_NONE )
			break;
		if( nLayer == 0	&& codeG1 == MAP_DATA_NONE )
		{
			return MAP_REGION_ERROR_UNDER;
		}
		nLayer--;
	}
	Assert( nLayer >= 0 );

	struct MAP_UNIT_CODE_STRUCT stctU;
	::MAP_UnitDeCode( codeU, &stctU );
	int nType = MAP_Lib.Unit[stctU.nFile].nType;

	// cannot build building on other unit
	WORD cUEx = ::MAP_GetUnitDataEx( pt.x, pt.y );
//	if( cUEx != MAP_DATA_NONE && codeUEx != cUEx )	
//		return MAP_REGION_ERROR_CANNOT;
	if( cUEx != MAP_DATA_NONE )	
		return MAP_REGION_ERROR_CANNOT;

	// cannot build on resources
	struct MAP_GROUND_CODE_STRUCT stctG;
	MAP_GroundDeCode( codeG1, &stctG );
	if( stctG.nAttr != MAP_SPECIAL_NONE 
		&& stctG.nAttr != MAP_SPECIAL_CUT_WOOD 
		&& stctG.nAttr != MAP_SPECIAL_CUT_WHEAT )	// cannot move in Forest and Field
		return MAP_REGION_ERROR_RES;

	// cannot build on other layers
	if( nLayer <MAP_DATA_THICK-1 )
	{
		WORD codeG2 = MAP_GetGroundData( nLayer+1, pt.x, pt.y );
		if( codeG2 != MAP_DATA_NONE )	return MAP_REGION_ERROR_CANNOT;
	}

	// should be built on one special ground type
	if( nType == MAP_UNIT_TYPE_SHIPYARD )	// shipyard
	{
		WORD codeG = MAP_GetGroundData( nLayer, pt.x, pt.y );
		struct MAP_GROUND_CODE_STRUCT stctG;
		::MAP_GroundDeCode( codeG, &stctG );
		if( !(stctG.nFile == 3 && stctG.nCol == 12) )
		{	// shipyard can only be placed in water
			return MAP_REGION_ERROR_SHIPYARD;
		}
	}
	else if( nType == MAP_UNIT_TYPE_SHIP 
		|| nType == MAP_UNIT_TYPE_SGEN )	// sailer
	{
		WORD codeG = MAP_GetGroundData( nLayer, pt.x, pt.y );
		struct MAP_GROUND_CODE_STRUCT stctG;
		::MAP_GroundDeCode( codeG, &stctG );
		if( !(stctG.nFile == 3 && stctG.nCol == 12) )
		{	// ships can only be placed in water
			return MAP_REGION_ERROR_SHIP;
		}
	}
	else
	{	// ½ϵԪ
		WORD codeG = MAP_GetGroundData( nLayer, pt.x, pt.y );
		struct MAP_GROUND_CODE_STRUCT stctG;
		::MAP_GroundDeCode( codeG, &stctG );
		if( stctG.nFile == 3 && stctG.nCol == 12 )
			return MAP_REGION_ERROR_WATER;	// ܽˮ

		if( nType == MAP_UNIT_TYPE_BUILDING ||
			nType == MAP_UNIT_TYPE_FLAG )	// generic building
		{
			if( !(stctG.nFile == 2 && stctG.nCol == 12) )
			{	// generic building can only be placed on TUDI
				return MAP_REGION_ERROR_TUDI;	// ֻܽ
			}
		}
	}

#ifdef	_MAP_EDIT_
	if( nType == MAP_UNIT_TYPE_FLAG )	// if it is flag
	{
		// clear region
		MAP_nRegionStack=0;
		::MAP_ClearRegion( pt );
		// set region to this flag
		MAP_nRegionStack=0;
		::MAP_FillRegion( pt, stctU.nPlayer );
	}
	else if( nType == MAP_UNIT_TYPE_BUILDING )	// other unit data
	{
		// must be placed with the same flag
		WORD codeR = MAP_GetRegionData( pt.x, pt.y );
		struct MAP_REGION_CODE_STRUCT stctR;
		MAP_RegionDeCode( codeR, &stctR );
		if( stctR.nPlayer == MAP_PLAYER_NONE )
		{
			// set flag first
			return MAP_REGION_ERROR_FLAG;
		}
		else
		{	// change the flag of the unit to the same as the region
			stctU.nPlayer = stctR.nPlayer;
			codeU = MAP_UnitEnCode( stctU );
		}
	}
#endif // _MAP_EDIT_
	return MAP_REGION_SUCCESS;
}

// ԶҵһԷøõԪλãMAP_SENSER_MAXΧѰ
// nZ, nX, nY	:	ʼ
// codeU		:	õԪѹ
// codeUEx		:	ĵԪʱȡô˵㣬MAP_DATA_NONEʱЧ
// return		:	(-1,-1)ʱΪûҵ
POINT MAP_FindRegion( int nZ, int nX, int nY, DWORD codeU, WORD codeUEx/*=MAP_DATA_NONE*/ )
{
	POINT pt;
	int ret;
	int bOdd;

	// test for the current position
	pt.x = nX, pt.y = nY;
	ret = MAP_TestRegion( nZ, pt, codeU, codeUEx );
	if( ret == MAP_REGION_SUCCESS )
	{
		Assert( MAP_GetUnitData( pt.x, pt.y ) == MAP_DATA_NONE );
		return pt;
	}

	// test for the positions around the current one
	bOdd = nY%2;
	for( int i=0; i< MAP_SENSER_MAX; i++ )
	for( int j=0; j< ((i+1)<<3); j++ )
	{
		pt.x = nX + MAP_ptSenser[bOdd][i][j].x;
		pt.y = nY + MAP_ptSenser[bOdd][i][j].y;
		if( EYE_IfOutOfRange( pt.x, pt.y ) )
			continue;
		ret = MAP_TestRegion( nZ, pt, codeU, codeUEx );
		if( ret == MAP_REGION_SUCCESS )
		{
			Assert( MAP_GetUnitDataEx( pt.x, pt.y ) == MAP_DATA_NONE 
				|| MAP_GetUnitDataEx( pt.x, pt.y ) == codeUEx );
			return pt;
		}
	}
	pt.x = -1, pt.y = -1;
	return pt;
}
///////////

///////////
// ֻCBBuild.cppʹã콨ʱ
// ǷڴƬ޽
// nLayer		:	룬
// pt			:	룬Ե㣬Ϊλ
// codeU		:	룬루ѹ
// pnRet		:	ֵ
// nRetNum		:	룬ݵĸ
void MAP_TestRegionBuild( int nLayer, POINT pt, DWORD codeU, int *pnRet, int nRetNum )
{
	if( codeU == MAP_DATA_NONE )	return;

	POINT ptNext;
	int retrns[16];
	int i;

	int bOdd = pt.y&1;	// TRUE if Odd
	for( i=0; i<nRetNum; i++ )
	{
		ptNext.x = pt.x + MAP_ptLocation[bOdd][i].x;
		ptNext.y = pt.y + MAP_ptLocation[bOdd][i].y;
		if( EYE_IfOutOfRange( ptNext.x, ptNext.y ) )
		{
			retrns[i] = MAP_REGION_ERROR_OUT;
		}
		else
		{
			// Ӱڵܽ
			WORD codeR = MAP_GetRegionData( ptNext.x, ptNext.y );
			struct MAP_REGION_CODE_STRUCT stctR;
			MAP_RegionDeCode( codeR, &stctR );
			if( stctR.nShadow == MAP_SHADOW_NONE )
				retrns[i] = MAP_REGION_ERROR_SHADOW;
			else
			{
				retrns[i] = MAP_testPointRegion( nLayer, ptNext, codeU );
			}
		}
	}

// ¼㴬ǷŰ
	BOOL bSuccess = TRUE;
	for( i=0; i<nRetNum; i++ )
	{
		if( retrns[i] != MAP_REGION_SUCCESS )
		{
			bSuccess = FALSE;
			break;
		}
	}
	// Գɹ
	if( bSuccess == TRUE )
	{	
		WORD codeG = MAP_GetGroundData( nLayer, pt.x, pt.y );
		if( codeG != MAP_DATA_NONE )
		{
			struct MAP_GROUND_CODE_STRUCT stctG;
			MAP_GroundDeCode( codeG, &stctG );
			if( stctG.nFile == 3 )	// ˮ
			{	// ֻˮ߲ܽ촬룬Կ϶Ҫ촬
				bSuccess = EYE_IfNearBank( nLayer, pt.x, pt.y, 2 );
			}
		}
		if( bSuccess == FALSE )
		{	// صΧûаʧ
			for( i=0; i<nRetNum; i++ )
			{
				retrns[i] = MAP_REGION_ERROR_BANK;
			}
		}
	}

	memcpy( pnRet, retrns, nRetNum*sizeof( int ) );
	return;
}
///////////

///////////
// ݵľ
// ptOff	:	ĻϽս
// nLayer, nCol, nRow	:	սά
// nFile	:	ݽṹļ
// return	:	ĻĵͷΧ
RECT MAP_GetOtherRect( CONST POINT ptOff, int nLayer, int nCol, int nRow, int nFile )
{
	int left, top;
	int widthG = MAP_Lib.szItem.cx;
	int heightG = MAP_Lib.szItem.cy;
	int width = MAP_Lib.Other[nFile].szItem.cx;
	int height = MAP_Lib.Other[nFile].szItem.cy;
	RECT rect;

	// calc top-left position on screen
	top = nRow*(heightG>>1) + heightG - height;	// ױӶ
	if( (nRow&1) == 0 )
	{
		left = nCol*widthG+(widthG>>1)-(width>>1);
	}
	else
	{
		left = (nCol+1)*widthG-(width>>1);
	}

	// re-adjust coords
	left -= ptOff.x;
	top -= ptOff.y;
	
	rect.left = left, rect.top = top, 
	rect.right = left+width, rect.bottom = top + height;
	return rect;
}
///////////
