/////////////////////
//	CBDraw.cpp		:	v0021
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.2 & DirectX
//	Library			:	DDraw.Lib
//	Copyright (C)	:	1996-1997 WayAhead Corporation
//	v0021			:	Jan.22.1997, devided from CBDraw.cpp
//  v0022			:	Sep.11.1997, HitTestU() parameters changed
/////////////////////
#include "stdafx.h"
#include <stdio.h>
#include "CBMouse.h"

#include "Assert.h"
#include "DDCompo.h"
#include "CBMap.h"
#include "CBGame.h"
#include "CBDraw.h"
#include "CBCtrl.h"
#include "CBEyes.h"
#include "CBMini.h"
#include "CBShadow.h"

#include "Marco.h"

/////////////////////
// external globals
// declared in CBDraw.cpp
extern RECT DRAW_rcScreen;
extern RECT DRAW_rcClient;
extern POINT DRAW_ptScreenOffset;
extern POINT DRAW_ptCovering[2][9];
/////////////////////

// private globals,for mouse control
/////////////////////
// array used for detecting if mouse hit the region
// ̽
int nByConts[MAP_ITEM_WIDTH][MAP_ITEM_HEIGHT];
/////////////////////

/////////////////////
// state of the cursor, ǲһpCursor״̬һ
int MOUSE_nState = MOUSE_STATE_NONE;
/////////////////////

/////////////////////
// local functions
BOOL MOUSE_bEnableTest=TRUE;
void MOUSE_testState( int nPosX, int nPosY );
/////////////////////

/////////////////////
// ʼ̽
extern CDDPalette palMain;
void MOUSE_InitByConts()
{
//ΪnByConts[MAP_ITEM_WIDTH][MAP_ITEM_HEIGHT]ֵ
	memset( nByConts, 0, MAP_ITEM_WIDTH*MAP_ITEM_HEIGHT );
	int halfwidth = MAP_ITEM_WIDTH>>1;
	int jj;
	for(int j=0; j<(MAP_ITEM_HEIGHT>>1); j++ ) 
	{
		jj = (j+1)<<1;
		for(int i=halfwidth-jj; i<halfwidth+jj; i++ )
		{
			nByConts[i][j]=1;
			nByConts[i][MAP_ITEM_HEIGHT-j-2]=1;
		}
	}
}
/////////////////////

/////////////////////
// Ч
// pt		:	ֱ꣬ӴGetCursorPos()еĵõģԵΪλ
// ظӣСУ
inline POINT MOUSE_hitTestPoint( POINT pt )
{
	POINT ptReturn;
	POINT ptGrid[3], ptOff[3];
	SIZE szItem;

	// initialize
	szItem.cx = MAP_Lib.szItem.cx, szItem.cy = MAP_Lib.szItem.cy;
	ptReturn.x = ptReturn.y = -1;

//	OutputString( pt.x, "," );
//	OutputString( pt.y, "\n" );

	// get grids position
	int halfy = szItem.cy>>1;
	int halfx = szItem.cx>>1;
	ptGrid[0].y = pt.y/(halfy);
	ptGrid[1].y = ptGrid[0].y-1;
	ptGrid[2].y = ptGrid[0].y-1;
	ptOff[0].y = pt.y - ptGrid[0].y*(halfy);
	ptOff[1].y = ptOff[0].y + halfy;
	ptOff[2].y = ptOff[0].y + halfy;
	int bOdd = ptGrid[0].y&1;
	int bEven = 1 - bOdd;
	ptGrid[0].x = (pt.x - halfx*bOdd) / szItem.cx;
	ptGrid[1].x = ptGrid[0].x + bOdd - 1; 
	ptGrid[2].x = ptGrid[0].x + bOdd;
	ptOff[0].x = pt.x - ptGrid[0].x*szItem.cx - halfx*bOdd;
	ptOff[1].x = pt.x - ptGrid[1].x*szItem.cx - halfx*bEven;
	ptOff[2].x = pt.x - ptGrid[2].x*szItem.cx - halfx*bEven;

	// check
	for( int i=0; i<3; i++ )
	{
		if( ptOff[i].x >= 0 && ptOff[i].y >= 0 &&
			ptOff[i].x < szItem.cx && ptOff[i].y < szItem.cy )
		{
			// test if in the points
			if( nByConts[ptOff[i].x][ptOff[i].y] == 1 )
			{
				// global position
//				ptReturn.x = DRAW_rcScreen.left + ptGrid[i].x + DRAW_SCREEN_ADJUST;
//				ptReturn.y = DRAW_rcScreen.top + ptGrid[i].y;
				ptReturn.x = ptGrid[i].x;// + DRAW_SCREEN_ADJUST;
				ptReturn.y = ptGrid[i].y;
				return ptReturn;
			}
		}
	}

	// set coords
	return ptReturn;
}

// ⵥԪ
// pt			:	ֱ꣬ӴGetCursorPos()еĵõģԵΪλ
// pHitResult	:	Ľ
// bEnemy		:	ֻѡʱΪ
// FALSEʱpHitResultЧ
BOOL MOUSE_HitTestU( POINT pt, struct MOUSE_HITRESULT_STRUCT *pHitResult, BOOL bEnemy/*=0*/ )
{
	POINT point, ptGrid;

	ptGrid.x = -1, ptGrid.y = -1;
	pHitResult->nType = MOUSE_HITRESULT_NONE;	// initialize

	pt.x += DRAW_ptScreenOffset.x, pt.y += DRAW_ptScreenOffset.y;
	ptGrid = MOUSE_hitTestPoint( pt );
	if( ptGrid.x == -1 || ptGrid.y == -1 )	return FALSE;
	Assert( ptGrid.x != -1 && ptGrid.y != -1 );
	pt.x -= DRAW_ptScreenOffset.x, pt.y -= DRAW_ptScreenOffset.y;

	// get display data
	point.x = ptGrid.x, point.y = ptGrid.y;
	WORD codeUEx = MAP_GetUnitDataEx( point.x, point.y );
	if( codeUEx != MAP_DATA_NONE )
	{
		struct UNIT_STRUCT * pUnit = MAP_GetUnit( codeUEx );
		// reset position
		point.x = pUnit->Draw.nX, point.y = pUnit->Draw.nY;

		// Please note:
		RECT rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pUnit->Draw );
		if( rect.left < pt.x && rect.right >= pt.x &&
			rect.top < pt.y && rect.bottom >= pt.y )
		{
			// õԪѾ
			// õԪǵˣbEnemyTRUE, Sep.11.1997
			struct UNIT_STRUCT *pUnit = MAP_GetUnit( codeUEx );
			Assert( pUnit );
			if( !EYE_IfUnitIsDead( pUnit ) 
				&& !( bEnemy == TRUE && pUnit->Draw.nPlayer == GAME.nMe ) )
			{
				BOOL bSet = TRUE;
				if( SHADOW_IfEnabled() )
				{
					WORD codeR = MAP_GetRegionData( point.x, point.y );
					struct MAP_REGION_CODE_STRUCT stctR;
					MAP_RegionDeCode( codeR, &stctR );
					if( stctR.nShadow == MAP_SHADOW_NONE || stctR.nShadowEx == 1 )
					{// κʽӰӦ
						bSet = FALSE;
					}
					if( pUnit->Draw.nPlayer == 0 )
					{// ԴӦ
						bSet = TRUE;
					}
				}
				if( bSet == TRUE )
				{
					pHitResult->nType = MOUSE_HITRESULT_UNIT;	
					pHitResult->nLayer = pUnit->Draw.nLayer;
					Assert( pHitResult->nLayer < 3 );
					pHitResult->wCode = codeUEx;
					pHitResult->ptHit.x = point.x;
					pHitResult->ptHit.y = point.y;
					return TRUE;
				}
			}
		}
	}

	for( int y=4; y>=0; y-- )
	for( int x=0; x<9; x++ )
	{
		// calc next position
		int bOdd = pt.y&1;
		point.x = ptGrid.x+DRAW_ptCovering[bOdd][x].x;
		point.y = ptGrid.y+DRAW_ptCovering[bOdd][x].y+y*2;
		if( EYE_IfOutOfRange( point.x, point.y ) )
			continue;

		// get display data
		WORD codeUEx = MAP_GetUnitDataEx( point.x, point.y );
		if( codeUEx != MAP_DATA_NONE )
		{
			struct UNIT_STRUCT * pUnit = MAP_GetUnit( codeUEx );
			// reset position
			point.x = pUnit->Draw.nX, point.y = pUnit->Draw.nY;
			RECT rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pUnit->Draw );
			if( rect.left < pt.x && rect.right >= pt.x &&
				rect.top < pt.y && rect.bottom >= pt.y )
			{
				// õԪѾ
				// õԪǵˣbEnemyTRUE, Sep.11.1997
				struct UNIT_STRUCT *pUnit = MAP_GetUnit( codeUEx );
				Assert( pUnit );
				if( !EYE_IfUnitIsDead( pUnit ) 
					&& !( bEnemy == TRUE && pUnit->Draw.nPlayer == GAME.nMe ) )
				{
					BOOL bSet = TRUE;

					if( SHADOW_IfEnabled() )
					{
						WORD codeR = MAP_GetRegionData( point.x, point.y );
						struct MAP_REGION_CODE_STRUCT stctR;
						MAP_RegionDeCode( codeR, &stctR );
						if( stctR.nShadow == MAP_SHADOW_NONE || stctR.nShadowEx == 1 )
						{
							bSet = FALSE;
						}
					}
					if( bSet == TRUE )
					{
						pHitResult->nType = MOUSE_HITRESULT_UNIT;
						pHitResult->nLayer = pUnit->Draw.nLayer;
						pHitResult->wCode = codeUEx;
						pHitResult->ptHit.x = point.x;
						pHitResult->ptHit.y = point.y;

						return TRUE;
					}
				}
			}
		}
	}

	// else return false
//	OutputDebugString( "HitTestU: Not Detected!\n" );
	return FALSE;
}

// 
// pt			:	ֱ꣬ӴGetCursorPos()еĵõģԵΪλ
// pHitResult	:	Ľ
// nLayer		:	ĲȱʡֵΪ2ĵζҪ
// FALSEʱpHitResultЧ
BOOL MOUSE_HitTestG( POINT pt, struct MOUSE_HITRESULT_STRUCT *pHitResult, int nLayer/* = 2*/ )
{
	POINT ptGrid;
	POINT point;
	WORD codeG;

	// initialize
	ptGrid.x = -1, ptGrid.y = -1;
	pHitResult->nType = MOUSE_HITRESULT_NONE;

	pt.x += DRAW_ptScreenOffset.x, pt.y += DRAW_ptScreenOffset.y;
	point.x = pt.x;
	for( int i=nLayer; i>=0 ; i-- )
	{
		point.y = pt.y+MAP_Lib.nHeight[i+1];
		ptGrid = MOUSE_hitTestPoint( point );
		// hit point test
		if( ptGrid.x == -1 || ptGrid.y == -1 )	return FALSE;	// not hit any point

		codeG = MAP_GetGroundData( i, ptGrid.x, ptGrid.y );
		if( codeG != MAP_DATA_NONE )
		{
			pHitResult->nType = MOUSE_HITRESULT_GROUND;	
			pHitResult->nLayer = i;
			Assert( i < 3 );
			pHitResult->wCode = codeG;
			pHitResult->ptHit.x = ptGrid.x;
			pHitResult->ptHit.y = ptGrid.y;
			return TRUE;
		}
	}
	// else return false
//	OutputDebugString( "HitTestG: Not Detected!\n" );
	return FALSE;
}

// ȼκⵥԪ
// pt			:	ֱ꣬ӴGetCursorPos()еĵõģԵΪλ
// pHitResult	:	Ľ
// FALSEʱpHitResultЧ
BOOL MOUSE_HitTestGU( POINT pt, struct MOUSE_HITRESULT_STRUCT *pHitResult )
{
	if( !MOUSE_HitTestG( pt, pHitResult ) )
	{
		return MOUSE_HitTestU( pt, pHitResult );
	}
	return TRUE;
}

// ȼⵥԪ
// pt			:	ֱ꣬ӴGetCursorPos()еĵõģԵΪλ
// pHitResult	:	Ľ
// bEnemy		:	ֻѡʱΪ
// FALSEʱpHitResultЧ
BOOL MOUSE_HitTestUG( POINT pt, struct MOUSE_HITRESULT_STRUCT *pHitResult, BOOL bEnemy /*=0*/ )
{
	if( !MOUSE_HitTestU( pt, pHitResult, bEnemy ) )
	{
		return MOUSE_HitTestG( pt, pHitResult );
	}
	return TRUE;
}
/////////////////////

/////////////////////
// test mouse dragging

// globals
// synchronization for drag and draw
BOOL MOUSE_bSemaphore = FALSE;

// if left mouse button is down
BOOL MOUSE_bLeftDown = FALSE;
BOOL MOUSE_bLeftDownLast = FALSE;

/*
// if right mouse button is down
BOOL MOUSE_bRightDown = FALSE;
BOOL MOUSE_bRightDownLast = FALSE;
*/

// dragging rectangle, and the old one
RECT MOUSE_rcDrag, MOUSE_rcDragLast;

// the first point mouse button down
POINT MOUSE_ptFirst;

// save the origional mouse moving range
RECT rcOldRange;

// if mouse left button down, set down flag, begin dragging process
// nPosX, nPosY	:	mouse cursor position
void MOUSE_LeftDown( int nPosX, int nPosY )
{
	// clear semaphore flag
	MOUSE_bSemaphore = FALSE;

	// set the flag
	if( MOUSE_bLeftDown == TRUE )
		return;
	MOUSE_bLeftDown = TRUE;
	MOUSE_bLeftDownLast = TRUE;

	// set value to MOUSE_rcDrag
	SetRect( &MOUSE_rcDrag, nPosX, nPosY, nPosX, nPosY );
	SetRect( &MOUSE_rcDragLast, nPosX, nPosY, nPosX, nPosY );
	MOUSE_ptFirst.x = nPosX, MOUSE_ptFirst.y = nPosY;

	// set mouse cursor new range
	class CDDCursor *pCursor;
	pCursor = CURSOR_Get();
	Assert( pCursor!= NULL );
	rcOldRange = pCursor->SetRange( &DRAW_rcClient );
	Assert( rcOldRange.left == 0 && rcOldRange.top == 0 );

	// change cursor state
	MOUSE_testState( nPosX, nPosY );
}

// if mouse left button up, clear down flag, end dragging process
// nPosX, nPosY	:	mouse cursor position
// return		:	dragging rectangle
RECT MOUSE_LeftUp( int nPosX, int nPosY )
{
	// clear the flag
	if( MOUSE_bLeftDown )
	{
		MOUSE_bLeftDown = FALSE;

		// set mouse cursor with old range
		class CDDCursor *pCursor;
		pCursor = CURSOR_Get();
		Assert( pCursor != NULL );
		Assert( rcOldRange.left == 0 && rcOldRange.top == 0 );
		if( rcOldRange.left != 0 )
		{
			rcOldRange.left = rcOldRange.top = 0;
			rcOldRange.right = GetSystemMetrics( SM_CXSCREEN );
			rcOldRange.bottom = GetSystemMetrics( SM_CYSCREEN );
		}
		pCursor->SetRange( &rcOldRange );
	}
	else
	{
		SetRectEmpty( &MOUSE_rcDrag );
	}

	// change cursor state
	MOUSE_testState( nPosX, nPosY );

	return MOUSE_rcDrag;
}

// if mouse is moving with left button holds down, do dragging process
// nPosX, nPosY	:	mouse cursor position
void MOUSE_IsLeftDown( int nPosX, int nPosY )
{
	// change cursor state
	MOUSE_testState( nPosX, nPosY );

	if( !MOUSE_bLeftDown )
	{
		return;
	}

	// 
	// if semaphore is not light, ignore this function
	if( MOUSE_bSemaphore == FALSE ) return;
	MOUSE_bSemaphore = FALSE;

	// save old dragging rectangle
	SetRect( &MOUSE_rcDragLast, 
			 MOUSE_rcDrag.left, MOUSE_rcDrag.top,
			 MOUSE_rcDrag.right, MOUSE_rcDrag.bottom );

	// set value to MOUSE_rcDrag
	if( nPosX < MOUSE_ptFirst.x )
	{
		MOUSE_rcDrag.left = nPosX;
		MOUSE_rcDrag.right = MOUSE_ptFirst.x;
	}
	else
	{
		MOUSE_rcDrag.left = MOUSE_ptFirst.x;
		MOUSE_rcDrag.right = nPosX;
	}

	if( nPosY < MOUSE_ptFirst.y )
	{
		MOUSE_rcDrag.top = nPosY;
		MOUSE_rcDrag.bottom = MOUSE_ptFirst.y;
	}
	else
	{
		MOUSE_rcDrag.top = MOUSE_ptFirst.y;
		MOUSE_rcDrag.bottom = nPosY;
	}
}

// display dragging rectangle to back buffer
void MOUSE_DrawDragRect()
{
	if( !MOUSE_bLeftDown )	return;

	// set synchronization flag
	MOUSE_bSemaphore = TRUE;

	// draw rectangle
	DDC_FrameRect( &MOUSE_rcDrag, RGB(0,255,0), FALSE );
}

// update dragging rectangle to front buffer
void MOUSE_UpdateDrag()
{
	if( !MOUSE_bLeftDownLast )	return;
	MOUSE_bLeftDownLast = MOUSE_bLeftDown;

	RECT rcUpdate;

	// update old dragging rectangle
	// update left border
	SetRect( &rcUpdate, 
			 MOUSE_rcDragLast.left, MOUSE_rcDragLast.top,
			 MOUSE_rcDragLast.left+1, MOUSE_rcDragLast.bottom+1 );
	DDC_UpdateScreen( &rcUpdate );

	// update top border
	SetRect( &rcUpdate, 
			 MOUSE_rcDragLast.left, MOUSE_rcDragLast.top,
			 MOUSE_rcDragLast.right+1, MOUSE_rcDragLast.top+1 );
	DDC_UpdateScreen( &rcUpdate );

	// update right border
	SetRect( &rcUpdate, 
			 MOUSE_rcDragLast.right-1, MOUSE_rcDragLast.top-1,
			 MOUSE_rcDragLast.right, MOUSE_rcDragLast.bottom );
	DDC_UpdateScreen( &rcUpdate );

	// update bottom border
	SetRect( &rcUpdate, 
			 MOUSE_rcDragLast.left-1, MOUSE_rcDragLast.bottom-1,
			 MOUSE_rcDragLast.right, MOUSE_rcDragLast.bottom );
	DDC_UpdateScreen( &rcUpdate );

	// udpate new dragging rectangle
	// update left border
	SetRect( &rcUpdate, 
			 MOUSE_rcDrag.left, MOUSE_rcDrag.top,
			 MOUSE_rcDrag.left+1, MOUSE_rcDrag.bottom+1 );
	DDC_UpdateScreen( &rcUpdate );

	// update top border
	SetRect( &rcUpdate, 
			 MOUSE_rcDrag.left, MOUSE_rcDrag.top,
			 MOUSE_rcDrag.right+1, MOUSE_rcDrag.top+1 );
	DDC_UpdateScreen( &rcUpdate );

	// update right border
	SetRect( &rcUpdate, 
			 MOUSE_rcDrag.right-1, MOUSE_rcDrag.top-1,
			 MOUSE_rcDrag.right, MOUSE_rcDrag.bottom );
	DDC_UpdateScreen( &rcUpdate );

	// update bottom border
	SetRect( &rcUpdate, 
			 MOUSE_rcDrag.left-1, MOUSE_rcDrag.bottom-1,
			 MOUSE_rcDrag.right, MOUSE_rcDrag.bottom );
	DDC_UpdateScreen( &rcUpdate );
}
/////////////////////

/////////////////////
// test if mouse hit in the minimap
// nPosX,nPosY	:	mouse hit position from screen, in grid
// return		:	the relative position to whole battlefield map that mouse hit,
//					in grid
POINT MOUSE_InMiniMap( int nPosX, int nPosY )
{
	POINT ptRet = {-1,-1};

	// test if minimap loaded
	if( MINI_Lib.nType == -1 )	return ptRet;

	POINT ptHit;
	ptHit.x = nPosX, ptHit.y = nPosY;
	if( PtInRect( &MINI_Lib.rcMap[MINI_Lib.nType], ptHit ) )
	{
		ptRet.x = ptHit.x - MINI_Lib.rcMap[MINI_Lib.nType].left;
		ptRet.y = (ptHit.y - MINI_Lib.rcMap[MINI_Lib.nType].top)<<2;
	}
	return ptRet;
}
/////////////////////

/////////////////////
// change grid position to point position
// ptPos:	grid position
POINT MOUSE_Grid2Point( int nLayer, POINT ptPosG )
{
	int top, left;
	POINT ptPos;

	top = (ptPosG.y*MAP_Lib.szItem.cy>>1);
	top -= MAP_Lib.nHeight[nLayer+1];
	if( (ptPosG.y&1) == 0 )
	{
		left = ptPosG.x*MAP_Lib.szItem.cx;
	}
	else
	{
		left = ptPosG.x*MAP_Lib.szItem.cx+(MAP_Lib.szItem.cx>>1);
	}
//	left = left - DRAW_ptScreenOffset.x;
//	top = top - DRAW_ptScreenOffset.y;
	left = left - DRAW_ptScreenOffset.x+(MAP_Lib.szItem.cx>>1);
	top = top - DRAW_ptScreenOffset.y+(MAP_Lib.szItem.cy>>1);
	ptPos.x = left, ptPos.y = top;
	return ptPos;
}

// nState	:	new state
// bForce	:	TRUE if set the state exactly you give
void MOUSE_SetState( int nState, BOOL bForce /*=FALSE*/ )
{
	// get cursor pointer
	class CDDCursor *pCursor;
	pCursor = CURSOR_Get();
	Assert( pCursor );

	MOUSE_nState = nState;
	pCursor->SetState( nState );
	if( bForce == TRUE )
	{
		if( GAME.nProgramState != PROGRAM_STATE_PLAY )
		{
			MOUSE_LeftUp( 0, 0 );
		}
	}
	else
	{
		POINT ptPos = pCursor->GetPos();
		MOUSE_testState( ptPos.x, ptPos.y );
	}
}


void MOUSE_testState( int nPosX, int nPosY )
{
	BOOL bReset = FALSE;
	int nState;
	class CDDCursor *pCursor;

	if( !MOUSE_bEnableTest ) return;
	// get cursor pointer
	pCursor = CURSOR_Get();
	Assert( pCursor );
	nState = pCursor->GetState();

	// жǷڿͻ
	if( DRAW_rcClient.left > nPosX
		|| DRAW_rcClient.top > nPosY
		|| DRAW_rcClient.right < nPosX
		|| DRAW_rcClient.bottom < nPosY )
	{	// ڿͻ⣬ʱΪNONE
		if( nState!= MOUSE_STATE_NONE )
		{
			nState = MOUSE_STATE_NONE;
			bReset = TRUE;
		}
	}
	else
	{
		// жǷ
		if( !MOUSE_bLeftDown )
		{	// ûа£λú״̬ı״̬

			// ǰµ״ָ̬Ϊԭʼ״̬
			if( nState == MOUSE_STATE_DOWN )
			{
				nState = MOUSE_STATE_NONE;
				bReset = TRUE;
			}
			// ոսͻָΪԭʼ״̬
			else if( nState == MOUSE_STATE_NONE
				&& MOUSE_nState != nState )
			{
				nState = MOUSE_nState;
				bReset = TRUE;
			}

			// ĳԪѡзΧΪӦ״̬
			BOOL bFind = FALSE;
			POINT pt;
			struct MOUSE_HITRESULT_STRUCT hitResult;
			pt.x = nPosX, pt.y = nPosY;
			if( MOUSE_HitTestU( pt, &hitResult ) )
			{	// ⵽Ԫ
				switch( MOUSE_nState )
				{	
				case	MOUSE_STATE_NONE:		// ʱ
					// ĿĵǵԪ
					if( nState != MOUSE_STATE_EYE )
					{
						nState = MOUSE_STATE_EYE;
						bReset = TRUE;
					}
					bFind = TRUE;
					break;
				case	MOUSE_STATE_GONGJI:		// ѡй
					{	// ĿĵǵзҷĵԪ
						struct UNIT_STRUCT *pUnit = MAP_GetUnit( hitResult.wCode );
						Assert( pUnit );
						if( nState == MOUSE_STATE_GONGJI )
						{
							if( EYE_PlayerIsAllied( GAME.nMe, pUnit->Draw.nPlayer ) )
								nState = MOUSE_STATE_GONGJI_END1;
							else
								nState = MOUSE_STATE_GONGJI_END2;
							bReset = TRUE;
						}
						bFind = TRUE;
					}
					break;
				case	MOUSE_STATE_YUNSONG:	// ѡ
					// Ŀĵǽ͵Դ
					{
						struct UNIT_STRUCT *pUnit = MAP_GetUnit( hitResult.wCode );
						Assert( pUnit );
						//if( EYE_IfUnitIsRes( pUnit ) )
						if( EYE_GetUResType( pUnit ) != QXZIYUAN )
						{
							if( nState == MOUSE_STATE_YUNSONG )
							{
								nState = MOUSE_STATE_YUNSONG_END;
								bReset = TRUE;
							}
							bFind = TRUE;
						}
					}
					break;
				case	MOUSE_STATE_JIARU:		// ѡм
					{	// Ŀĵǽ
						struct UNIT_STRUCT *pUnit = MAP_GetUnit( hitResult.wCode );
						Assert( pUnit );
						if( EYE_IfSheIsMine( pUnit ) )
						{
							pUnit = EYE_GetGeneral( pUnit );
							if( pUnit != NULL )
							{
								if( nState == MOUSE_STATE_JIARU )
								{
									nState = MOUSE_STATE_JIARU_END;
									bReset = TRUE;
								}
								bFind = TRUE;
							}
						}
					}
					break;
				}
			}// End of if( MOUSE_HitTestU( pt, &hitResult ) )
			else if( MOUSE_nState == MOUSE_STATE_YUNSONG )
			{	// δ⵽Ԫ
				// ڼ͵Դ
				pt.y += 15;
				if( MOUSE_HitTestG( pt, &hitResult ) 
					&& EYE_GetGResType( hitResult.nLayer, hitResult.ptHit.x, hitResult.ptHit.y ) 
						!= QXZIYUAN )
				{	// ⵽͵Դ
					if( nState == MOUSE_STATE_YUNSONG )
					{
						nState = MOUSE_STATE_YUNSONG_END;
						bReset = TRUE;
					}
					bFind = TRUE;
				}
			}// End of else if( MOUSE_nState == MOUSE_STATE_YUNSONG )

			// Ƿָ״̬
			if( bFind == FALSE
				&& nState != MOUSE_nState )
			{	// δ⵽Ԫ
				nState = MOUSE_nState;
				bReset = TRUE;
			}// End of if( bFind == FALSE && nState != MOUSE_nState )
		}// End of if( !MOUSE_bLeftDown )
		else
		{	// 
			if( nState != MOUSE_STATE_DOWN )
			{
				nState = MOUSE_STATE_DOWN;
				bReset = TRUE;
			}
		}// End of else if( !MOUSE_bLeftDown )
	}

	// reset cursor state
	if( bReset )
		pCursor->SetState( nState );
}

void MOUSE_EnableTest( BOOL bEnable/*=TRUE*/ )
{
	MOUSE_bEnableTest = bEnable;
}
/////////////////////
