/////////////
//	DDCompo.cpp		:	v0043
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.0 & DirectX
//	Library			:	DDraw.Lib
//	Copyright (C)	:	1996 WayAhead Corporation 
//	v0020			:	Nov.12.1996
//	v0030			:	Dec.11.1996, upgrade to DirectDraw 2.0 or higher
//	v0031			:	Jan.22.1997, fix one reported bug, and change something in SetRange()
//	v0040			:	Feb.13.1997, changed some cursor functions, deleted surface m_lpSpriteBuffer
//	v0041			:	Mar.5.1997,	add member m_bShow and function Show()
//	v0042			:	Mar.22.1997, add some global functions for cursor
//						Fixed a bug when cursor is animating, add Erase() to CDDCursor
//	v0043			:	Apr.9.1997, changed the name of one of cursor's member m_bCreated to m_bCreatedC
/////////////
// implementation file
// DirectDraw components
// mouse cursor, framerate, etc
// ļDDAPIϱȽϽܣʹһЩDDAPIȫֱ

#include "stdafx.h"
#include "Assert.h"	// ErrorMessage(), Assert()
#include "DDCompo.h"
#include "mmsystem.h"
#include "L_Allbmp.h"
//////////////////////////////

// globals
//////////////////////////////
// mouse cursor
class CDDCursor		*DDC_pCursor = NULL;	// current mouse cursor pointer
// MMX Cheater
extern MAIN_bMMX;
/////////

/////////
// frame rate
class CDDSurface	DDC_sFrameRate;
#ifdef	_DEBUG
BOOL                DDC_bShowFrameRate=TRUE;
#else
BOOL                DDC_bShowFrameRate=FALSE;
#endif
DWORD               DDC_dwFrameCount;
DWORD               DDC_dwFrameTime;
DWORD				DDC_dwFrames;

// display functions
#ifdef	_CURSOR_OLD_VERSION_
// spriteʾΧ
RECT	DDC_rcSpriteRange={0,0,SCREEN_WIDTH, SCREEN_HEIGHT};

// max size of each sprite
// spriteľγ2¾λõܾβܴڴֵŻʾ
SIZE	DDC_szSpriteMax={320, 200};
#endif	// _CURSOR_OLD_VERSION_
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
// frame rate
/////////////////////////
// load frame rate file
// filename		:	bitmap file to display framerate
// return value	:	TRUE if succeeded
BOOL DDC_LoadFrameRate( LPCTSTR filename )
{
    DDC_dwFrameTime = timeGetTime();
	// no color key, in system memory
	if( !DDC_sFrameRate.LoadBitmap( filename, FALSE, FALSE ) )
		return FALSE;
	return TRUE;
}

// set if should show frame rate
// bShow	:	TRUE for show frame rate
void DDC_ShowFrameRate( BOOL bShow/* = TRUE */)
{
	DDC_bShowFrameRate = bShow;
	DDC_dwFrameCount = 0;
	DDC_dwFrameTime = timeGetTime();
	
	// update screen
	RECT rect;
	SetRect( &rect, 0, 0, 96, 16 );
	DDC_UpdateScreen( &rect );
}

// show display frame rate
void DDC_DisplayFrameRate( void )
{
    DWORD               time2;

	static DWORD        dwFramesLast;

	if( !DDC_bShowFrameRate )	return;

    DDC_dwFrameCount++;
    time2 = timeGetTime() - DDC_dwFrameTime;
    dwFramesLast = DDC_dwFrames;
    if( time2 > 1000 )
    {
        DDC_dwFrames = (DDC_dwFrameCount*1000)/time2;
        DDC_dwFrameTime = timeGetTime();
        DDC_dwFrameCount = 0;
    }

	if( DDC_dwFrames >999999 )	DDC_dwFrames = 999999;

	// drawing
	if( dwFramesLast == DDC_dwFrames )	return;

/*
	//--- MMX Cheater --- Liu Gang
	if( !MAIN_bMMX )
	{
		if( DDC_dwFrames < 5 ) DDC_dwFrames -= 1;
		else if( DDC_dwFrames < 10 ) DDC_dwFrames -= 2;
		else if( DDC_dwFrames < 20 ) DDC_dwFrames -= 4;
		else if( DDC_dwFrames < 30 ) DDC_dwFrames -= 6;
		else if( DDC_dwFrames < 40 ) DDC_dwFrames -= 8;
		if( DDC_dwFrames <= 0 )	DDC_dwFrames = 1;
	}
	//--- MMX Cheater ---
*/	
	DWORD dwFrames = DDC_dwFrames;
	// update to front buffer
	for ( int i=0; i< 6; i++ )
	{
		int num  = dwFrames%10;
		RECT rect;
		POINT ptDest;
		rect.top = 0;
		rect.bottom = 16;
		rect.left = 16*num;
		rect.right = rect.left + 16;
		ptDest.x = 16*5-16*i, ptDest.y = 0;
		DDC_sFrameRate.BltToFront( ptDest, &rect );
		dwFrames = dwFrames/10;
	}
}

// get frame rate
int DDC_GetFrameRate()
{
	return DDC_dwFrames;
}
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
// cursor
// constructor
CDDCursor::CDDCursor()
{
	m_bCreatedC = FALSE;
	m_bShow = TRUE;

#ifdef	_CURSOR_OLD_VERSION_
	m_lpSpriteBuffer = NULL;	// Sprite buffer
#endif	// _CURSOR_OLD_VERSION_

	m_lpMixBuffer = NULL;	// mix buffer

	m_szSize.cx = 0, m_szSize.cy = 0;
	GetCursorPos( &m_ptPos );

	m_rcRange.left = 0,
	m_rcRange.top = 0,
	m_rcRange.right = SCREEN_WIDTH,
	m_rcRange.bottom = SCREEN_HEIGHT;
	m_nState = DDC_CURSOR_STATE_NORMAL;
	m_nStateLast = DDC_CURSOR_STATE_NORMAL;
	m_nFrame = 0;
	m_nFrameLast = 0;
	m_nSpeed = 5;

	for( int i=0; i<DDC_CURSOR_STATE_MAX; i++ )
	{
		m_ptHotspot[i].x = 15,
		m_ptHotspot[i].y = 15;
	}

	for( int j=0; j<DDC_CURSOR_STATE_MAX; j++ )
		m_nFrameCount[j] = 1;
}

// destructor
CDDCursor::~CDDCursor()
{
	Release();
}

// load cursor
// create cursor 
// filename		:	cursor bitmap filename 
// nCol			:	cursor state, λͼУСһ, cannot be zero
// nRow			:	cursor frame, λͼУÿһ֡, cannot be zero
// return value	:	TRUE if succeeded
BOOL CDDCursor::Load( LPCTSTR filename, int nCol/*=1*/, int pnRow[]/*=NULL*/, POINT pptHotspot[]/*=NULL*/ )
{
	// load bitmap from file
	// has color key, auto
	if( GetSurface() )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+7, "cannot load cursor twice!" );
		return FALSE;
	}
	// has color key, in system memory
	if( !LoadBitmap( filename, TRUE, FALSE ) )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+0, "Cannot open cursor bitmap file! ", filename );
		return FALSE;
	}
	
// set members
	// set size of cursor
	m_szSize = GetSize();

	// set frame counters, rows per column
	int nRowMax=1;
	if( pnRow )
	{
		for( int i=0; i<nCol; i++ )
		{
			m_nFrameCount[i] = pnRow[i];
			if( nRowMax < m_nFrameCount[i] )
				nRowMax = m_nFrameCount[i];
		}
	}

	// set hotspots of cursor in each state
	if( pptHotspot )
	{
		for( int i=0; i<nCol; i++ )
		{
			m_ptHotspot[i] = pptHotspot[i];
		}
	}

	if( nCol == 0 )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+1, "Column cannot be zero!" );
		return FALSE;
	}
	if( nRowMax == 0 )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+2, "Any row cannot be zero!" );
		return FALSE;
	}
	m_szSize.cy /= nCol;
	m_szSize.cx /= nRowMax;

	// create mix buffer
	BOOL retrn;
	if( m_lpMixBuffer )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+4, "cannot load cursor mix buffer twice!" );
		return FALSE;
	}
	m_lpMixBuffer = new CDDSurface;
	// no color key, in system memory
	retrn = m_lpMixBuffer->Create( m_szSize.cx*2, m_szSize.cy*2, FALSE, FALSE );
	if( !retrn )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+3, "Cannot create mix buffer for cursor!" );
		return FALSE;
	}

#ifdef	_CURSOR_OLD_VERSION_
	// create sprite buffer
	if( m_lpSpriteBuffer )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+5, "Cannot create cursor sprite buffer twice!" );
		return FALSE;
	}
	m_lpSpriteBuffer = new CDDSurface;
	// no color key, in system memory
	retrn = m_lpSpriteBuffer->Create( DDC_szSpriteMax.cx, DDC_szSpriteMax.cy, FALSE, FALSE );
	if( !retrn )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+6, "Cannot create sprite buffer for cursor!" );
		return FALSE;
	}
#endif	// _CURSOR_OLD_VERSION_

	m_bCreatedC = TRUE;
	return TRUE;
}

// load cursor
// create cursor 
// filename		:	cursor bitmap compact file
// nIndex		:	index number in compact file
// nCol			:	cursor state, λͼУСһ, cannot be zero
// nRow			:	cursor frame, λͼУÿһ֡, cannot be zero
// return value	:	TRUE if succeeded
BOOL CDDCursor::LoadEx( LPSTR filename, LPSTR fileIndex, int nIndex, int nCol/*=1*/, int pnRow[]/*=NULL*/, POINT pptHotspot[]/*=NULL*/ )
{
	// load bitmap from file
	// has color key, auto
	if( GetSurface() )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+7, "cannot load cursor twice!" );
		return FALSE;
	}

	class CPicture_imageall picture;

	picture.image_open_compress(filename);
	picture.image_open_index(fileIndex);
	picture.LoadBitmap( this, nIndex );
	picture.image_close_index();
	picture.image_close_compress();

	SetColorKeyRGB( RGB(0,0,0) );

// set members
	// set size of cursor
	m_szSize = GetSize();

	// set frame counters, rows per column
	int nRowMax=1;
	if( pnRow )
	{
		for( int i=0; i<nCol; i++ )
		{
			m_nFrameCount[i] = pnRow[i];
			if( nRowMax < m_nFrameCount[i] )
				nRowMax = m_nFrameCount[i];
		}
	}

	// set hotspots of cursor in each state
	if( pptHotspot )
	{
		for( int i=0; i<nCol; i++ )
		{
			m_ptHotspot[i] = pptHotspot[i];
		}
	}

	if( nCol == 0 )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+1, "Column cannot be zero!" );
		return FALSE;
	}
	if( nRowMax == 0 )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+2, "Any row cannot be zero!" );
		return FALSE;
	}
	m_szSize.cy /= nCol;
	m_szSize.cx /= nRowMax;

	// create mix buffer
	BOOL retrn;
	if( m_lpMixBuffer )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+4, "cannot load cursor mix buffer twice!" );
		return FALSE;
	}
	m_lpMixBuffer = new CDDSurface;
	// no color key, in system memory
	retrn = m_lpMixBuffer->Create( m_szSize.cx*2, m_szSize.cy*2, FALSE, FALSE );
	if( !retrn )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+3, "Cannot create mix buffer for cursor!" );
		return FALSE;
	}

#ifdef	_CURSOR_OLD_VERSION_
	// create sprite buffer
	if( m_lpSpriteBuffer )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+5, "Cannot create cursor sprite buffer twice!" );
		return FALSE;
	}
	m_lpSpriteBuffer = new CDDSurface;
	// no color key, in system memory
	retrn = m_lpSpriteBuffer->Create( DDC_szSpriteMax.cx, DDC_szSpriteMax.cy, FALSE, FALSE );
	if( !retrn )
	{
		ErrorMessage( hwndGame, DDC_ERROR_ID+6, "Cannot create sprite buffer for cursor!" );
		return FALSE;
	}
#endif	// _CURSOR_OLD_VERSION_

	m_bCreatedC = TRUE;
	return TRUE;
}

// release cursor
void CDDCursor::Release()
{
	CDDSurface::Release();

#ifdef	_CURSOR_OLD_VERSION_
	if( m_lpSpriteBuffer )
	{
		m_lpSpriteBuffer->Release();
		delete m_lpSpriteBuffer;
		m_lpSpriteBuffer = NULL;
	}
#endif	// _CURSOR_OLD_VERSION_

	if( m_lpMixBuffer )
	{
		m_lpMixBuffer->Release();
		delete m_lpMixBuffer;
		m_lpMixBuffer = NULL;
	}
	m_bCreatedC = FALSE;
}

// set cursor moving range
// this may effects other cursor's range
// rcRange	:	new range for mouse moving in
// return value	:	old range for mouse moving in
// Warning	:	A bug report here:
//				Cannot erase old cursor if change range in run time
//				but this be fixed on Jan.22.1997
RECT CDDCursor::SetRange( CONST RECT *lprcRange )
{

	RECT rcRangeOld;
	rcRangeOld.left = m_rcRange.left,
	rcRangeOld.top = m_rcRange.top,
	rcRangeOld.right = m_rcRange.right,
	rcRangeOld.bottom = m_rcRange.bottom;

	// erase cursor in old position
	if( m_bCreatedC )
		DD_UpdateScreen( &GetRect() );

	m_rcRange.left = lprcRange->left,
	m_rcRange.top = lprcRange->top,
	m_rcRange.right = lprcRange->right,
	m_rcRange.bottom = lprcRange->bottom;

	// set cursor moving range
	ClipCursor( &m_rcRange );

	// redraw it right now
	if( m_bCreatedC )
		Draw( TRUE );
	
	return rcRangeOld;
}

// change cursor to next frame when display
void CDDCursor::Animate()
{

	Assert( m_bCreatedC );

	static int nTimer=0;
	nTimer ++;
	if( nTimer >= m_nSpeed )
	{
		nTimer = 0;
		m_nFrameLast = m_nFrame;
		m_nFrame = ( m_nFrame+1 )%m_nFrameCount[m_nState];
	}
	Draw( TRUE );
}

// set cursor state
// nState		:	new state
// return value	:	old state
int	CDDCursor::SetState( int nState )
{
	if( m_bCreatedC )
	{
		Erase();	// erase old
	}

	m_nStateLast = m_nState;
	m_nState = nState;
	// reset frame
	m_nFrameLast = m_nFrame;	m_nFrame = 0;
	if( m_bCreatedC )
	{
//		Draw( TRUE );	// draw new
	}
	return m_nStateLast;
}

// set cursor frame
// nFrame		:	new frame
// return value	:	old frame
int CDDCursor::SetFrame( int nFrame )
{
	m_nFrameLast = m_nFrame;
	m_nFrame = nFrame;
	if( m_bCreatedC )
		Draw( TRUE );
	return m_nFrameLast;
}

// set animate speed
// nSpeed		:	new speed
// return value	:	old speed
int CDDCursor::SetSpeed( int nSpeed )
{
	int nSpeedLast = m_nSpeed;
	m_nSpeed = nSpeed;
	return nSpeedLast;
}

// get cursor rectangle
RECT CDDCursor::GetRect()
{
	RECT rcDest;
	rcDest.left = m_ptPos.x - m_ptHotspot[m_nState].x;
	rcDest.top = m_ptPos.y - m_ptHotspot[m_nState].y;
	rcDest.right = rcDest.left + m_szSize.cx;
	rcDest.bottom = rcDest.top + m_szSize.cy;
	return rcDest;
}

// ӦóʾʱӦʹô˺
// draw cursor to front surface
// bForce		:	TRUE for force draw the cursor, 
//					usually used after changing the state or frame of a cursor
// bForce		:	TRUE for force drawing
// return value	:	TRUE for has drew
BOOL CDDCursor::Draw( BOOL bForce/*=FALSE*/ )
{
	//if( !m_bCreatedC )	return FALSE;
	Assert( m_bCreatedC == TRUE );
	if( !m_bShow	)	return FALSE;

	POINT ptPosOld;
	RECT rcDest1, rcDest2;
	RECT rcSrcFile;

	ptPosOld.x = m_ptPos.x;
	ptPosOld.y = m_ptPos.y;

	// get old destination rectangle
	rcDest1 = GetRect();

	// get current cursor position
	GetCursorPos( &m_ptPos );

	// test if needn't draw
	if( m_ptPos.x == ptPosOld.x && m_ptPos.y == ptPosOld.y && !bForce )
		return FALSE;	// needn't 

	// get current destination rectangle
	rcDest2 = GetRect();

	// get source rectangle of the bitmap file
	rcSrcFile.left = m_nFrame*m_szSize.cx;
	rcSrcFile.top = m_nState*m_szSize.cy;
	rcSrcFile.right = rcSrcFile.left + m_szSize.cx;
	rcSrcFile.bottom = rcSrcFile.top + m_szSize.cy;

	// calculate if the two rectangles cross
	POINT ptDest;	// destination position
	RECT rcSrc;		// source rectangle

	// if they cross
	if( IntersectRect( &rcSrc, &rcDest1, &rcDest2 ) )
	{	// draw it together
		RECT rcSrcUni;	// intersection of the two rectangles
		UnionRect( &rcSrcUni, &rcDest1, &rcDest2 );
		// step 1:	draw back buffer to mix buffer
		IntersectRect( &rcSrc, &rcSrcUni, &m_rcRange );
		ptDest.x = rcSrc.left - rcSrcUni.left;
		ptDest.y = rcSrc.top - rcSrcUni.top;
		m_lpMixBuffer->BltSurface( ptDest.x, ptDest.y, DD_GetBackBuffer(), &rcSrc, DDBLTFAST_NOCOLORKEY );
		// step 2:	draw cursor to mix buffer in new position
		ptDest.x = rcDest2.left - rcSrcUni.left;
		ptDest.y = rcDest2.top - rcSrcUni.top;
		m_lpMixBuffer->BltSurface( ptDest.x, ptDest.y, GetSurface(), &rcSrcFile, GetDrawFlag() );
		// step 3:	draw mix buffer to front buffer
		IntersectRect( &rcSrc, &rcSrcUni, &m_rcRange );
		ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
		rcSrc.left -= rcSrcUni.left, rcSrc.top -= rcSrcUni.top;
		rcSrc.right -= rcSrcUni.left;
		rcSrc.bottom -= rcSrcUni.top;
		m_lpMixBuffer->BltToFront( ptDest, &rcSrc );
	}
	else
	{	// draw it seperatly
		// step 1:	draw back buffer to front buffer in old position 
		IntersectRect( &rcSrc, &rcDest1, &m_rcRange );
		ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
		DD_BltSurface( ptDest, DD_GetFrontBuffer(), &rcSrc, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );
		// step 2:	draw cursor to front buffer in new position
		IntersectRect( &rcSrc, &rcDest2, &m_rcRange );
		ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
		rcSrcFile.left -= rcDest2.left - rcSrc.left;
		rcSrcFile.top -= rcDest2.top - rcSrc.top;
		rcSrcFile.right -= rcDest2.right - rcSrc.right ;
		rcSrcFile.bottom -= rcDest2.bottom - rcSrc.bottom;
		BltToFront( ptDest, &rcSrcFile );
	}

	// set last state and last frame
	m_nStateLast = m_nState, m_nFrameLast = m_nFrame;
	return TRUE;
}

// ӦóڲʱӦʹô˺
// erase cursor to front surface, doesn't change frame
// return value	:	TRUE for has erased
BOOL CDDCursor::Erase()
{
	Assert( m_bCreatedC == TRUE );
	if( !m_bShow	)	return FALSE;

	POINT ptPosOld;
	RECT rcDest1, rcDest2;
	RECT rcSrcFile;

	ptPosOld.x = m_ptPos.x;
	ptPosOld.y = m_ptPos.y;

	// get old destination rectangle
	rcDest1 = GetRect();

	// get current cursor position
	GetCursorPos( &m_ptPos );

	// get current destination rectangle
	rcDest2 = GetRect();

	// get source rectangle of the bitmap file
	rcSrcFile.left = m_nFrame*m_szSize.cx;
	rcSrcFile.top = m_nState*m_szSize.cy;
	rcSrcFile.right = rcSrcFile.left + m_szSize.cx;
	rcSrcFile.bottom = rcSrcFile.top + m_szSize.cy;

	// calculate if the two rectangles cross
	POINT ptDest;	// destination position
	RECT rcSrc;		// source rectangle

	// if they cross
	if( IntersectRect( &rcSrc, &rcDest1, &rcDest2 ) )
	{	// draw it together
		RECT rcSrcUni;	// intersection of the two rectangles
		UnionRect( &rcSrcUni, &rcDest1, &rcDest2 );
		// step 1:	draw back buffer to mix buffer
		IntersectRect( &rcSrc, &rcSrcUni, &m_rcRange );
		ptDest.x = rcSrc.left - rcSrcUni.left;
		ptDest.y = rcSrc.top - rcSrcUni.top;
		m_lpMixBuffer->BltSurface( ptDest.x, ptDest.y, DD_GetBackBuffer(), &rcSrc, DDBLTFAST_NOCOLORKEY );
		// step 2:	draw cursor to mix buffer in new position
//		ptDest.x = rcDest2.left - rcSrcUni.left;
//		ptDest.y = rcDest2.top - rcSrcUni.top;
//		m_lpMixBuffer->BltSurface( ptDest.x, ptDest.y, GetSurface(), &rcSrcFile, GetDrawFlag() );
		// step 3:	draw mix buffer to front buffer
		IntersectRect( &rcSrc, &rcSrcUni, &m_rcRange );
		ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
		rcSrc.left -= rcSrcUni.left, rcSrc.top -= rcSrcUni.top;
		rcSrc.right -= rcSrcUni.left;
		rcSrc.bottom -= rcSrcUni.top;
		m_lpMixBuffer->BltToFront( ptDest, &rcSrc );
	}
	else
	{	// draw it seperatly
		// step 1:	draw back buffer to front buffer in old position 
		IntersectRect( &rcSrc, &rcDest1, &m_rcRange );
		ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
		DD_BltSurface( ptDest, DD_GetFrontBuffer(), &rcSrc, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );
		// step 2:	draw cursor to front buffer in new position
//		IntersectRect( &rcSrc, &rcDest2, &m_rcRange );
//		ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
//		rcSrcFile.left -= rcDest2.left - rcSrc.left;
//		rcSrcFile.top -= rcDest2.top - rcSrc.top;
//		rcSrcFile.right -= rcDest2.right - rcSrc.right ;
//		rcSrcFile.bottom -= rcDest2.bottom - rcSrc.bottom;
//		BltToFront( ptDest, &rcSrcFile );
	}

	// set last state and last frame
//	m_nStateLast = m_nState, m_nFrameLast = m_nFrame;
	return TRUE;
}

SIZE CURSOR_szSave;
// ʾڱϣBackBuffer,ʹ
// ѱ汣m_lpMixBuffer
// draw corsor to back buffer
// stores back ground to m_lpMixBuffer
// prcCut		:	ֻʾڴ˾ڣif NULL򲻲
// return value	:	TRUE for has drew
BOOL CDDCursor::Draw2Back( CONST RECT *prcCut/* = NULL*/ )
{
	RECT rcDestOld = GetRect();
	RECT rcDest;
	RECT rcSrc;
	POINT ptDest;
	if( IntersectRect( &rcDest, &rcDestOld, prcCut ) )
	{
		// calc offset
		POINT ptTLOff, ptRBOff;
		ptTLOff.x = rcDestOld.left - rcDest.left;
		ptTLOff.y = rcDestOld.top - rcDest.top;
		ptRBOff.x = rcDestOld.right - rcDest.right;
		ptRBOff.y = rcDestOld.bottom - rcDest.bottom;
		
		// get source rectangle of the bitmap file
		rcSrc.left = m_nFrame*m_szSize.cx;
		rcSrc.top = m_nState*m_szSize.cy;
		rcSrc.right = rcSrc.left + m_szSize.cx - ptRBOff.x;
		rcSrc.bottom = rcSrc.top + m_szSize.cy - ptRBOff.y;
		rcSrc.left -= ptTLOff.x;
		rcSrc.top -= ptTLOff.y;

		// for backup back buffer to mix buffer
		ptDest.x = ptDest.y = 0;
		CURSOR_szSave.cx = rcDest.right - rcDest.left;	// save backup size
		CURSOR_szSave.cy = rcDest.bottom - rcDest.top;
		// rcDest as rcSrc
		DD_BltSurface( ptDest, m_lpMixBuffer->GetSurface(), &rcDest, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );

		// draw cursor to back buffer
		ptDest.x = rcDest.left, ptDest.y = rcDest.top;
		BltToBack( ptDest, &rcSrc );
	}
	return TRUE;
}

// ѱı棨m_lpMixBufferУŻر
// restores from m_lpMixBuffer to back buffer
// prcCut		:	ֻʾڴ˾ڣif NULL򲻲
// return value	:	TRUE for has drew
BOOL CDDCursor::Restore2Back( CONST RECT *prcCut/* = NULL*/ )
{
	RECT rcDestOld = GetRect();
	RECT rcDest;
	RECT rcSrc;
	if( IntersectRect( &rcDest, &rcDestOld, prcCut ) )
	{
		// get source rectangle of the bitmap file
		rcSrc.left = rcSrc.top = 0;
		rcSrc.right = CURSOR_szSave.cx;
		rcSrc.bottom = CURSOR_szSave.cy;

		POINT ptDest;
		ptDest.x = rcDest.left, ptDest.y = rcDest.top;
		m_lpMixBuffer->BltToBack( ptDest, &rcSrc );
	}
	return TRUE;
}


#ifdef	_CURSOR_OLD_VERSION_
// when draw sprite should draw cursor on it
// used only in DDCompo.cpp, do not use outside
// pRect1, pRect2	:	the new and old positoin of the sprite
// return value		:	if one rectangle is NULL, or did not draw, return FALSE
// Warning	:	A bug report here
//				Draw cursor on any sprite even if cursor is out of range
BOOL CDDCursor::drawSprite( CONST RECT *pRect1, CONST RECT *pRect2 )
{
	Assert( m_bCreatedC );

	// get cursor rectangle in screen
	RECT rcCursor = GetRect();

	// get source rectangle of the bitmap file
	RECT rcSrcFile;
	rcSrcFile.left = m_nFrame*m_szSize.cx;
	rcSrcFile.top = m_nState*m_szSize.cy;
	rcSrcFile.right = rcSrcFile.left + m_szSize.cx;
	rcSrcFile.bottom = rcSrcFile.top + m_szSize.cy;

	// get old destination rectangle
	RECT rcDest1;
	rcDest1.left = pRect1->left;
	rcDest1.top = pRect1->top;
	rcDest1.right = pRect1->right;
	rcDest1.bottom = pRect1->bottom;

	// get current destination rectangle
	RECT rcDest2;
	rcDest2.left = pRect2->left; 
	rcDest2.top = pRect2->top;
	rcDest2.right = pRect2->right;
	rcDest2.bottom = pRect2->bottom;

	// calculate if the two rectangles cross
	POINT ptDest;	// destination position
	RECT rcSrc;		// source rectangle

	// if they cross
	if( IntersectRect( &rcSrc, &rcDest1, &rcDest2 ) )
	{	// draw it together
		RECT rcSrcUni;	// intersection of the two rectangles
		UnionRect( &rcSrcUni, &rcDest1, &rcDest2 );
		// step 1:	draw back buffer to Sprite buffer
		if( !IntersectRect( &rcSrc, &rcSrcUni, &DDC_rcSpriteRange ) )
			return FALSE;
		ptDest.x = rcSrc.left - rcSrcUni.left;
		ptDest.y = rcSrc.top - rcSrcUni.top;
		m_lpSpriteBuffer->BltSurface( ptDest.x, ptDest.y, DD_GetBackBuffer(), &rcSrc, DDBLTFAST_NOCOLORKEY );
		// step 2:	draw cursor to Sprite buffer in new position
		IntersectRect( &rcSrc, &rcCursor, &rcSrcUni );
		ptDest.x = rcSrc.left - rcSrcUni.left;
		ptDest.y = rcSrc.top - rcSrcUni.top;

		rcSrc.left = rcSrcFile.left + rcSrc.left - rcCursor.left;
		rcSrc.top = rcSrcFile.top + rcSrc.top - rcCursor.top;
		rcSrc.right = rcSrcFile.right + rcSrc.right - rcCursor.right ;
		rcSrc.bottom = rcSrcFile.bottom + rcSrc.bottom - rcCursor.bottom;

		m_lpSpriteBuffer->BltSurface( ptDest.x, ptDest.y, GetSurface(), &rcSrc, GetDrawFlag() );
		// step 3:	draw Sprite buffer to front buffer
		if( !IntersectRect( &rcSrc, &rcSrcUni, &DDC_rcSpriteRange ) )
			return FALSE;
		ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
		rcSrc.left -= rcSrcUni.left, rcSrc.top -= rcSrcUni.top;
		rcSrc.right -= rcSrcUni.left;
		rcSrc.bottom -= rcSrcUni.top;
		m_lpSpriteBuffer->BltToFront( ptDest, &rcSrc );
	}
	else	// not fully tested
	{	// draw it seperatly
		// step 1:	draw back buffer to front buffer in old position 
		if( !IntersectRect( &rcSrc, &rcDest1, &DDC_rcSpriteRange ) )
			return FALSE;
		ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
		DD_BltSurface( ptDest, DD_GetFrontBuffer(), &rcSrc, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );
		// step 2:	draw back buffer to front buffer in new position
		if( !IntersectRect( &rcSrc, &rcDest2, &DDC_rcSpriteRange ) )
			return FALSE;
		ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
		DD_BltSurface( ptDest, DD_GetFrontBuffer(), &rcSrc, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );
		Assert( DDC_pCursor != NULL );
		DDC_pCursor->Draw( TRUE );
	}
	return TRUE;
}// end of drawSprite()
#endif	// _CURSOR_OLD_VERSION_
//////////////////////////////


// global functions for cursor
//////////////////////////////
// set the cursor as the current cursor
// pCursor	:	cursor pointer to be set, set to NULL if you don't need cursor at all
// return	:	TRUE if the cursor is not null now
BOOL CURSOR_Set( class CDDCursor *pCursor )
{
	//if( pCursor == NULL ) return FALSE;
	if( DDC_pCursor != NULL )
	{
		DDC_pCursor->Erase();
		DDC_pCursor->SetState(0);
	}
	DDC_pCursor = pCursor;
	return TRUE;
}

// get the current cursor
inline class CDDCursor *CURSOR_Get()
{
	return DDC_pCursor;
}

// animate cursor, should be called each cycle
inline void CURSOR_Animate()
{
	if( DDC_pCursor != NULL )
		DDC_pCursor->Animate();
}
//////////////////////////////
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
// display functions
//////////////////////////////
#ifdef	_CURSOR_OLD_VERSION_
// set sprite moving range
// rcRange		:	range for sprites to move
// return value	:	old range for sprites to move
RECT DDC_SetSpriteRange( RECT rcRange )
{
	RECT rcRangeOld;
	rcRangeOld.left = DDC_rcSpriteRange.left,
	rcRangeOld.top = DDC_rcSpriteRange.top,
	rcRangeOld.right = DDC_rcSpriteRange.right,
	rcRangeOld.bottom = DDC_rcSpriteRange.bottom;

	DDC_rcSpriteRange.left = rcRange.left,
	DDC_rcSpriteRange.top = rcRange.top,
	DDC_rcSpriteRange.right = rcRange.right,
	DDC_rcSpriteRange.bottom = rcRange.bottom;
	
	return rcRangeOld;
} // DDC_SetSpriteRange()
#endif	// _CURSOR_OLD_VERSION_

#ifdef	_CURSOR_OLD_VERSION_
// ӦóڸspritesӦõô˺DD_UpdateScreen()
// this function will redraw cursor automatically
// һΪspriteھλϵľκλϵľ
// update two rectangles from back buffer to front buffer
// if the two rectangles cross, it will combine it to a large rectangle,
// else	update two rectangles seperatly
// pRect1, pRect2	:	the two rectangles
// return value		:	if one is NULL, or do not draw, return FALSE
BOOL DDC_UpdateSprite( CONST RECT *pRect1, CONST RECT *pRect2 )
{
	// update whole screen from back buffer to front buffer
	if( pRect1 == NULL || pRect2 == NULL )
		return FALSE;

	// calculate if the two rectangles cross
	POINT ptDest;	// destination position
	RECT rcSrc;		// source rectangle

	// update cursor if need
	Assert( DDC_pCursor != NULL );
	RECT rcCursor = DDC_pCursor->GetRect();
	RECT rcDest;

	if( IntersectRect( &rcDest, pRect1, &rcCursor) ||
		IntersectRect( &rcDest, pRect2, &rcCursor) )
	{
		// should draw cursor on it
		return DDC_pCursor->drawSprite( pRect1, pRect2 );
	}
	else
	{
		// need not to draw cursor on it
		// if they cross
		if( IntersectRect( &rcSrc, pRect1, pRect2 ) )
		{	// draw it together
			RECT rcSrcUni;	// intersection of the two rectangles
			UnionRect( &rcSrcUni, pRect1, pRect2 );
			// step 1:	draw back buffer to front buffer
			if( !IntersectRect( &rcSrc, &rcSrcUni, &DDC_rcSpriteRange ) )
				return FALSE;
			ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
			DD_BltSurface( ptDest, DD_GetFrontBuffer(), &rcSrc, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );
		}
		else
		{	// draw it seperatly
			// step 1:	draw back buffer to front buffer in old position 
			if( !IntersectRect( &rcSrc, pRect1, &DDC_rcSpriteRange ) )
				return FALSE;
			ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
			DD_BltSurface( ptDest, DD_GetFrontBuffer(), &rcSrc, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );
			// step 2:	draw cursor to front buffer in new position
			if( !IntersectRect( &rcSrc, pRect2, &DDC_rcSpriteRange ) )
				return FALSE;
			ptDest.x = rcSrc.left, ptDest.y = rcSrc.top;
			DD_BltSurface( ptDest, DD_GetFrontBuffer(), &rcSrc, DD_GetBackBuffer(), DDBLTFAST_NOCOLORKEY );
		}
	}

	return TRUE;
} // DDC_UpdateSprite()
#endif	// _CURSOR_OLD_VERSION_

// when need update, should use this functions instead of DD_UpdateScreen() in DDAPI.h
// update only one rectangle of back buffer to front buffer
// pRect	:	rectangle to be update
void DDC_UpdateScreen( RECT *pRect/*=NULL*/ )
{
	if( DDC_pCursor != NULL )
		DDC_pCursor->Draw2Back( pRect );
	DD_UpdateScreen( pRect );
	if( DDC_pCursor != NULL )
		DDC_pCursor->Restore2Back( pRect );
}	// DDC_UpdateScreen()

#ifdef	_CURSOR_OLD_VERSION_
// set max size of sprites
// in order to take effect, you must call this function before CDDCursor::Load()
// szMax		:	max size of sprites
// return value	:	old max size of sprites
SIZE DDC_SetSpriteMaxSize( SIZE szMax )
{
	SIZE szMaxOld;
	szMaxOld.cx = DDC_szSpriteMax.cx;
	szMaxOld.cy = DDC_szSpriteMax.cy;
	DDC_szSpriteMax.cx = szMax.cx;
	DDC_szSpriteMax.cy = szMax.cy;
	return szMaxOld;
} // DDC_SetSpriteMaxSize()
#endif	// _CURSOR_OLD_VERSION_
//////////////////////////////

// sub-draw functions
//////////////////////////////
// draw rectangle on screen, by using DC
// pRect		:	rectangle to draw
// color		:	color to draw
// bFront		:	TRUE for draw it on front buffer
// return value	:	TRUE if succeeded
BOOL DDC_FrameRect( CONST RECT *pRect, COLORREF color, BOOL bFront/*=FALSE*/ )
{
	HDC hdc; 
	LPDIRECTDRAWSURFACE2 lpDDS=NULL;
	if( bFront )	lpDDS = DD_GetFrontBuffer();
	else			lpDDS = DD_GetBackBuffer();
	if( lpDDS->GetDC(&hdc) != DD_OK )
		return FALSE;

	HBRUSH hbr = CreateSolidBrush( color );
	FrameRect( hdc, pRect, hbr );
	DeleteObject( HBRUSH(hbr) );

	lpDDS->ReleaseDC( hdc );
	return TRUE;
}

// draw rectangle on one surface, by using DC
// pRect		:	rectangle to draw
// color		:	color to draw
// bFront		:	TRUE for draw it on front buffer
// return value	:	TRUE if succeeded
BOOL DDC_FrameRect( LPDIRECTDRAWSURFACE2 lpDDS, CONST RECT *pRect, COLORREF color )
{
	HDC hdc; 
	if( lpDDS->GetDC(&hdc) != DD_OK )
		return FALSE;

	HBRUSH hbr = CreateSolidBrush( color );
	FrameRect( hdc, pRect, hbr );
	DeleteObject( HBRUSH(hbr) );

	lpDDS->ReleaseDC( hdc );
	return TRUE;
}
//////////////////////////////
