////////////
//mciapi.cpp	:	v0020
//writen by		:	Liu Gang(0020), Xie Shen(v0010)
//complier		:	Microsoft Visual C++ 4.2
//Library		:	winmm.lib
//v0010			:	Sep.12.1995
//v0020			:	Feb.9.1997
//v0021			:	Aug.14.1997, changed some convensions
////////////
// implementation file

// this file contains the functions to play avi, midi wav file
// need multimeida library when link

#include "stdafx.h"			// standard includings
#include "assert.h"			// debug functions, error message functions
#include "mciapi.h"

BOOL MCI_bEnableAVI = TRUE;
BOOL MCI_bEnableMIDI = TRUE;
BOOL MCI_bEnableWAV = TRUE;
BOOL MCI_bEnableCDAUDIO = TRUE;

////////////
//AVI Animation functions
////////////
// open avi file
// hwnd		:	window for avi file to play on and receive error message
// filename	:	avi file name, must with full path and extension
// lpRect	:	display rectangle on desination window
//				if NULL, display it with its origional size 
//					and the topleft on destination window is (0,0)
//				if right and bottom is 0, the functions will use 
//					left and top as topleft position on destinaiton window
//				ΪգĿĴڵϽǰԭСAVI
//				rightbottom0lefttopΪϽԭСAVI
// return	:	-1 if failed, others to be the handle of avi file
//				ʧ򷵻-1򷵻aviļľ
int MCI_AVI_Open(HWND hwnd,LPSTR filename,CONST RECT *lpRect/*=NULL*/)
{
	if (!MCI_bEnableAVI) return -1;

	DWORD retrn;
	char b[MCI_STRINGSIZE];
	int videoID;

	//Open avi
	MCI_OPEN_PARMS mciopen;
	mciopen.lpstrDeviceType="avivideo";
	mciopen.lpstrElementName=filename;
	if((retrn=mciSendCommand(0,MCI_OPEN,MCI_WAIT|MCI_OPEN_TYPE|MCI_OPEN_ELEMENT,(DWORD)(LPVOID)&mciopen))!=0L)
	{
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+2, b, filename);
		OutputDebugString( "MCI_OpenAvi Error(2): Cannot open file:" );
		OutputDebugString( filename );
		OutputDebugString( "\n" );
//		MCI_bEnableAVI=FALSE;
		return -1;
	}
	videoID=mciopen.wDeviceID;

	// set avi time format
	MCI_SET_PARMS	mciset;
	mciset.dwCallback=(DWORD)hwnd;
	mciset.dwTimeFormat=MCI_FORMAT_FRAMES;
	if((retrn=mciSendCommand(videoID,MCI_SET,MCI_WAIT|MCI_SET_TIME_FORMAT	,(DWORD)(LPVOID)&mciset))!=0L)	{
		mciSendCommand(videoID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,128);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+3, b, filename);
		OutputDebugString( "MCI_OpenAvi Error(3): Set time format error:" );
		OutputDebugString( filename );
		OutputDebugString( "\n" );
		MCI_bEnableAVI=FALSE;
		return FALSE;
	}

	//Set position and size on destination window
	if( lpRect == NULL ) return videoID;
	// get display rectangle on destination window
	MCI_DGV_RECT_PARMS	dgvRect;
	dgvRect.dwCallback=(DWORD)hwnd;
	if( lpRect->right == 0 && lpRect->bottom == 0 )
	{
		if((retrn=mciSendCommand(videoID,MCI_WHERE,
			MCI_WAIT|MCI_DGV_WHERE_DESTINATION,(DWORD)(LPVOID)&dgvRect))!=0L)
		{
			mciSendCommand(videoID,MCI_CLOSE,0,NULL);
			mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
			ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+9, b, filename);
			OutputDebugString( "MCI_OpenAvi Error(9): GetWave information error!" );
			OutputDebugString( filename );
			OutputDebugString( "\n" );
			MCI_bEnableAVI=FALSE;
			return -1;
		}
	}
	else
	{
		dgvRect.rc.right = lpRect->right - lpRect->left;
		dgvRect.rc.bottom = lpRect->bottom - lpRect->top;
	}
	dgvRect.rc.left = lpRect->left;
	dgvRect.rc.top = lpRect->top;

	// set rectangle
	if((retrn=mciSendCommand(videoID,MCI_PUT,
		MCI_WAIT|MCI_DGV_RECT|MCI_DGV_PUT_DESTINATION,(DWORD)(LPVOID)&dgvRect))!=0L)
	{
		mciSendCommand(videoID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+5, b, filename);
		OutputDebugString( "MCI_OpenAvi Error(5): Set position error:" );
		OutputDebugString( filename );
		OutputDebugString( "\n" );
		MCI_bEnableAVI=FALSE;
		return -1;
	}

  	//Set window
	MCI_DGV_WINDOW_PARMS mwindow;
	mwindow.dwCallback=(DWORD)hwnd;
	mwindow.hWnd=hwnd;
	if((retrn=mciSendCommand(videoID,MCI_WINDOW,MCI_WAIT|MCI_ANIM_WINDOW_HWND,(DWORD)(LPVOID)&mwindow))!=0L)
	{
		mciSendCommand(videoID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit( hwnd, MCI_ERROR_ID+4, b, filename);
		OutputDebugString( "MCI_OpenAvi Error(4): Set window error:" );
		OutputDebugString( filename );
		OutputDebugString( "\n" );
		MCI_bEnableAVI=FALSE;
		return -1;
	}

	return videoID;
}

// play avi file
// hwnd		:	window for avi file to play on and receive error message
// videoID	:	handle of avi object that previously opened, if it is -1, do nothing
// dwCommand:	command for play, usually be MCI_WAIT, MCI_NOTIFY, and/or MCI_MCIAVI_PLAY_FULLSCREEN
//				when using MCI_WAIT, the function will not returned until end playing.
//				when using MCI_NOTIFY, the function returned at once, when finished playing the 
//              object will send a MM_MCINOTIFY message to the window,
//				you can close it on receiving this message
//				
//				ʹMCI_WAITʱҪAVIܷ
//				ʹMCI_NOTIFYʱϷأʱᷢһϢMM_MCINOTIFY
//				ӦϢʱԹرոļ
// dwFrom	:	frame number to be played from
// dwTo		:	frame number to be played to, if both zero, play it from beginning to end.
// return	:	TRUE if played
BOOL MCI_AVI_Play(HWND hwnd,int videoID,DWORD dwCommand, DWORD dwFrom/*=0*/, DWORD dwTo/*=0*/)	
{
	if (!MCI_bEnableAVI) return FALSE;
	if (videoID==-1) return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//Play avi
	MCI_DGV_PLAY_PARMS mciplay;
 	mciplay.dwCallback=(DWORD)hwnd;
	if(dwFrom!=0)	{mciplay.dwFrom=dwFrom;dwCommand|=MCI_FROM;}
	if(dwTo!=0)		{mciplay.dwTo=dwTo;dwCommand|=MCI_TO;}
	if((retrn=mciSendCommand(videoID,MCI_PLAY,
		dwCommand,(DWORD)(LPMCI_DGV_PLAY_PARMS)&mciplay))!=0L)
	{
		mciSendCommand(videoID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+6, b);
		OutputDebugString( "MCI_PlayAvi Error(6): Cannot play avi!\n" );
//		MCI_bEnableAVI=FALSE;
		return FALSE;
	}
	return TRUE;
}

// seek in avi file
// hwnd		:	window for avi file to play on and receive error message
// videoID	:	handle of avi object that previously opened, if it is -1, do nothing
// dwCommand:	command for seek, usually be MCI_WAIT, MCI_SEEK_TO_START
// return	:	TRUE if seeked
BOOL MCI_AVI_Seek(HWND hwnd,int videoID,DWORD dwCommand,DWORD dwTo/*=0*/)
{
	if (!MCI_bEnableAVI) return FALSE;
	if (videoID==-1) return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//seek avi
	MCI_SEEK_PARMS mciseek;
 	mciseek.dwCallback=(DWORD)hwnd;
	mciseek.dwTo=dwTo;
	if((retrn=mciSendCommand(videoID,MCI_SEEK,dwCommand,(DWORD)(LPVOID)&mciseek))!=0L)
	{
		mciSendCommand(videoID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+7, b);
		OutputDebugString( "MCI_SeekAvi Error(7): Seek avi error!\n" );
		MCI_bEnableAVI=FALSE;
		return FALSE;
	}
	return TRUE;
}

// stop avi file
// hwnd		:	window for avi file to play on and receive error message
// videoID	:	handle of avi object that previously opened, if it is -1, do nothing
// return	:	TRUE if stoped the avi
BOOL MCI_AVI_Stop(HWND hwnd,int videoID)	
{
	if (!MCI_bEnableAVI) return FALSE;
	if (videoID==-1) return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//Stop avi
	MCI_GENERIC_PARMS mcigen;
	mcigen.dwCallback=(DWORD)hwnd;
	if((retrn=mciSendCommand(videoID,MCI_STOP,MCI_WAIT,(DWORD)(LPVOID)&mcigen))!=0L)
	{
		mciSendCommand(videoID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+8, b);
		OutputDebugString( "MCI_StopAvi Error(8): Stop avi error!\n" );
		MCI_bEnableAVI=FALSE;
		return FALSE;
	}
	return TRUE;
}

// pause avi file
// hwnd		:	window for avi file to play on and receive error message
// videoID	:	handle of avi object that previously opened, if it is -1, do nothing
// return	:	TRUE if stoped the avi
BOOL MCI_AVI_Pause(HWND hwnd,int videoID)	
{
	if (!MCI_bEnableAVI) return FALSE;
 
	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//Stop avi
	MCI_GENERIC_PARMS mcigen;
	mcigen.dwCallback=(DWORD)hwnd;
	if((retrn=mciSendCommand(videoID,MCI_PAUSE,MCI_WAIT,(DWORD)(LPVOID)&mcigen))!=0L)
	{
		mciSendCommand(videoID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+8, b);
		OutputDebugString( "MCI_PauseAvi Error(15): Pause avi error!\n" );
		MCI_bEnableAVI=FALSE;
		return FALSE;
	}
	return TRUE;
}

// close avi file
// videoID	:	handle of avi object that previously opened, if it is -1, do nothing
// return	:	TRUE if closed the file
BOOL MCI_AVI_Close(int videoID)	
{

	if (!MCI_bEnableAVI) return FALSE;
	if (videoID==-1) return FALSE;
	//Close avi
	mciSendCommand(videoID,MCI_CLOSE,MCI_WAIT,NULL);
	return TRUE;
}
////////////

////////////
// MIDI music functions
////////////
// open midi file
// hwnd		:	window for midi file to play on and receive error message
// filename	:	midi file name, must with full path and extension
// return	:	-1 if failed, others to be the handle of midi file
//				ʧ򷵻-1򷵻midiļľ
int MCI_MIDI_Open(HWND hwnd,LPSTR filename)
{
	if( !MCI_bEnableMIDI ) return -1;

	char b[MCI_STRINGSIZE];
	DWORD retrn;	
	int midiID=-1;

	// open midi
	MCI_DGV_OPEN_PARMS mciOpen;
	mciOpen.wDeviceID=NULL;
	mciOpen.lpstrDeviceType="sequencer";
	mciOpen.lpstrElementName=filename;
	if((retrn=mciSendCommand(0,MCI_OPEN,MCI_OPEN_TYPE|MCI_OPEN_ELEMENT,(DWORD)(LPVOID)&mciOpen))!=0L)
	{
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+10, b, filename);
		OutputDebugString( "MCI_OpenMIDI Error(10): Cannot open file:" );
		OutputDebugString( filename );
		OutputDebugString( "\n" );
		MCI_bEnableMIDI = FALSE;
		return -1;
	}
	midiID=mciOpen.wDeviceID;
	return midiID;
}

// play midi file
// hwnd		:	window for midi file to play on and receive error message
// midiID	:	handle of midi object that previously opened, if it is -1, do nothing
// dwCommand:	command for play, usually be MCI_WAIT, MCI_NOTIFY
//				when using MCI_WAIT, the function will not returned until end playing.
//				when using MCI_NOTIFY, the function returned at once, when finished playing the 
//              object will send a MM_MCINOTIFY message to the window,
//				you can close it on receiving this message
//				ʹMM_WAITʱҪMIDIܷ
//				ʹMM_NOTIFYʱϷأʱᷢһϢMM_MCINOTIFY
//				ӦϢʱԹرոļ
//				ע⣬ʹMCI_MIDI_Stop()ֹʱҲᷢϢ
// return	:	TRUE if played the file
BOOL MCI_MIDI_Play(HWND hwnd,int midiID,DWORD dwCommand)
{
	if( !MCI_bEnableMIDI ) return FALSE;
	if( midiID == -1 )	return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//Play midi
	MCI_PLAY_PARMS mciplay;
 	mciplay.dwCallback=(DWORD)hwnd;
	if((retrn=mciSendCommand(midiID,MCI_PLAY,dwCommand,(DWORD)(LPVOID)&mciplay))!=0L)
	{
		mciSendCommand(midiID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+11, b);
		OutputDebugString( "MCI_PlayMIDI Error(11):	cannot play midi!\n" );
		MCI_bEnableMIDI = FALSE;
		return FALSE;
	}
	return TRUE;
}

// seek midi file, not done yet
// hwnd		:	window for midi file to play on and receive error message
// midiID	:	handle of midi object that previously opened, if it is -1, do nothing
// dwCommand:	command for seek, usually be MCI_WAIT, MCI_SEEK_TO_START
// return	:	TRUE if seeked the file
BOOL MCI_MIDI_Seek(HWND hwnd,int midiID,DWORD dwCommand)
{
	if( !MCI_bEnableMIDI ) return FALSE;
	
	return FALSE;
}

// stop midi file
// hwnd		:	window for midi file to play on and receive error message
// midiID	:	handle of midi object that previously opened, if it is -1, do nothing
// return	:	TRUE if stoped the file
BOOL MCI_MIDI_Stop(HWND hwnd,int midiID)
{
	if( !MCI_bEnableMIDI ) return FALSE;
	if( midiID == -1 )	return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//Stop midi
	MCI_GENERIC_PARMS mcigen;
	mcigen.dwCallback=(DWORD)hwnd;
	if((retrn=mciSendCommand(midiID,MCI_STOP,MCI_WAIT,(DWORD)(LPVOID)&mcigen))!=0L)
	{
		mciSendCommand(midiID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+12, b);
		OutputDebugString( "MCI_StopMIDI Error(12): Cannot stop midi or cannot find midi!\n" );
		MCI_bEnableMIDI = FALSE;
		return FALSE;
	}
	return TRUE;
}

// close midi file
// midiID	:	handle of midi object that previously opened, if it is -1, do nothing
// return	:	TRUE if closed the file
BOOL MCI_MIDI_Close(int midiID)
{
	if( !MCI_bEnableMIDI ) return FALSE;
	if( midiID == -1 )	return FALSE;

	// close midi
	mciSendCommand(midiID,MCI_CLOSE,MCI_WAIT,NULL);
	return TRUE;
}
////////////

////////////
// WAV music functions
////////////
// open wave file
// hwnd		:	window for wave file to play on and receive error message
// filename	:	wave file name, must with full path and extension
// return	:	-1 if failed, others to be the handle of wav file
//				ʧ򷵻-1򷵻waveļľ
int MCI_WAV_Open(HWND hwnd,LPSTR filename)
{
	if (!MCI_bEnableWAV) return -1;

	char b[MCI_STRINGSIZE];
	DWORD retrn;	
	int waveID;

	// open wave
	MCI_OPEN_PARMS mciOpen;
	mciOpen.wDeviceID=NULL;
	mciOpen.lpstrDeviceType="waveaudio";
	mciOpen.lpstrElementName=filename;
	if((retrn=mciSendCommand(0,MCI_OPEN,MCI_OPEN_TYPE|MCI_OPEN_ELEMENT,(DWORD)(LPVOID)&mciOpen))!=0L)
	{
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit( hwnd, MCI_ERROR_ID+20, b, filename);
		OutputDebugString( "MCI_OpenWav Error(20): Cannot open wave file: " );
		OutputDebugString( filename );
		OutputDebugString( "\n" );
		MCI_bEnableWAV=FALSE;
		return -1;
	}
	waveID=mciOpen.wDeviceID;
	return waveID;
}

// play wave file
// hwnd		:	window for wave file to play on and receive error message
// waveID	:	handle of wave object that previously opened, if it is -1, do nothing
// dwCommand:	command for play, usually be MCI_WAIT, MCI_NOTIFY
//				when using MCI_WAIT, the function will not returned until end playing.
//				when using MCI_NOTIFY, the function returned at once, when finished playing the 
//              object will send a MM_MCINOTIFY message to the window,
//				you can close it on receiving this message
//				ʹMM_WAITʱҪWAVܷ
//				ʹMM_NOTIFYʱϷأʱᷢһϢMM_MCINOTIFY
//				ӦϢʱԹرոļ
//				ע⣬ʹMCI_WAV_Stop()ֹʱҲᷢϢ
// return	:	TRUE if played the file
BOOL MCI_WAV_Play(HWND hwnd,int waveID,DWORD dwCommand)
{
	if (!MCI_bEnableWAV) return FALSE;
	if (waveID==-1) return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//Play wave
	MCI_PLAY_PARMS mciplay;
 	mciplay.dwCallback=(DWORD)hwnd;
	if((retrn=mciSendCommand(waveID,MCI_PLAY,dwCommand,(DWORD)(LPVOID)&mciplay))!=0L)	{
		mciSendCommand(waveID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit( hwnd, MCI_ERROR_ID+21, b);
		OutputDebugString( "MCI_PlayWav Error(21): cannot play wave!\n" );
		MCI_bEnableWAV=FALSE;
		return FALSE;
	}
	return TRUE;
}

// seek wave file
// hwnd		:	window for wave file to play on and receive error message
// waveID	:	handle of wave object that previously opened, if it is -1, do nothing
// dwCommand:	command for seek, usually be MCI_WAIT, MCI_SEEK_TO_START
// return	:	TRUE if seeked the file
BOOL MCI_WAV_Seek(HWND hwnd,int waveID,DWORD dwCommand)
{
	if (!MCI_bEnableWAV) return FALSE;
	if (waveID==-1) return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//seek wav
	MCI_SEEK_PARMS mciseek;
 	mciseek.dwCallback=(DWORD)hwnd;
	if((retrn=mciSendCommand(waveID,MCI_SEEK,dwCommand,(DWORD)(LPVOID)&mciseek))!=0L)	{
		mciSendCommand(waveID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+22, b);
		OutputDebugString( "MCI_SeekWav Error(22):	Cannot send seek command!\n" );
		MCI_bEnableWAV=FALSE;
		return FALSE;
	}
	return TRUE;
}

// stop wave file
// hwnd		:	window for wave file to play on and receive error message
// waveID	:	handle of wave object that previously opened, if it is -1, do nothing
// return	:	TRUE if stoped the file
BOOL MCI_WAV_Stop(HWND hwnd,int waveID)
{
	if (!MCI_bEnableWAV) return FALSE;
	if (waveID==-1) return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//Stop wave
	MCI_GENERIC_PARMS mcigen;
	mcigen.dwCallback=(DWORD)hwnd;
	if((retrn=mciSendCommand(waveID,MCI_STOP,MCI_WAIT,(DWORD)(LPVOID)&mcigen))!=0L)	{
		mciSendCommand(waveID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+23, b);
		OutputDebugString( "MCI_StopWav Error(23): cannot stop wave!\n" );
		MCI_bEnableWAV=FALSE;
		return FALSE;
	}
	return TRUE;
}

// close wave file
// waveID	:	handle of wave object that previously opened, if it is -1, do nothing
// return	:	TRUE if closed the file
BOOL MCI_WAV_Close(int waveID)
{
	if (!MCI_bEnableWAV) return FALSE;
	if (waveID==-1) return FALSE;

	// close wave
	mciSendCommand(waveID,MCI_CLOSE,MCI_WAIT,NULL);
	return TRUE;
}
////////////

////////////
// open CDAudio by track
// hwnd		:	window for cdaudio file to play on and receive error message
// nTrack	:	Sound Track to play
// return	:	-1 if failed, others to be the handle of cdaudio file
//				ʧ򷵻-1򷵻cdaudioļľ
int MCI_CDAUDIO_Open(HWND hwnd)
{
	if (!MCI_bEnableCDAUDIO) return -1;

	char b[MCI_STRINGSIZE];
	DWORD retrn;	
	int cdaudioID;

	// open cdaudio
	MCI_OPEN_PARMS mciOpen;
	mciOpen.wDeviceID=NULL;
	mciOpen.lpstrDeviceType="cdaudio";
	//mciOpen.lpstrElementName=filename;
	if((retrn=mciSendCommand(0,MCI_OPEN,MCI_OPEN_TYPE,(DWORD)(LPVOID)&mciOpen))!=0L)
	{
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
//		ErrorMessageNoQuit( hwnd, MCI_ERROR_ID+30, b);
		OutputDebugString( "MCI_OpenCD Error(30): Cannot read CD Audio data!\n" );
//		MCI_bEnableCDAUDIO=FALSE;
		return -1;
	}
	cdaudioID=mciOpen.wDeviceID;

	// set cd audio time format
	MCI_SET_PARMS mciSet;
 	mciSet.dwCallback=(DWORD)hwnd;
	mciSet.dwTimeFormat = MCI_FORMAT_TMSF;
	if((retrn=mciSendCommand(cdaudioID,MCI_SET,MCI_SET_TIME_FORMAT,(DWORD)(LPVOID)&mciSet))!=0L)
	{
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
//		ErrorMessageNoQuit( hwnd, MCI_ERROR_ID+34, b);
		OutputDebugString( "MCI_OpenCD Error(34): Set time format error!\n" );
		MCI_bEnableCDAUDIO=FALSE;
		return -1;
	}

	return cdaudioID;
}

// play cdaudio file
// hwnd		:	window for cdaudio file to play on and receive error message
// cdaudioID	:	handle of cdaudio object that previously opened, if it is -1, do nothing
// dwCommand:	command for play, usually be MCI_WAIT, MCI_NOTIFY
//				when using MCI_WAIT, the function will not returned until end playing.
//				when using MCI_NOTIFY, the function returned at once, when finished playing the 
//              object will send a MM_MCINOTIFY message to the window,
//				you can close it on receiving this message
//				ʹMM_WAITʱҪCDAudioܷ
//				ʹMM_NOTIFYʱϷأʱᷢһϢMM_MCINOTIFY
//				ӦϢʱԹرոļ
//				ע⣬ʹMCI_CDAUDIO_Stop()ֹʱҲᷢϢ
// dwFrom	:	track number to be played from, 1 if the first track
// dwTo		:	track number to be played to, if both zero, play it from beginning to end.
// return	:	TRUE if played the file
BOOL MCI_CDAUDIO_Play(HWND hwnd,int cdaudioID,DWORD dwCommand/*=MCI_NOTIFY*/, DWORD dwFrom/* = 0*/, DWORD dwTo/* = 0*/ )
{
	if (!MCI_bEnableCDAUDIO) return FALSE;
	if (cdaudioID==-1) return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//Play cdaudio
	MCI_PLAY_PARMS mciplay;
 	mciplay.dwCallback=(DWORD)hwnd;
	if(dwFrom!=0)	{mciplay.dwFrom=dwFrom;dwCommand|=MCI_FROM;}
	if(dwTo!=0)		{mciplay.dwTo=dwTo;dwCommand|=MCI_TO;}
	if((retrn=mciSendCommand(cdaudioID,MCI_PLAY,dwCommand,(DWORD)(LPVOID)&mciplay))!=0L)	{
		mciSendCommand(cdaudioID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
//		ErrorMessageNoQuit( hwnd, MCI_ERROR_ID+31, b);
		OutputDebugString( "MCI_PlayCD Error(31): cannot play cd audio!\n" );
//		MCI_bEnableCDAUDIO=FALSE;
		return FALSE;
	}
	return TRUE;
}

// seek cdaudio file
// hwnd		:	window for cdaudio file to play on and receive error message
// cdaudioID	:	handle of cdaudio object that previously opened, if it is -1, do nothing
// dwCommand:	command for seek, usually be MCI_WAIT, MCI_SEEK_TO_START
// nTrack	:	Track number to seek
// return	:	TRUE if seeked the file
BOOL MCI_CDAUDIO_Seek(HWND hwnd,int cdaudioID, int nTrack, DWORD dwCommand/*=MCI_WAIT|MCI_SEEK_TO_START*/)
{
	if (!MCI_bEnableCDAUDIO) return FALSE;
	if (cdaudioID==-1) return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//seek wav
	MCI_SEEK_PARMS mciseek;
 	mciseek.dwCallback=(DWORD)hwnd;
	mciseek.dwTo = nTrack;
	if((retrn=mciSendCommand(cdaudioID,MCI_SEEK,dwCommand,(DWORD)(LPVOID)&mciseek))!=0L)	{
		mciSendCommand(cdaudioID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
//		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+32, b);
		OutputDebugString( "MCI_SeekCD Error(32):	Cannot send seek command!\n" );
		MCI_bEnableCDAUDIO=FALSE;
		return FALSE;
	}
	return TRUE;
}

// stop cdaudio file
// hwnd		:	window for cdaudio file to play on and receive error message
// cdaudioID	:	handle of cdaudio object that previously opened, if it is -1, do nothing
// return	:	TRUE if stoped the file
BOOL MCI_CDAUDIO_Stop(HWND hwnd,int cdaudioID)
{
	if (!MCI_bEnableCDAUDIO) return FALSE;
	if (cdaudioID==-1) return FALSE;

	DWORD retrn;
	char b[MCI_STRINGSIZE];

	//Stop cdaudio
	MCI_GENERIC_PARMS mcigen;
	mcigen.dwCallback=(DWORD)hwnd;
	if((retrn=mciSendCommand(cdaudioID,MCI_STOP,MCI_WAIT,(DWORD)(LPVOID)&mcigen))!=0L)	{
		mciSendCommand(cdaudioID,MCI_CLOSE,0,NULL);
		mciGetErrorString(retrn,(LPSTR)b,MCI_STRINGSIZE-1);
//		ErrorMessageNoQuit(hwnd, MCI_ERROR_ID+33, b);
		OutputDebugString( "MCI_StopCD Error(33): cannot stop cd audio!\n" );
		MCI_bEnableCDAUDIO=FALSE;
		return FALSE;
	}
	return TRUE;
}

// close cdaudio file
// cdaudioID	:	handle of cdaudio object that previously opened, if it is -1, do nothing
// return	:	TRUE if closed the file
BOOL MCI_CDAUDIO_Close(int cdaudioID)
{
	if (!MCI_bEnableCDAUDIO) return FALSE;
	if (cdaudioID==-1) return FALSE;

	// close cdaudio
	mciSendCommand(cdaudioID,MCI_CLOSE,MCI_WAIT,NULL);
	return TRUE;
}
////////////
